<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/

$noheader=true;
require('../config.inc.php');

$GameCP->loadIncludes("cron");
$Cron=new Cron();

if((isset($_SERVER['REQUEST_METHOD']) && !isset($_REQUEST['key'])) || (isset($_REQUEST['key']) && $Cron->CheckKey($_REQUEST['key']) == false)){
    header( "HTTP/1.1 403 Forbidden" );
    die( "<html><body><h1>HTTP 403 - Forbidden</h1></body></html>" );
}

sql_query("UPDATE settings SET value='".time()."' WHERE name='ran_imap';");


if(!imapserver || !imapport || !imapuser || !imappw) exit;


if(debugging == '1') echo "Connecting to ".imapserver." account: ".imapuser."\r\n";

$hostname = '{'.imapserver.':'.imapport.'/imap/'.imapauth.'}INBOX';

$parse=array();
$inbox = imap_open($hostname, imapuser, imappw) or die('Unable to access mail: ' . imap_last_error());
$emails = imap_search($inbox,'UNSEEN');

if($emails) {

	if(debugging == '1') echo "Processing ".count($emails)." new message(s)\r\n";
	rsort($emails);
	foreach($emails as $email_number) {
		$overview = imap_fetch_overview($inbox,$email_number,0);
		$structure = imap_fetchstructure($inbox,$email_number);
		$structure=$structure->parts[0];
		$message=imap_fetchbody($inbox,$email_number,1);

		if ($structure->encoding == ENCQUOTEDPRINTABLE) {
			$message = quoted_printable_decode($message); 
		}elseif($structure->encoding == ENCBASE64) $message = base64_decode($message);
		
		$message=preg_replace("/=(\r?)\n/", '',strip_tags($message));
		$message=preg_replace("/=20(\r?)\n/", '',$message);
		$header = imap_header($inbox, $email_number);

		$header=$header->from;
		$from=$header[0]->mailbox."@".$header[0]->host;
		$subject=$overview[0]->subject;
		$date=$overview[0]->date;

		$parse[]=array($date, $from, $subject, $message);

		if(imapdelete == 'yes'){
			imap_delete($inbox,$email_number,2);
			imap_expunge($inbox);
		}
	}
}  else if(debugging == '1') echo "No messages to process.\r\n";

imap_close($inbox);

$GameCP->loadIncludes("support");
$Support = new Support();
$Support->parseMail($parse);

?>