<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/

session_start();

function MonitorStop($ugid){
	global $Control;

	$Control->Usergame($ugid, "stop");
	$hook_vars=$ugid;
	run_hook("monitor_service_stop");

}
function myErrorHandler($errno, $errstr, $errfile, $errline){
    switch ($errno) {
    case E_USER_ERROR:
        echo "- FATAL ERROR: [$errno] $errstr in $errfile Line: $errline\n";
        break;
	case E_USER_WARNING:
        echo "- WARNING: [$errno] $errstr in $errfile Line: $errline\n";
        break;
    case E_USER_NOTICE:
        echo "- NOTICE: [$errno] $errstr in $errfile Line: $errline\n";
        break;
    default:
      //  echo "- ERROR: [$errno] $errstr in $errfile Line: $errline\n";
        break;
    }
    return true;
}
$handler = set_error_handler("myErrorHandler");

function echo_memory_usage() {
        $mem_usage = memory_get_usage(true);
       
        if ($mem_usage < 1024)
            return $mem_usage." bytes";
        elseif ($mem_usage < 1048576)
            return ($mem_usage/1024)." kilobytes";
        else
            return ($mem_usage/1048576)." megabytes";
           
   } 

$noheader=true;
require('../config.inc.php');


if(isset($_SERVER['argv'][1]) && ($_SERVER['argv'][1] == "--help" || $_SERVER['argv'][1] == "-h")){
	echo "Usage: php -q servermonitor.php <0/1 constant scan>\n";
	echo "All other settings are defined Settings > General\n";
	echo "Remove lock: php servermonitor.php --reset\n\n";
	sql_query("UPDATE settings SET value='' WHERE name='monitorlock';");
	exit;
}


$GameCP->loadIncludes("panel");
$GameCP->loadIncludes("query");
$GameCP->loadIncludes("control");
$GameCP->loadIncludes("cron");
$GameCP->loadIncludes("game");
$GameCP->loadIncludes("email");
$GameCP->loadIncludes("support");
$GameCP->loadIncludes("backend");
require_once($PATH ."/includes/core/editable/rrdtool.inc.php");

$Panel=new Panel();
$Game=new Game();
$Cron=new Cron();
$Support=new Support();
$Query=new Query();
$Control=new Control();
$Backend=new Backend();

$nocheck = "1";
$scanday = date(dateformat." h:i:s A");
$smver="3.0";



if((isset($_SERVER['REQUEST_METHOD']) && !isset($_REQUEST['key'])) || (isset($_REQUEST['key']) && $Cron->CheckKey($_REQUEST['key']) == false)){
    header( "HTTP/1.1 403 Forbidden" );
    die( "<html><body><h1>HTTP 403 - Forbidden</h1></body></html>" );
}

sql_query("UPDATE settings SET value='".time()."' WHERE name='ran_monitor';");


if(isset($_SERVER['argv'][1]) && $_SERVER['argv'][1] == "--version"){
	echo "------------------------------------------------------------\n";
	echo "- Server Monitor Version #$smver\n";
	sql_query("UPDATE settings SET value='' WHERE name='monitorlock';");
	exit;
}

if(isset($_SERVER['argv'][1]) && $_SERVER['argv'][1] == "--reset"){
	echo "------------------------------------------------------------\n";
	echo "- Monitor lock removed\n";
	sql_query("UPDATE settings SET value='' WHERE name='monitorlock';");
	exit;
}

$fetchLockQ = sql_query("SELECT value FROM settings WHERE name='monitorlock' LIMIT 1;") or die(mysql_error());
$fetchLock = mysql_fetch_row($fetchLockQ);

if($fetchLock[0] != "" && (time() - $fetchLock[0]) < '300'){
	echo "------------------------------------------------------------\n";
	echo "- Monitor is locked\n- Remove lock or wait up to 300 seconds.\n- php servermonitor.php --reset\n";
	echo "------------------------------------------------------------\n";
	exit;
} 

sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");

//error_reporting(E_ALL);
//ini_set("display_errors", 1); 
ini_set("memory_limit","32M");

if(isset($_SERVER['argv'][1]) && $_SERVER['argv'][1] == "1"){
	define('constantScan', "1");
} else define('constantScan', "0");


$i="0";
while($i == "0"){
	set_time_limit("999999");
	$overalltotal="0";
	$overalllimit="0";
	$oaserverTotal=array();
	$oaserverLimit=array();
	$sidDown=array();
	$sidOverload=array();

	echo "------------------------------------------------------------\n";
	echo "GameCP Service Monitor $smver";
	echo "\nMonitoring servers started at ". $scanday ."\n";
	echo "------------------------------------------------------------\n";

	sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");
	


	echo "Scanning for remote machine status\n";
	echo "------------------------------------------------------------\n";
	
	$result = sql_query("SELECT sid, ip, os, winport, id FROM servers WHERE active='1'") or die(mysql_error());
	while ($row = mysql_fetch_array($result)){ 
		if($Query->Status($row['sid'])){ 
			$serverup=true;	
		} else $serverup = false;
		
		sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");	

		if($serverup == false){
			$sidDown[]=$row[0];
			echo " - Server is OFFLINE: ".$row[0]." - services will not be scanned\n";
			if(ttuid){
				$Support->CreateMonitor(ttuid, "Tech-MachineDown", "Machine", $row['id'], $row['ip'], $row['winport'], $vtype);
			} else echo " - Define a ticket user id in Settings to create tickets regarding this\n";
		} else {
			echo " - Server is Online: ".$row[0]." - services will be scanned\n";
			$loadInfo=$Query->Stats($row['sid'], $row['os']);
			if(isset($loadInfo[1]) || isset($loadInfo[2])){
				$total=$loadInfo[4];
				$total=$Panel->FormatSize($total);
				$swap=$loadInfo[0]; 
				$free=$loadInfo[1];
				$cache=$loadInfo[2];
				$idle=$loadInfo[3];
				$loadavg=$loadInfo[5];
				$sid=$row['sid'];

				if(!$loadavg) $loadavg='0';

				echo " -- Load Average: ".$idle."\n";
				if(sm_smmaxLoad > '0' && $idle >= sm_smmaxLoad){
					echo " -- OVERLOADED!\n";
					$sidOverload[]=$row[0];
				}

				if(sm_doMachineGraphs){
					$statsdir="$PATH/includes/stats/machines/$sid";
					$graph="graph.rrd";
					if(is_numeric($free+$cache) && is_numeric($loadavg) && is_numeric($idle)) rrdtoolMachines($free+$cache, $loadavg, $idle);
					sql_query("UPDATE settings SET value='".time()."' WHERE name='graphlock';");
				}
			}
		}
		$hook_vars=$row;
		run_hook("monitor_machine");

	}
	unset($serverup, $row, $result);
	echo "------------------------------------------------------------\n";

	sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");
	


	/* check voice */
	$ai=0;
	$result = sql_query("SELECT 
						U.id as 'cid',
						U.username as 'user',
						UV.maxclients,
						UV.ip,
						UV.port,
						UV.tssid,
						UV.servername,
						UV.vid,
						UV.id,
						UV.pass,
						UV.active, UV.voicetype, UV.ts3token, U.firstname, U.lastname FROM uservoice UV, users U WHERE UV.active='1' AND U.id = UV.cid;") or die(mysql_error());
	while ($voiceDetails = mysql_fetch_assoc($result)){
		$suser=$voiceDetails['user'];
		$cid=$voiceDetails['cid'];

		echo "#$ai Voice #". $voiceDetails['id']." ". $voiceDetails['ip'] .":". $voiceDetails['port'] ." @ " . date(dateformat." h:i:s A") ."\n";
		echo "------------------------------------------------------------\n";

		if($voiceDetails['vid'] == "1"){
			if($voiceDetails['voicetype'] == "ts2"){ 
				$vtype="Teamspeak 2";
			} else $vtype="Teamspeak 3";

			$superInfo="";
			$superInfo=$Panel->GetServer('', $voiceDetails['ip']);
			$serverStatus=$Query->Teamspeak($voiceDetails['ip'], $superInfo['ts3pass'], $superInfo['ts3admin'], $voiceDetails['port'], $voiceDetails['voicetype']);
		} else {
			$serverStatus=$Query->Ventrilo($voiceDetails['ip'], $voiceDetails['port']);
			$vtype="Ventrilo";
		}

		sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");
		

		if(!is_array($serverStatus) || (is_array($serverStatus) && $serverStatus[2] != "up")){
			$trys="3";
			$ti="0";
			$voiceup="0";

			while($trys >= $ti){
				echo " --- Service scanned as down, waiting 10 seconds to scan again.\n";
				set_time_limit("999999");
				sleep(10);

				sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");
				

				if($voiceDetails['vid'] == "1"){
					$superInfo=$Panel->GetServer('', $voiceDetails['ip']);
					$serverStatus=$Query->Teamspeak($voiceDetails['ip'], $superInfo['ts3pass'], $superInfo['ts3admin'], $voiceDetails['port'], $voiceDetails['voicetype']);
				} else $serverStatus=$Query->Ventrilo($voiceDetails['ip'], $voiceDetails['port']);
				if(is_array($serverStatus) && $serverStatus[2] == "up"){
					$voiceup="1";
					break;
				} 
				$ti++;
			} 

			if($voiceup == "1"){
				echo " --- Status: Online\n";
			} else {
				echo " --- Restarting.\n";
				if($voiceDetails['vid'] == "1"){
					$Control->Teamspeak($voiceDetails['ip'], $voiceDetails['port'], "restart", $voiceDetails['tssid']); 
				} else $Control->Ventrilo($voiceDetails['ip'], $voiceDetails['port'], "restart");

				sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");
				

				echo " --- Restarted, waiting " . sm_sleeptime ." seconds to scan again.\n";
				set_time_limit("999999");
				sleep(sm_sleeptime);

				sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");
				

				if($voiceDetails['vid'] == "1"){
					$superInfo=$Panel->GetServer('', $voiceDetails['ip']);
					$serverStatus=$Query->Teamspeak($voiceDetails['ip'], $superInfo['ts3pass'], $superInfo['ts3admin'], $voiceDetails['port'], $voiceDetails['voicetype']);
				} else $serverStatus=$Query->Ventrilo($voiceDetails['ip'], $voiceDetails['port']);

				if(!is_array($serverStatus) || (is_array($serverStatus) && $serverStatus[2] != "up")){
					if(sm_downTicket == "2"){
						echo " --- Service is still down, doing nothing because youve enabled it that way.\n";
					} else {
						echo " --- Service is still down, stopping.\n";
						if($voiceDetails['vid'] == "1"){
							$Control->Teamspeak($voiceDetails['ip'], $voiceDetails['port'], "stop", $voiceDetails['tssid']); 
						} else $Control->Ventrilo($voiceDetails['ip'], $voiceDetails['port'], "stop");

						if(sm_downTicket == "1") $Support->CreateMonitor($cid, "Tech-ServerDown", "Voice", $voiceDetails['id'], $voiceDetails['ip'], $voiceDetails['port'], $vtype);
					}
				}else echo " --- Status: Online\n";
			}
		} else echo " --- Status: Online\n";

		if($serverStatus[0]){
			if($serverStatus[0] <= $voiceDetails['maxclients']){ 
				$overslots = "no";
			} else $overslots = "yes";
		} else $overslots = "no";
		
		echo " --- Slots: ". $serverStatus[1]."/".$serverStatus[0]."/".$voiceDetails['maxclients'] ."\n";
		$overalltotal=$overalltotal+$serverStatus[1];
		$overalllimit=$overalllimit+$voiceDetails['maxclients'];

		$hook_vars=$serverStatus;
		run_hook("monitor_voice");

		/* over slot check */
			$doTT = "0";
			if($overslots == "yes"){
				if(sm_overlimit == "1") {
					echo " --- Server over slot quota, stopping server.\n";
					$Control->Uservoice($voiceDetails['id'], "stop");
					$doTT = "1";
				} else {	
					echo " --- Server over slot quota, creating trouble ticket.\n";
					$doTT = "1";
				} 
				if(sm_overlimit != "2") if($doTT == "1") $Support->CreateMonitor($cid, "Tech-Slots-Exceeded", "Voice", $voiceDetails['id'], $voiceDetails['ip'], $voiceDetails['port'], $vtype);
			}
		/* end over slot check */



		unset($serverStatus, $voiceDetails, $voiceup, $suser, $cid);
		$ai++;
		echo "------------------------------------------------------------\n";
		sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");
	
	}
	unset($result, $voiceDetails);

	set_time_limit("999999");
		
	sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");

	$inactiveschedQ = sql_query("SELECT UG.id, UG.restarted
									FROM users U, usergames UG
								WHERE 
									U.id = UG.cid
									AND UG.active = '0'
									AND UG.scan = '1' 
									AND U.active='1' 
									AND UG.use_sched='1' 
								ORDER BY UG.ip, UG.port;") or die(mysql_error());
								//	AND (UG.lastplytime is null OR UG.lastplytime = '')
								//	AND UG.start_date !=''


	while ($inacrow = mysql_fetch_array($inactiveschedQ)) { 
		/* check time to start */
			$sched_start=$Control->Timer($inacrow['id'], true, true);
			if($inacrow['restarted'] < $sched_start && $Control->Timer($inacrow['id'], true) == true){
				echo "-  Service #".$inacrow['id']." schedule time started - starting now.\n";
				echo "------------------------------------------------------------\n";
				$Control->Usergame($inacrow['id'], "start");
			}
		/* end check time to start */
	}


	
	/* check games */
	$result = sql_query("SELECT 
							UG.scontrol,
							UG.ip,
							UG.port,
							G.protocol,
							UG.id,
							U.name,
							U.username, 
							S.sid,
							S.os,
							U.id,
							UG.pubpriv,
							G.gcode,
							UG.queryport,
							UG.clientplayers,
							UG.gid,
							UG.restarted,
							G.name as 'gname',
							UG.status,
							UG.branding,
							UG.brandingon,
							U.firstname, 
							U.lastname,
							UG.restarted, 
							UG.lastplytime,
							UG.stopempty
						FROM users U, usergames UG, game G, iptable I, servers S WHERE U.id = UG.cid AND UG.gid = G.id AND UG.active = '1' AND UG.ip = I.ip AND I.sid = S.sid AND UG.scan = '1' AND U.active='".sm_activeScan."' ORDER BY UG.ip, UG.port;") or die(mysql_error());
						$ii="0";
	while ($row = mysql_fetch_array($result)) { 
		unset($sci, $ip, $port, $qport, $protocol, $gid, $user, $suser, $sid, $os, $cid, $pubpriv, $gcode, $maxplayers, $ggid, $restarted, $gname);
		$sci = $row[0]; 
		$ip = $row[1];
		$port = $row[2];
		$qport=$row['queryport'];
		$protocol = $row[3];
		$gid = $row[4];
		$user = $row[6];
		$suser = $row[6];
		$sid = $row[7];
		$os = $row[8];
		$cid = $row[9];
		$pubpriv = $row[10];
		$gcode = $row[11];
		$maxplayers = $row[13];
		$ggid = $row[14];
		$gname = $row['gname'];
		$stopempty = $row['stopempty']*60;
		$restarted = $row['restarted'];
		$lastplytime = $row['lastplytime'];


		if($protocol == "halflife") $protocol = "cssource";
		if($protocol == "mohaa")	$protocol = "quake3";
		if($protocol == "quake2")	$protocol = "quake3";

		$gamename=array();
		$gamename[]= $gname." @ ". $ip.":".$port;
		$gamename=serialize($gamename);

		$stillActiveQ=sql_query("SELECT active FROM usergames WHERE id='$gid' AND active='1';");

		$restartdelay=time()-$restarted;

		/* server is not down & is still active */
		if(!in_array($sid, $sidDown) && mysql_num_rows($stillActiveQ) == "1" && (($restarted !="" && $restartdelay >= "120") || !$restarted) ){
			echo "#$ii Service #$gid ". $ip .":". $port ." @ " . date(dateformat." h:i:s A") ."\n";
			echo "------------------------------------------------------------\n";

			if(sm_scanquery){
				$qstatInfo=$Query->GameQ($gid, false, true);
				sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");
				if(!is_array($qstatInfo)){
					echo " --- ERROR: Query failure, cannot check status\n";
				} else {
					/* rescan checker */
					if($qstatInfo[2] != "up"){
						$trys="2";
						$ti="0";
						while($trys >= $ti){
							echo " --- Server scanned as down, waiting 10 seconds to scan again.\n";
							set_time_limit("999999");
							sleep(8);
							sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");
							$qstatInfo=$Query->GameQ($gid, false, true);
							if($qstatInfo[2] == "up") break;
							$ti++;
						} 
					}

					if($qstatInfo[2] != "up"){
						$spa = "Offline"; 
					} else $spa = "Online"; 

					$qstat[4]=$qstatInfo[0];
					$qstat[5]=$qstatInfo[1];
					if(isset($qstat[4])){ 
						$total=$qstat[4]; 
					} else $total="0"; 

					$slots=$total . "/". $maxplayers;
					$players=$qstat[5];
					$playerlimit=$maxplayers;

					$lastActiveQ=sql_query("SELECT lastactivetime FROM usergames WHERE id='$gid' AND lastactivetime != '';");
					$lastActive=mysql_fetch_row($lastActiveQ);
					if($stopempty != "" && time()-$lastActive[0] > $stopempty){
						echo " --- Service empty for $stopempty seconds, stopping.\n";
						MonitorStop($gid);
						$Event->EventLogAdd('', "Service $gid stopped for being empty for $stopempty seconds");

					}

					if(sm_smmaxLoadon == '1' && in_array($sid, $sidOverload) && time()-$lastActive[0] > $stopempty){
						echo " --- Server overloaded, stopping this empty service.\n";
						MonitorStop($gid);
						$Event->EventLogAdd('', "Service $gid stopped for being over loaded");
					}
					
					if(sm_disablebrandcheck == '0' 
						&& 
						(!isset($qstatInfo[7]) && $row['brandingon'] == "1" ) 
						|| (isset($qstatInfo[7]) && $qstatInfo[7] != '' && $row['brandingon'] == "1" 
						&& $row['branding'] && !preg_match("/".str_replace("[", "\[", $row['branding'])."/", $qstatInfo[7]))){
						$brandcheck=false;
						echo " --- ERROR: Server branding missing\n";
					} else $brandcheck=true;

					/* graphs */
						if(sm_doMachineGraphs){
							if(DIRECTORY_SEPARATOR == '\\'){
								$statsdir="$PATH/includes/stats/$ip-$port";
							} else $statsdir="$PATH/includes/stats/$ip:$port";
							$graph="graph.rrd";
							if(is_numeric($players) && is_numeric($playerlimit)) rrdtool1( $players, $playerlimit);
							sql_query("UPDATE settings SET value='".time()."' WHERE name='graphlock';");
						}
					/* end graphs */

					/* player check */
						$overslots = "no";
						if($maxplayers){
							if($total <= $maxplayers){ 
								$slots=$qstat[5] ."/".$total . "/". $maxplayers . "";
							} else {
								$slots=$qstat[5] ."/".$total . "/". $maxplayers . " (over limit)"; 
								$overslots = "yes";
							}
						} else $slots="No slots returned";
						
					/* end player check */

					$overalltotal=$overalltotal+$qstat[5];
					$overalllimit=$overalllimit+$maxplayers;

					if(isset($oaserverTotal[$sid])){
						$oaserverTotal[$sid]=$oaserverTotal[$sid]+$qstat[5];
					} else $oaserverTotal[$sid]=$qstat[5];

					if(isset($oaserverLimit[$sid])){
						$oaserverLimit[$sid]=$oaserverLimit[$sid]+$maxplayers;
					} else $oaserverLimit[$sid]=$maxplayers;

					sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");

					echo " --- Status: ". $spa ."\n";
					echo " --- Type: ". $pubpriv ."\n";
					echo " --- Slots: ". $slots ."\n";

					$hook_vars=$qstat;
					run_hook("monitor_service");


					/* brading check 2 */
						if($row['brandingon'] == "1" && sm_disablebrandcheck == '0'){
							if($brandcheck == false){
								if(sm_brandstop == "1"){
									echo " --- Server missing branding, stopping server.\n";
									MonitorStop($gid);
									$Event->EventLogAdd('', "Service $gid stopped missing branding");

								} else if(sm_brandstop == "2"){
									echo " --- Server missing branding, changing server status.\n";
									if(sm_disablebrand == "1") sql_query("UPDATE usergames SET status='5' WHERE id='$gid';");
								}

								$Support->CreateMonitor($cid, "Tech-NoBranding", "Service", $gid, $ip, $port, $gname);

							}elseif(sm_disablebrand == "1" && $row['status'] == "5"){
								echo " --- Server branded, forcing status update.\n";
								sql_query("UPDATE usergames SET status='0' WHERE id='$gid';");
							} else echo " --- Server branded [ok]\n";


						}
					/* end brading check 2 */
					
					sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");

					/* over slot check */
						if($overslots == "yes"){
							echo " --- Service over slot quota, creating trouble ticket.\n";
							if(sm_overlimit == "1") {
								echo " --- Stopping service...\n";
								MonitorStop($gid);
								$Event->EventLogAdd('', "Service $gid stopped for being over slot quota");
							} 
							if(sm_overlimit != "2") $Support->CreateMonitor($cid, "Tech-Slots-Exceeded", "Service", $gid, $ip, $port, $gname);
						}
					/* end over slot check */
					
					sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");

					/* private status check */
						if($spa == "Up." && $pubpriv == "private"){
							if($protocol == "quake3" || $protocol == "cssource" || $protocol == "csgo"){
								
								$qstat = $Query->GameQ($gid, "rules", true);

								/* now easier to add support for more games */
								$privflags=array();
								$privflags[]="pswrd";
								$privflags[]="password";
								$privflags[]="sv_password";
								$privflags[]="g_needpass";
								$privflags[]="si_needPass";

								$private="no";
								foreach($privflags as $p => $f) if (isset($qstat[$f]) && $qstat[$f] == "1") $private="yes";
								

								if(!$private){
									echo " --- Unable to determine services private status.\n";
								}else if($private == "no"){ 
									echo " --- Service should be private but is not, creating trouble ticket.\n";

									if(sm_privatekill == "1") {
										echo " --- Stopping service...\n";
										MonitorStop($gid);
										$Event->EventLogAdd('', "Service $gid stopped for not being private");
									}
									if(sm_privatekill != "2") $Support->CreateMonitor($cid, "Tech-Non-private-private", "Service", $gid, $ip, $port, $gname);

								} // End protocol if
							} // End if private ! = yes
						} 
					/* end private status check */
					
					sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");

					/* downd server */
						$timeDifference=time()-$restarted;
						if($qstatInfo[2] != "up"){
							if(!isset($restarted) || $restarted && $timeDifference > "30"){
								$timeToRescan="30"-$timeDifference;
								
								if(sm_downRestart != "0"){
									echo " --- Restarting Service #$gid.\n";
									$Control->Usergame($gid, "stop");
									$Control->Usergame($gid, "start");
								}
								
								$trys="1";
								$ti="0";

								while($trys >= $ti){
									sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");
									echo " --- Checking Service again, waiting " . sm_sleeptime ." seconds to scan again.\n";
									set_time_limit("999999");
									sleep(sm_sleeptime);
									$spaQ=$Query->GameQ($gid, false, true);
									if($spaQ[2] == "up")break;
									
									$ti++;
								} 

								if($spaQ[2] == "up"){
									$spa="Up.";
								} else $spa = "Down.";

								if($spaQ[2] != "up"){
									if(sm_downTicket == "2"){
										echo " --- Service is still down, doing nothing because youve enabled it that way.\n";
									} else {
										echo " --- Service is still down, stopping.\n";
										if(sm_downTicket == "1" || sm_downTicket == "3"){
											MonitorStop($gid);
											$Event->EventLogAdd('', "Service $gid stopped for being offline");
										}

										if(sm_downTicket == "1"){
											echo " --- Creating trouble ticket about this service.\n";
											$Support->CreateMonitor($cid, "Tech-ServerDown", "Service", $gid, $ip, $port, $gname);
										}
									}
								} else echo " ---  Service is now online\n";
								
							} else {
								$timeToRescan="30"-$timeDifference;
								echo " ---  Service was just restarted or started, will scan again in $timeToRescan seconds.\n";
							}
						}
					/* end downd server */

					sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");
				}
			}

			/* check time to stop */
				if($Control->Timer($gid) == false){
					echo " --- Server is out of time, creating trouble ticket.\n";

					if(sm_timekill == "1") {
						echo " --- Stopping service...\n";
						MonitorStop($gid);
						$Event->EventLogAdd('', "Service $gid stopped for running out of time");
					}

					$Support->CreateMonitor($cid, "Tech-Time-Exceeded", "Service", $gid, $ip, $port, $gname);

				}
			/* end check time to stop */

			
			sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");

			$loadmem = $Backend->ServiceLoad($sid, $os, $gid, $user);

			if($os=="1"){
				$loadmem=explode("::", $loadmem);
				$load=$loadmem[1];
				$mem=$loadmem[0];
			} else {
				$loadmem=explode(" ", $loadmem);
				$load=$loadmem[0];
				$mem=$loadmem[1];
			}

			if(!$load) $load="0.0";
			if(!$mem) $mem="0";
			if(is_numeric($load)) echo " --- CPU: %". $load ."\n"; 
			if(is_numeric($mem)) echo " --- Memory: %". $mem ."\n"; 
			
			// when we have for windows move all this lower
			$statscache=array('load' => $load, 'memory' => $mem);
			sql_query("UPDATE usergames SET `statscache`='".serialize($statscache)."', `statscachetime`='".time()."' WHERE id='$gid';");
			if(DIRECTORY_SEPARATOR == '\\'){
				$statsdir="$PATH/includes/stats/$ip-$port/usage";
			} else $statsdir="$PATH/includes/stats/$ip:$port/usage";
			$graph="graph.rrd";
			if(is_numeric($load) && is_numeric($mem)) rrdtoolUsage($load, $mem);

			sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");
	
			/* load scanning */
			if(sm_maxLoad && sm_maxLoad != "0"){
				$overloaded="no";
				if($load > sm_maxLoad && sm_restartOverloaded == "1"){ echo " --- Service over loaded.\n"; $overloaded = "yes"; }
				if(sm_restartOverloaded == "1" && $overloaded == "yes"){ 
					echo " --- Restarting $gid.\n";
					$Control->Usergame($gid, "stop");
					$Control->Usergame($gid, "start");
				}
			}
			/* end load scanning */
	

			echo "------------------------------------------------------------\n";
			$ii++;
		}
		sql_query("UPDATE settings SET value='".time()."' WHERE name='monitorlock';");
	
	}

	/* overall graph */
		if(sm_doMachineGraphs){
			foreach($oaserverTotal as $osid => $ototal) rrdtoolServerPlayers($osid, $oaserverTotal[$osid], $oaserverLimit[$osid]);
			rrdtool2( $overalltotal, $overalllimit);
			sql_query("UPDATE settings SET value='".time()."' WHERE name='graphlock';");
		} 
	/* end overall graph */


	echo "Monitoring services stopped at ". $scanday ."\n";
	echo "Memory Used: ". echo_memory_usage()."\n";
			
	echo "------------------------------------------------------------\n";
	
	if(constantScan == "1") { 
		set_time_limit("999999");
		echo " --- Constant scan delay, waiting " . sm_constantScanDelay ." seconds to scan again.\n";
		sleep(sm_constantScanDelay);
		$i="0";
	} else $i="1";

	 sql_query("UPDATE settings SET value='' WHERE name='monitorlock';");
}
?>
