<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/
$noheader=true;
require('core/includes/user/session.inc.php');
require('config.inc.php');

function generateMonthlyTotal($monthoo){
	$monthoo=$monthoo-1;
	$showtoday=date(dateformat, strtotime("-".$monthoo++." month"));
	$montha_01=date(dateformat, strtotime("-".$monthoo." months"));

	$compAdmin2 = "date <= '$showtoday' AND date > '$montha_01' AND"; 
	$completedGross2 = mysql_query("SELECT sum(gross) FROM billing WHERE $compAdmin2 status='Completed'") or die(mysql_error());
	$completedFee2 = mysql_query("SELECT sum(fee) FROM billing WHERE $compAdmin2 status='Completed'") or die(mysql_error());
	$completedGrossRes2 = mysql_fetch_array($completedGross2); 
	$completedFeeRes2 = mysql_fetch_array($completedFee2);
	
	$completedTotal2 = $completedGrossRes2[0] - $completedFeeRes2[0];
	if(!$completedTotal2) $completedTotal2='0';
	return $completedTotal2;
}



function generateYearlyTotal($monthoo){
	$monthoo=$monthoo-1;
	$showtoday=date(dateformat, strtotime("-".$monthoo++." year"));
	$montha_01=date(dateformat, strtotime("-".$monthoo." year"));

	$compAdmin2 = "date <= '$showtoday' AND date > '$montha_01' AND"; 
	$completedGross2 = mysql_query("SELECT sum(gross) FROM billing WHERE $compAdmin2 status='Completed'") or die(mysql_error());
	$completedFee2 = mysql_query("SELECT sum(fee) FROM billing WHERE $compAdmin2 status='Completed'") or die(mysql_error());
	$completedGrossRes2 = mysql_fetch_array($completedGross2); 
	$completedFeeRes2 = mysql_fetch_array($completedFee2);
	
	$completedTotal2 = $completedGrossRes2[0] - $completedFeeRes2[0];
	if(!$completedTotal2) $completedTotal2='0';
	return $completedTotal2;
}



function generateClientTotal($monthoo){
	$monthoo=$monthoo-1;
	$showtoday=strtotime("-".$monthoo++." month");
	$montha_01=strtotime("-".$monthoo." months");

	$compAdmin2 = "joindate <= '$showtoday' AND joindate > '$montha_01'"; 
	$completedGross2 = mysql_query("SELECT joindate FROM users WHERE $compAdmin2") or die(mysql_error());
	$completedGrossRes2 = mysql_num_rows($completedGross2); 
	
	$completedTotal2 = $completedGrossRes2;
	if(!$completedTotal2) $completedTotal2='0';
	return $completedTotal2;
}



function ParseFetch($graph_data){
	$legend=array();
	$out=array();
	if(trim($graph_data)){
		$graph_data = preg_replace('/(nan)|(NaN)/', '0.0000000000e+000', $graph_data);
		$data = preg_split('/\n/',$graph_data);  
		if(is_array($data) && isset($data[0])){
			$legend = preg_split('/[\s,]+/',$data[0]);
			if(is_array($legend)) $legend[0]="timestamp";
			unset($data[0], $data[1]);
			foreach($data as $d => $a){
				$row = preg_split('/ /',$a);
				if(is_array($row) && isset($a[0]) && isset($row[0])){
					$tmp=array();
					$tmp[0]= strtotime(date("m/d/y h:i:s A", rtrim($row[0], ":")));
					$totalcols=sizeof($row);
					$i=1;
					while($i < $totalcols){
						$tmp[$i]=@number_format($row[$i],2,'.', '');
						$i++;
					}
					$out[]=$tmp;
				}
			}
		}
	}
	return array($legend, $out);
}

function ReturnJson($graph, $legened=array()){
	$legend=$graph[0];
	$data=$graph[1];
	$out=array();
	foreach($legend as $id => $name){
		if($id != "0"){
			$tmp=array();
			foreach($data as $d => $a){
				$tmp2=array();
				$tmp2[]=$a[0]*1000;
				$tmp2[]=$a[$id];
				$tmp[]=$tmp2;
			}
			$tmp3=array();
			if(isset($legened[$name])){
				$tmp3['label']=$legened[$name];
			} else $tmp3['label']=$name;
			$tmp3['data']=$tmp;
			$out[]=$tmp3;
		}
	}

	return json_encode($out);
}

function GetData($chart, $time_back){
	global $GameCP;

	$time_back=$GameCP->whitelist($time_back, "bash");
	if(DIRECTORY_SEPARATOR == '\\'){
		$rrdbin=path."\\includes\\cron\\rrdtool.exe";
	}else $rrdbin="rrdtool";

	$run_now =  "$rrdbin fetch ".path."/includes/stats/$chart/graph.rrd AVERAGE -s $time_back -e ".(time() - 100);

	if(rrdUseEXEC == "true"){
		return shell_exec($run_now);
	} else {
		if($sid){
			$GameCP->loadIncludes("panel");
			$Panel=new Panel();
			$sid=$Panel->GetMasterID();

			return $Backend->QueryResponse($sid, '', "command:_:$run_now");
		}
	}
}

header('Content-type: application/json');

if(isset($_REQUEST['rrd'])){

	if(isset($_REQUEST['graph'])){
		switch($_REQUEST['graph']){
			case "halfhour";
				$delay="1800";
			break;		
			case "hour";
				$delay="3600";
			break;		
			case "day";
				$delay="86400";
			break;		
			case "month";
				$delay="2629743";
			break;
			case "week";
				$delay="604800";
			break;
			case "year";
				$delay="31556926";
			break;
			default:
				$delay="3600";
			break;
		}
	}

	$chart=$GameCP->whitelist($_REQUEST['chart'], "clean");

	if($_SESSION['gamecp']['userinfo']['ulevel'] == "0" || $_SESSION['gamecp']['userinfo']['ulevel'] == "10") {
		if(DIRECTORY_SEPARATOR == '\\'){
			$ipport=explode("-", $chart);
		} else $statsdir=$ipport=explode(":", $chart);
		$uginfoQ=sql_query($safesql->query("SELECT cid FROM usergames WHERE ip='%s' AND port='%s' LIMIT 1;", array($ipport[0], $ipport[1])));
		$uginfo=mysql_fetch_assoc($uginfoQ);
		if($_SESSION['gamecp']['userinfo']['id'] != $uginfo['cid']) exit;
	}

	$time_back = time() - $delay;		              
	$graph_data=GetData($chart, $time_back);

	$legened=array();
	$legened['cpuid']="CPU Usage (in %)";
	$legened['load']= "CPU Load (100 = 1)";
	$legened['free']= "Memory Free";
	$legened['speed']= "Active Players";
	$legened['limit']= "Player Limit";
	echo ReturnJson(ParseFetch($graph_data), $legened);

}

if($_SESSION['gamecp']['userinfo']['ulevel'] != "0") {
	if(isset($_REQUEST['home'])){
		if(!isset($_SESSION['gamecp']['charts']) || (isset($_SESSION['gamecp']['charts']) && $_SESSION['gamecp']['charts']['time']-time() >= 900)){
			$_SESSION['gamecp']['charts']['data']=array();

			$pendingBills =  mysql_query("SELECT id FROM billing WHERE status = 'Pending'") or die(mysql_error());
			$pendingBills = mysql_num_rows($pendingBills);
			$_SESSION['gamecp']['charts']['data']['pendingBills']=$pendingBills;

			$dueBills =  mysql_query("SELECT id FROM billing WHERE date = '".date(dateformat, time())."' AND status = 'Pending'");
			$dueBills = mysql_num_rows($dueBills);
			$_SESSION['gamecp']['charts']['data']['dueBills']=$dueBills;

			$overDueBills =  mysql_query("SELECT id FROM billing WHERE date > '".date(dateformat, time())."' AND status = 'Pending'") or die(mysql_error());
			$overDueBills = mysql_num_rows($overDueBills);
			$_SESSION['gamecp']['charts']['data']['overDueBills']=$overDueBills;

			$openTickets =  mysql_query("SELECT id FROM ttsystem WHERE status = 'Open'") or die(mysql_error());
			$openTickets = mysql_num_rows($openTickets);
			$_SESSION['gamecp']['charts']['data']['openTickets']=$openTickets;

			$totalActiveClients = mysql_query("SELECT id FROM users WHERE active='1' AND userlevel = '0'") or die(mysql_error());
			$totalActiveClients = mysql_num_rows($totalActiveClients);
			$_SESSION['gamecp']['charts']['data']['totalActiveClients']=$totalActiveClients;

			$totalInactiveClients = mysql_query("SELECT id FROM users WHERE active='0' AND userlevel = '0'") or die(mysql_error());
			$totalInactiveClients = mysql_num_rows($totalInactiveClients);
			$_SESSION['gamecp']['charts']['data']['totalInactiveClients']=$totalInactiveClients;

			$voiceTotal = mysql_query("SELECT id FROM `uservoice`") or die(mysql_error());
			$voiceTotal = mysql_num_rows($voiceTotal);
			$_SESSION['gamecp']['charts']['data']['voiceTotal']=$voiceTotal;

			$machineTotal = mysql_query("SELECT id FROM `servers`") or die(mysql_error());
			$machineTotal = mysql_num_rows($machineTotal);
			$_SESSION['gamecp']['charts']['data']['machineTotal']=$machineTotal;

			$gamesTotal = mysql_query("SELECT UG.id FROM usergames UG, users U WHERE U.active='1' AND U.id = UG.cid") or die(mysql_error());
			$gamesTotal = mysql_num_rows($gamesTotal);
			$_SESSION['gamecp']['charts']['data']['gamesTotal']=$gamesTotal;

			$totalPlayers = mysql_query("SELECT sum(maxplayers) FROM usergames UG, users U WHERE U.active='1' AND UG.active = '1' AND U.id = UG.cid") or die(mysql_error());
			$totalPlayers=mysql_fetch_array($totalPlayers);
			$totalPlayers=$totalPlayers[0];
			$_SESSION['gamecp']['charts']['data']['totalPlayers']=$totalPlayers;

			$_SESSION['gamecp']['charts']['time']=time();
		}

		$out="[";
		$i=1;
		foreach($_SESSION['gamecp']['charts']['data'] as $s =>$d){
			if(!$d)$d='0';
			$out.= "[$i, $d],";
			$i++;

		}
		echo rtrim($out, ",")."]";

	}elseif(isset($_REQUEST['newclients'])){
		$out="[";
		$i=1;
		while($i < "5"){
			$out.="[$i, ".generateClientTotal($i)."],";
			$i++;
		}
		echo rtrim($out, ",")."]";

	}elseif(isset($_REQUEST['yearly'])){
		$out="[";
		$i=1;
		while($i < "5"){
			$out.="[$i, ".generateYearlyTotal($i)."],";
			$i++;
		}
		echo rtrim($out, ",")."]";

	}elseif(isset($_REQUEST['newbills'])){
		$out="[";
		$i=1;
		while($i < "5"){
			$out.="[$i, ".generateMonthlyTotal($i)."],";
			$i++;
		}
		echo rtrim($out, ",")."]";
	}
}

?>