<?php

$noheader=true;
require('core/includes/user/session.inc.php');
require('config.inc.php');
chdir(path);

ob_start();


/*
 * List of known content types based on file extension.
 * Note: These must be built-in somewhere...
 */

$known_content_types = array(
    "htm"  => "text/html",
    "html" => "text/html",
    "js"   => "text/javascript",
    "css"  => "text/css",
    "xml"  => "text/xml",
    "gif"  => "image/gif",
    "jpg"  => "image/jpeg",
    "jpeg" => "image/jpeg",
    "png"  => "image/png",
    "txt"  => "text/plain"
);


if ( !isset( $_GET["uri"] ) ) {
    header( "HTTP/1.1 400 Bad Request" );
    die( "<html><body><h1>HTTP 400 - Bad Request</h1></body></html>" );
}

if (($src_uri = realpath( $_GET["uri"] )) === false) {
    /* The file does not exist */
    header( "HTTP/1.1 404 Not Found" );
    die( "<html><body><h1>HTTP 404 - Not Found</h1></body></html>" );
}

$doc_root = realpath( "." );

if (strpos($src_uri, $doc_root) !== 0) {
    header( "HTTP/1.1 403 Forbidden" );
    die( "<html><body><h1>HTTP 403 - Forbidden</h1></body></html>" );
}

$uri_dir = "";
$folder = "";
$file_name = "";
$content_type = "";

$uri_parts = explode( "/", $src_uri );
for ( $i=0 ; $i<count( $uri_parts ) - 1 ; $i++ ) $uri_dir .= $uri_parts[$i] . "/";
$file_name = end( $uri_parts );
$file_parts = explode( ".", $file_name );

if ( count( $file_parts ) > 1 ) {
    $file_extension = end( $file_parts );
    $content_type = $known_content_types[$file_extension];
}

if (!array_key_exists($file_extension, $known_content_types)) {
    header( "HTTP/1.1 403 Forbidden" );
    die( "<html><body><h1>HTTP 403 - Forbidden</h1></body></html>" );
}

$file_last_modified = filemtime( $src_uri );
header( "Last-Modified: " . date( "r", $file_last_modified ) );

$max_age = 300 * 24 * 60 * 60; // 300 days

$expires = $file_last_modified + $max_age;
header( "Expires: " . date( "r", $expires ) );

$etag = dechex( $file_last_modified );
header( "ETag: " . $etag );

$cache_control = "must-revalidate, proxy-revalidate, max-age=" . $max_age . ", s-maxage=" . $max_age;
header( "Cache-Control: " . $cache_control );

if ( isset($_SERVER['HTTP_IF_MODIFIED_SINCE'])
        && $file_last_modified <= strtotime($_SERVER['HTTP_IF_MODIFIED_SINCE']) ) {
   header( "HTTP/1.1 304 Not Modified" );
   exit;
}
if ( isset($_SERVER['HTTP_IF_NONE_MATCH'])
        && stripslashes($_SERVER['HTTP_IF_NONE_MATCH']) === $etag ) {
    header( "HTTP/1.1 304 Not Modified" );
    exit;
 }



$dst_uri = $src_uri;

$compress = true;
$compress = $compress && ( strpos( $content_type, "text" ) !== false );
$compress = $compress && ( strpos( $_SERVER["HTTP_ACCEPT_ENCODING"], "gzip" ) !== false );
if (gzip == "true" &&  $compress && function_exists("gzopen") ) {
    $gz_uri = $src_uri . ".gz";

    if ( file_exists( $gz_uri ) ) {
        $src_last_modified = filemtime( $src_uri );
        $dst_last_modified = filemtime( $gz_uri );
        if ( $src_last_modified > $dst_last_modified ) unlink( $gz_uri );
    }

    if ( !file_exists( $gz_uri ) ) {
        $error = false;
        if ( $fp_out = @gzopen( $gz_uri, "wb" ) ) {
            if ( $fp_in = fopen( $src_uri, "rb" ) ) {
                while( !feof( $fp_in ) )
                    @gzwrite( $fp_out, fread( $fp_in, 1024*512 ) );
                fclose( $fp_in );
            } else {
                $error = true;
            }
            @gzclose( $fp_out );
        } else {
            $error = true;
        }

        if ( !$error ) {
            $dst_uri = $gz_uri;
            header( "Content-Encoding: gzip" );
        }
    } else {
        $dst_uri = $gz_uri;
        header( "Content-Encoding: gzip" );
    }
}
if ( $content_type ) header( "Content-Type: " . $content_type );

header( "Content-Length: " . filesize( $dst_uri ) );
readfile( $dst_uri );

ob_end_flush();

?>