<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/
$noheader=true;

if(!isset($_REQUEST['checkUser']) && !isset($_REQUEST['getKeyInfo'])){
	require('core/includes/user/session.inc.php');
}
require('config.inc.php');


if(isset($_REQUEST['getKeyInfo'])) die(gcplickey);


$GameCP->CheckPermissions('process');

if(isset($_REQUEST['notifications'])){
	if ($_SESSION['gamecp']['userinfo']['ulevel'] == "1"){
		if(!isset($_SESSION['gamecp']['notifications']['time'])) $_SESSION['gamecp']['notifications']['time']=time();
		$notify_list = sql_query("SELECT * FROM eventlogs WHERE time > ".$_SESSION['gamecp']['notifications']['time'] . " LIMIT 10") or die(mysql_error());
		$notification=array();
		while ($r = mysql_fetch_assoc($notify_list)){ 
			$show=false;
			$type="normal";
			if(preg_match("/was told to/i", $r['comment'])) $show=true;
			if(preg_match("/had voice/i", $r['comment'])) $show=true;
			if(preg_match("/suspend/i", $r['comment'])) $show=true;
			if(preg_match("/removed/i", $r['comment'])) $show=true;
			if(preg_match("/created/i", $r['comment'])) $show=true;
			if(preg_match("/reinstall/i", $r['comment'])) $show=true;
			if(preg_match("/logged in/i", $r['comment'])) $show=true;
			if(preg_match("/EMAILSENT/i", $r['comment'])) $show=false;
			if(preg_match("/EMAILCACHED/i", $r['comment'])) $show=false;
			if($show) $notification[]=array("type"=>$type,"text" => substr($r['comment'], 0, 256));
		}
		$_SESSION['gamecp']['notifications']['time']=time();
		echo json_encode($notification);
	}
}

if(isset($_REQUEST['managemapload'])){
	$GameCP->UserGameAccess($_REQUEST['ugid'], "usergames");
	$GameCP->loadIncludes("game");
	$Game=new Game();
	$serviceInfo=$Game->GetService($_REQUEST['ugid']);
	$mapdir=$serviceInfo['mapimgdir'];
	$map=$_REQUEST['map'];
	if($map){
		$map=explode(".", $map);
		$map=$map[0];
	}
	if(!$map) $map=$serviceInfo['fsgame'];
	if($map) echo $Game->MapImage($mapdir, $map);
}

if(isset($_REQUEST['diskusage'])){
	if ($_SESSION['gamecp']['userinfo']['ulevel'] == "1"){
		$GameCP->loadIncludes("user");
		$User=new User();

		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$userInfo = $Panel->GetUser($_REQUEST['cid']);
		$quotas=unserialize($userInfo['quota']);

		$usage=$User->GetDiskUsage($_REQUEST['cid']);
		$use=array();
		foreach($usage as $mach=>$size){
			$machineDetails = $Panel->GetServer('','',$mach);
			$bytesallowed=$GameCP->ConvertToBytes($quotas[$mach]['size']." ".$quotas[$mach]['size_type']);
			if($bytesallowed){
				$percent=round($size/$bytesallowed*100);
			} else $percent="0";

			if($size-$bytesallowed > 0){
				$over=true;
			} else $over=false;

			$use[]=array("over"=>$over,"server" => $machineDetails['sid'], "id" => $mach, "size"=>$GameCP->ConvertBytes($size), 'percent'=>$percent,'quota' => $quotas[$mach]['size'], 'quota_type' => $quotas[$mach]['size_type']);

		}
		$smarty->assign("discusage", $use);
		$smarty->display("manageusers/diskusage.tpl");
	}
}

if(isset($_REQUEST['rcon'])){
	if ($mode == "quicksend" && DEMO != "yes") {

		$GameCP->UserGameAccess($_REQUEST['ugid'], "usergames");
		$GameCP->loadIncludes("game");
		$Game=new Game();

		$gameInfo = $Game->GetService($_REQUEST['ugid']);

		if($rcon == "") { die("Please select a command."); }
		
		$rconvalue="";

		$rconQ=explode(" ", $rcon);
		$rcon=$rconQ[0];

		unset($rconQ[0]);
		foreach($rconQ as $rvi => $rv) $rconvalue.=$rv. " ";	

		$GameCP->loadIncludes("rcon");
		$Rcon=new Rcon();

		sql_query("UPDATE usergames SET lastplytime='' WHERE id='".$gameInfo['id']."'");

		echo "<font style=\"font-family: arial; font-size: 10px;\" class=\"rconreply\">";
		$GameCP->whitelist($Rcon->Send($gameInfo['ip'], $gameInfo['port'], $gameInfo['protocol'], $rcon, $rconvalue, $gameInfo['rconpass']));
		echo "</font>";
	}
}

if(isset($_REQUEST['gamecontrol'])){
	if(isset($ggame))$gid = $ggame; 

	if(!$gid) die("Game ID required.<br><br><a href=\"javascript:history.go(-1)\"><b>Click here</b></a> to go back."); 

	$gid=$GameCP->whitelist($gid, "int");
	$mode=$GameCP->whitelist($mode, "clean");

	$GameCP->UserGameAccess($gid, "usergames");

	/* Grab all the information. */
	$GameCP->loadIncludes("game");
	$Game=new Game();
	$gameInfo = $Game->GetService($gid);

	$fip		= $gameInfo['ip'];
	$sci		= $gameInfo['scontrolname'];
	$suser		= $gameInfo['username'];
	$sid		= $gameInfo['sid'];
	$os			= $gameInfo['os'];
	$limit		= $gameInfo['flimit'];
	$active		= $gameInfo['gactive'];
	$user		= $gameInfo['username'];
	$fport		= $gameInfo['port'];
	$cid		= $gameInfo['cid'];
	$ugsci		= $gameInfo['scontrol'];


	if($_SESSION['gamecp']['userinfo']['ulevel'] == "5"){
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$userInfo = $Panel->GetUser($_SESSION['gamecp']['userinfo']['id']);
		$userServer=unserialize($userInfo['servers']);
	} 
	if($_SESSION['gamecp']['userinfo']['ulevel'] == "4"){ 
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$userInfo = $Panel->GetUser($cid);
		$rsid=$userInfo['rsid'];
	}


	if(
		($_SESSION['gamecp']['userinfo']['ulevel'] == "4" && $rsid != $_SESSION['gamecp']['userinfo']['id'] ) ||
		($_SESSION['gamecp']['userinfo']['ulevel'] == "5" && !in_array($sid, $userServer)  ) || 
		($_SESSION['gamecp']['userinfo']['ulevel'] != "5" && $_SESSION['gamecp']['userinfo']['ulevel'] != "4" && $_SESSION['gamecp']['userinfo']['ulevel'] != "3" && $_SESSION['gamecp']['userinfo']['ulevel'] != "1" && $_SESSION['gamecp']['userinfo']['ulevel'] != "2" && $_SESSION['gamecp']['userinfo']['id'] != $cid)

	) {

		echo "Error! User id does not match games user owner!";

	} else {

		if($ugsci){
			$sci=$ugsci;
		} else $sci=$sci.".".$gid;

		$GameCP->loadIncludes("user");
		$User=new User();

		$totalUserServers=$User->GetServers($cid, $gid, $limit);
		$activeServers=$totalUserServers[0];

		/* Verify they can run more games. */
		if($activeServers >= $limit && $mode == "start") {
			$smarty->assign("serverLimit", $limit);
			$smarty->assign("ugid", $gid);
			$smarty->display("manageusergames/server-limit.tpl");
			exit;
		} 
		$GameCP->loadIncludes("control");
		$Control=new Control();

		$erreport=false;

		if($mode == "repair") { 
			if($os == "1"){ 
				$debugfile=".bat";
			} else $debugfile=".sh";
			

			echo "<ul style='text-align: left;'><li>Repair mode enabled for service #".$GameCP->whitelist($gid)."</li><li>Locate the file <strong>debug".$GameCP->whitelist($gid)."$debugfile</strong> in the users service folder</li><li>Use this file to debug this game server</li></ul>";
			sql_query($safesql->query("UPDATE usergames SET status='1' WHERE id='%i';", array($GameCP->whitelist($gid, "int"))));
			$mode = "restart";
			$erreport=true;

		}



		// Start, checks to see if its active then starts.
		if($mode == "start") { 
			if($active == "1") { 
				echo "Server is already running.<br>Please stop or restart first.<br>"; 
			} else $Control->Usergame($gid, "start");
		}

		// Stop, stops.
		if($mode == "stop") $Control->Usergame($gid, "stop");

			 

		// Restart, stops then starts.
		if($mode == "restart") $Control->Usergame($gid, "restart", '', $erreport);


		if(!isset($_REQUEST['noheader']) && !isset($_REQUEST['mini'])){
			if(debugging =="0" || $_SESSION['gamecp']['userinfo']['ulevel'] == "0") { 
				if ($_SESSION['gamecp']['userinfo']['ulevel'] == "1") { 
					echo "<meta http-equiv=\"Refresh\" content=\"1;url=" . $url . "/system/services.php\">";
				} else echo "<meta http-equiv=\"Refresh\" content=\"1;url=" . $url . "/system/index.php\">";
			}
		}
	}
}


if(isset($_REQUEST['checkServerStatus'])){
	$GameCP->UserGameAccess($_REQUEST['ugid'], "usergames");

	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$rowServerDetails=$Panel->GetUserGame($_REQUEST['ugid']);
	$serverInfo=$Panel->GetServer('', $rowServerDetails['ip']);

	if($rowServerDetails['status'] == "4" || $rowServerDetails['status'] == "6"){
		$GameCP->loadIncludes("game");
		$Game=new Game();
		if($rowServerDetails['status'] == "6"){
			$reinstall=true;
		} else $reinstall=false;
		if($Game->CheckStatus($serverInfo['sid'], $rowServerDetails['id'], $rowServerDetails['username'], $rowServerDetails['startserver'], true,'','',$reinstall)) echo "ok";
	}else echo "ok";
}

if(isset($_REQUEST['sshTerminalSave'])){
	if($_SESSION['gamecp']['userinfo']['ulevel'] == "1") $_SESSION['gamecp']['terminal'][$sid]['console']=$code;	
}

if(isset($_REQUEST['hideHelper'])){
	if($_SESSION['gamecp']['userinfo']['ulevel'] == "1") sql_query("UPDATE `settings` SET value='no' WHERE name='showinstallhelp' ;");
}

if(isset($_REQUEST['sshTerminal'])){
	if($_SESSION['gamecp']['userinfo']['ulevel'] == "1") {
		$GameCP->loadIncludes("backend");
		$Backend=new Backend();
		$GameCP->loadIncludes("query");
		$Query=new Query();

		$sid=$_REQUEST['sid'];

		if(!$sid || !empty($sid) && !$Query->Status($GameCP->whitelist($sid))) die("root:_:$sid:_:Remote server is offline.");
		

		$_SESSION['gamecp']['terminal'][$sid]['oldpwd']=$_SESSION['gamecp']['terminal'][$sid]['pwd'];
		$c=explode(";", $_REQUEST['code']);
		$GameCP->loadIncludes("linux");
		$Linux=new Linux();

		foreach($c as $d) $Linux->extractCWD($d, $sid);

		$_SESSION['gamecp']['terminal'][$sid]['cmd'][]=$_REQUEST['code'];

		$runcode=$_REQUEST['code'];


		if(preg_match('/[[:blank:]]*su *-* (?P<name>\w+)/', $runcode, $matches)){
			if($matches['name']){

				$check= "a".trim($Backend->QueryResponse($sid, "", "checkuser:_:".$matches['name']))."b";
				if($check == "aexistsb"){
					$_SESSION['gamecp']['terminal'][$sid]['user']=$matches['name'];

					if($matches['name'] == "root"){
						$_SESSION['gamecp']['terminal'][$sid]['pwd']="/root";
					} else $_SESSION['gamecp']['terminal'][$sid]['pwd']="/";

					$runcode=preg_replace('/[[:blank:]]*su *-* (?P<name>\w+)[[:blank:]]*[;]/', '', $runcode);
					$runcode=preg_replace('/[[:blank:]]*su *-* (?P<name>\w+)[[:blank:]]*/', '', $runcode);
				} else die($_SESSION['gamecp']['terminal'][$sid]['user'].":_:".$_SESSION['gamecp']['terminal'][$sid]['oldpwd'].":_:User ".$matches['name']." does not exist.");
			}
		}

		if(!preg_match('/[[:blank:]]*cd[[:blank:]]*([^;]+)/', $runcode, $regs)) $runcode="cd ".$_SESSION['gamecp']['terminal'][$sid]['pwd']." ; $runcode";

		if($code=="exit" && $_SESSION['gamecp']['terminal'][$sid]['user'] != "root"){
			$_SESSION['gamecp']['terminal'][$sid]['user']	= "root";
			$_SESSION['gamecp']['terminal'][$sid]['pwd']	= "/root";
			echo $_SESSION['gamecp']['terminal'][$sid]['user'].":_:".$_SESSION['gamecp']['terminal'][$sid]['pwd'].":_:";
		}
	
	
		if(trim($Backend->QueryResponse($sid, "", "isdir:_:".$_SESSION['gamecp']['terminal'][$sid]['pwd'], $_SESSION['gamecp']['terminal'][$sid]['user'])) == "valid"){
			$res=nl2br(rtrim($Backend->QueryResponse($sid, "", "command:_:".$runcode, $_SESSION['gamecp']['terminal'][$sid]['user'])));
			echo $_SESSION['gamecp']['terminal'][$sid]['user'].":_:".$_SESSION['gamecp']['terminal'][$sid]['pwd'].":_:$res";
		} else {
			$_SESSION['gamecp']['terminal'][$sid]['pwd']= $_SESSION['gamecp']['terminal'][$sid]['oldpwd'];
			echo $_SESSION['gamecp']['terminal'][$sid]['user'].":_:".$_SESSION['gamecp']['terminal'][$sid]['oldpwd'].":_:Folder does not exist.";
		}
	}
}

if(isset($_REQUEST['showServerBox'])){
	if($_SESSION['gamecp']['userinfo']['ulevel'] == "0"){
		$smarty->assign("sessionUserID", $_SESSION['gamecp']['userinfo']['id']);
		$smarty->display("modules/server-box2.tpl");
	}
}

if(isset($_REQUEST['saveIndexSort'])){	
	$currentLeft=serialize($_REQUEST['sort_left']);
	$currentRight=serialize($_REQUEST['sort_right']);

	$savearray['left']=$currentLeft;
	$savearray['right']=$currentRight;

	if($_SESSION['gamecp']['subaccount'] == "yes"){
		sql_query($safesql->query("UPDATE `usersubaccounts` SET indexsort='%s' WHERE id='%i';", array(serialize($savearray), $_SESSION['gamecp']['subuser']['id']))) or die(mysql_error());
	} else sql_query($safesql->query("UPDATE users SET indexsort='%s' WHERE id='%i';", array(serialize($savearray), $_SESSION['gamecp']['userinfo']['id']))) or die(mysql_error());
}

if(isset($_REQUEST['checkUser'])){	
	/* thanks http://jqueryfordesigners.com/using-ajax-to-validate-forms/ */
		$response = array();
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$invalidnames=$Panel->InvalidNames();
		if(in_array($username, $invalidnames)){
			$total="1";
		} else {
			$uname = sql_query($safesql->query("SELECT name FROM users where name='%s' LIMIT 1;", array($GameCP->whitelist($username, "clean")))) or die(mysql_error());
			$total= mysql_num_rows($uname);
		}

		if($total >= "1"){
			echo "Used";
		}elseif($total == "0") echo "Available";
}

if(isset($_REQUEST['checkEmail'])){	
	/* thanks http://jqueryfordesigners.com/using-ajax-to-validate-forms/ */
		$response = array();
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$invalidnames=$Panel->InvalidNames();
		if(in_array($email, $invalidnames)){
			$total="1";
		} else {
			$uname = sql_query($safesql->query("SELECT id FROM users where email='%s' LIMIT 1;", array($GameCP->whitelist($email, "clean")))) or die(mysql_error());
			$total= mysql_num_rows($uname);
		}

		if($total >= "1"){
			echo "Used";
		}elseif($total == "0") echo "Available";
}

if(isset($_REQUEST['showVoiceOptions'])){	
	if($_SESSION['gamecp']['userinfo']['ulevel'] == "1" || $_SESSION['gamecp']['userinfo']['ulevel'] == "4"){
		$GameCP->loadIncludes("display");
		$Display=new Display();
		$smarty->assign("showvoice", "yes");
		$smarty->assign("voicelist",$Display->VoiceIPList($type)); 
		
		$smarty->display("manageusers/addserver-voptions.tpl");
	}
}

if(isset($_REQUEST['showBillOptions'])){
	if($_SESSION['gamecp']['userinfo']['ulevel'] == "1"){
		require_once(path.'/includes/core/classes/billing/order.inc.php');
		$Order=new Order();
		if($pubpriv == 'false'||$pubpriv == 'undefined'){
			$pubpriv="Public";
		} else $pubpriv="Private";

		$pidq = sql_query($safesql->query("SELECT * FROM prices where id='%i' LIMIT 1;", array($GameCP->whitelist($type, "clean")))) or die(mysql_error());
		$pid= mysql_fetch_array($pidq);

		$paddons=$Order->ProductAddons($pid['pid'], $pubpriv);
		if(!isset($term))$term="Monthly";
		$smarty->assign("Order", $Order);	
		$smarty->assign("paddons", $paddons);	
		$smarty->assign("term", $term);	
		$smarty->assign("product", $pid);	
		$smarty->display("order/paddons.tpl");
		$smarty->display("manageusers/addserver-billoptions.tpl");
	}
}

if(isset($_REQUEST['showGameOptions'])){	
	if($_SESSION['gamecp']['userinfo']['ulevel'] == "1" || $_SESSION['gamecp']['userinfo']['ulevel'] == "4"){
		if($_REQUEST['gid']){
			$GameCP->loadIncludes("panel");
			$Panel=new Panel();
			$gameInfo=$Panel->GetGame($_REQUEST['gid']);
			$smarty->assign("gameInfo", $gameInfo);

			$GameCP->loadIncludes("display");
			$Display=new Display();

			$smarty->assign("machineIPList2",$Display->MachineIPList(true, '', '', '', '', '', unserialize($gameInfo['installedon']))); 

			if($gameInfo['vars']){
				$gvars=unserialize($gameInfo['vars']);
				if(is_array($gvars)){
					foreach($gvars as $gv => $gval){
						$gval['val']=$gval['value'];
						$vars[]=$gval;
					}

					$smarty->assign("gamevars", $vars);
				}
			}
			$smarty->display("manageusers/addserver-options.tpl");
		}
	}
}

if(isset($_REQUEST['showMachinePing'])){	
	if($_SESSION['gamecp']['userinfo']['ulevel'] == "1"){
		if(doMachineStats == "yes"){
		
			$GameCP->loadIncludes("panel");
			$Panel=new Panel();
			$machineInfo=$Panel->GetServer($_REQUEST['gmid']);
		
			$GameCP->loadIncludes("query");
			$Query=new Query();

			$smarty->assign("ftpup", $Query->Port($machineInfo['ip'], $machineInfo['ftpport'])); 
			if($machineInfo['master'] == "yes" || $machineInfo['webroot'] != '') {
				$smarty->assign("webup", $Query->Port($machineInfo['ip'], "80")); 
				$smarty->assign("web", 'yes');
			}
			
			$smarty->display("managemachines/port-status.tpl");
		}
	}
}

if(isset($_REQUEST['showMachineDetails'])){	
	if($_SESSION['gamecp']['userinfo']['ulevel'] == "1"){
		$GameCP->loadIncludes("backend");
		$Backend=new Backend();
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$machineInfo=$Panel->GetServer($_REQUEST['gmid']);
		$ipaddresses=array();

		if(isset($doIpList)) {
			$iplistA=$Backend->QueryResponse($machineInfo['sid'], $machineInfo['winport'], "iplist:_:");
			$iplistA=str_replace(" ", "\n", $iplistA);

			/* current ips for this machine */
			$result = sql_query($safesql->query("SELECT ip, id, assigned FROM iptable WHERE sid ='%s' ORDER BY ip ASC;", array($GameCP->whitelist($gmid, "int")))) or die(mysql_error());

			while ($cipl = mysql_fetch_array($result)){ 
				$ipGamesQ = sql_query("SELECT * FROM usergames UG, iptable I WHERE UG.ip = I.ip AND I.ip = '".$cipl['ip']."'") or die(mysql_error());
				$ipgames=mysql_num_rows($ipGamesQ);
				$cipl['ipGames']=$ipgames;
				$ipaddresses[]=$cipl;
			}
							
			/* parse the machines ip list if it gave us any */
			if($iplistA){ 
				$iplist=explode("\n", $iplistA);
				if(is_array($iplist) && count($iplist) > 0){
					$arrayLength = count($iplist);

					$iplistscan="";
					for ($i = 0; $i < $arrayLength; $i++){
					  if($iplist[$i]){ $iplistscan.= "<option value=\"".  trim($iplist[$i]) ."\">". trim($iplist[$i]) ."</option>"; }
					}
				} else $iplistscan = "";

			} else $iplistscan = "";

			$smarty->assign("iplist", $ipaddresses); 
			$smarty->assign("liveiplist", $iplistscan); 

			$smarty->assign("gmid", $gmid); 
			$smarty->assign("machineInfo", $row); 

			$smarty->display("managemachines/ip-list.tpl");
		} else {

			$version=trim($Backend->QueryResponse($machineInfo['sid'], '', "version:_:"));
			if($version == 'Remote server ip is not valid on the license key.' || $version == 'License key is no longer valid.'){
				echo "Remote ip is not valid on license. Reissue license and Sync License to update.";
			} else echo $version;
		}
	}
}

?>