<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


require('core/includes/user/session.inc.php');
require('config.inc.php');

$GameCP->CheckPermissions('serverstatus');

if(isset($_REQUEST['ugid'])){
	if(!isset($forcecache)) $forcecache=false;
	$GameCP->UserGameAccess($_REQUEST['ugid']);

	$GameCP->loadIncludes("game");
	$Game=new Game();
	$GameCP->loadIncludes("query");
	$Query=new Query();
	$serverStatus=$Query->GameQ($_REQUEST['ugid'], '', '', $forcecache);
	$serviceInfo=$Game->GetService($_REQUEST['ugid']);
	
	if($serverStatus[7]){
		$smarty->assign("hostname", strip_tags($serverStatus[7]));
		$smarty->assign("ugid", $GameCP->whitelist($_REQUEST['ugid'], "int"));
	}
	$smarty->assign("livestats", $serverStatus);
	$smarty->assign("status", $serverStatus[8]);
	$smarty->assign("count", $serverStatus[4]);
	if(isset($_REQUEST['alt'])) $smarty->assign("alt", $GameCP->whitelist($_REQUEST['alt'], "clean"));
	$map=$serverStatus[6];

	$mapdir=$serviceInfo['mapimgdir'];
	if(!$map) $map=$serviceInfo['fsgame'];
	if($map) $smarty->assign("showmap", $Game->MapImage($mapdir, $map));

	$smarty->display("modules/show-status.tpl");

/* query voice status */
} else if(isset($_REQUEST['vid'])){
	$GameCP->UserVoiceAccess($_REQUEST['vid']);

	$voiceDetailsQ=sql_query($safesql->query("SELECT * FROM uservoice WHERE id='%i' LIMIT 1", array($GameCP->whitelist($_REQUEST['vid'], "int"))));
	$voiceDetails=mysql_fetch_array($voiceDetailsQ);

	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$superInfo=$Panel->GetServer('', $voiceDetails['ip']);
	$ipInfo=$Panel->GetIP($voiceDetails['ip']);
	if($ipInfo['useinternal'] == "1" && queryinternalip == "yes") $voiceDetails['ip']=$ipInfo['internal'];

	$GameCP->loadIncludes("query");
	$Query=new Query();

	if($voiceDetails['vid'] == "1"){
		$serverStatus=$Query->Teamspeak($voiceDetails['ip'], $superInfo['ts3pass'], $superInfo['ts3admin'], $voiceDetails['port'], $voiceDetails['voicetype']);
	} else $serverStatus=$Query->Ventrilo($voiceDetails['ip'], $voiceDetails['port']);

	if(is_array($serverStatus)){
		$status="up";
		$smarty->assign("hostname", strip_tags($serverStatus[3]));
		$smarty->assign("count", $serverStatus[1]."/".$serverStatus[0]);
		$smarty->assign("ugid", $_REQUEST['vid']);
	} else $status="down";

	$smarty->assign("status", $status);
	$smarty->display("modules/show-status.tpl");

/* query ping */
} else if(isset($_REQUEST['ping'])){
	if($_SESSION['gamecp']['userinfo']['ulevel'] == "1"){
		$GameCP->loadIncludes("query");
		$Query=new Query();

		 $ping=$Query->Ping($_REQUEST['ping'], $os); 
		 if($ping) echo $ping;
	}

/* query server load info */
} else if(isset($_REQUEST['serverstats'])){
	if($_SESSION['gamecp']['userinfo']['ulevel'] == "1"){
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$serverDetails=$Panel->GetServer($_REQUEST['serverstats']);
		$os=$serverDetails['os'];

		$GameCP->loadIncludes("query");
		$Query=new Query();

		if($serverDetails['statscache'] && isset($_REQUEST['forcecache'])|| $serverDetails['statstime'] && ($serverDetails['statstime'] > (time()-machinestatscache))){
			$loadInfo=json_decode($serverDetails['statscache']);
			if(!is_array($loadInfo)) $loadInfo=$Query->Stats($serverDetails['sid'], $os);
		} else $loadInfo=$Query->Stats($serverDetails['sid'], $os);

		if($loadInfo[0] == "Unable to connect to the remote" || $loadInfo[0]=="Unable to connect to the remote, incorrect sid"){
			$smarty->assign("error", $loadInfo[0]);
		}elseif(!is_array($loadInfo) || ($loadInfo[0] == '' && $loadInfo[1] == '')){
			$smarty->assign("error", "Invalid response");
		} else {
			$smarty->assign("loadInfo", array_filter($loadInfo));
			$smarty->assign("os", $os);
		}

		$smarty->display("managemachines/status.tpl");
	}
}

?>