<?php
/*
 * Smarty plugin
 * -------------------------------------------------------------
 * File:     function.gcp_server_box.php
 * Type:     function
 * Name:     gcp_server_box
 * Purpose:  displays GameCP's server status box
 * -------------------------------------------------------------
 */
function smarty_function_gcp_server_box($params, &$smarty)
{
global $GameCP, $safesql;

$cid=$params['cid'];
$definedGid=$params['gid'];

if(!$cid){ return("Fatal Error: Missing client id."); }

$ip=$GameCP->whitelist($_GET['ip']);
$port=$GameCP->whitelist($_GET['port']);

// Clear any old variabels.
$smarty->clearAssign("showStatus"); 
$smarty->clearAssign("sbipport"); 
$smarty->clearAssign("sbugcode"); 
$smarty->clearAssign("ucid"); 
$smarty->clearAssign("ugid"); 
$smarty->clearAssign("sbfsgame"); 
$smarty->clearAssign("console"); 
$smarty->clearAssign("sbprotocol"); 
$smarty->clearAssign("hostname"); 
$smarty->clearAssign("totalPlayers"); 
$smarty->clearAssign("maxPlayers"); 
$smarty->clearAssign("allowedClients"); 
$smarty->clearAssign("currentMap"); 
$smarty->clearAssign("sbrconpass"); 
$smarty->clearAssign("sbip"); 
$smarty->clearAssign("currentMap"); 
$smarty->clearAssign("console"); 
$smarty->clearAssign("gameName"); 

if($definedGid){ $ugQuery = " AND UG.id = '".$GameCP->whitelist($definedGid, 'int')."' LIMIT 1"; }

// Generate a box for each result
if($ip && $port){ $cQuery = "AND UG.ip = '$ip' AND UG.port='$port' LIMIT 1"; } else { $cQuery = ""; }
$resultQ = sql_query($safesql->query("SELECT UG.ip, UG.port, G.protocol, G.name, UG.maxplayers, UG.id as 'ugid', G.mapdir, UG.rconpass, G.gcode, UG.queryport, G.quickmod, G.fsgame FROM usergames UG, game G, users U WHERE U.id = UG.cid AND UG.gid = G.id AND U.id = '%i' AND UG.active = '1' $cQuery $ugQuery", array($cid))) or die(mysql_error());
$GameCP->loadIncludes("query");
$Query=new Query();
while($result = mysql_fetch_array($resultQ)) {
	$sbugid = $result['ugid'];
	$sbip = $result[0];
	$sbport = $result[1];
	$sbname = $result[3];
	$allowedClients = $result[4];
	$sbgcode=$result[8];
	$sbprotocol=$result[2];
	$sbqueryport=$result['queryport'];
	$sbquickMod=$result['quickmod'];
	$sbfsgame=$result['fsgame'];
	$sbrconpass = $result['rconpass'];
	$sbugcode=strtoupper($sbgcode);

	// Grab the quick mods
	$quickMod=explode("::", $sbquickMod);
	$smarty->assign("quickMod", $quickMod);


$sbqstat=$Query->GameQ($ugid);

// Make sure the vars are good
if(isset($sbqstat[1])){ $totalPlayers=$sbqstat[1]; } else { $active="0"; }
if(isset($sbqstat[0])){ $maxPlayers=$sbqstat[0]; } else { $total="0"; }
if(isset($sbqstat[3])){ $currentMap=$sbqstat[6]; } else { $map=""; }
if(isset($sbqstat[2])){ $hostname=$sbqstat[7]; } else { $hostname=""; }
if($sbqstat[0] != ""){ $showStatus="yes"; } else { $showStatus="no"; }

if(!isset($console)){ $console = ""; }

// Assign some smarty vars
if(is_file(path."/uglygs/stats/servers/$sbugcode$sbip:$sbport.php")) { $smarty->assign("showStatsLink", "yes"); }

$smarty->assign("showStatus", $showStatus);
$smarty->assign("sbipport", $sbip.":".$sbport);
$smarty->assign("sbugcode", $sbugcode);
$smarty->assign("ucid", $cid);
$smarty->assign("ugid", $sbugid);
$smarty->assign("sbfsgame", $sbfsgame);
$smarty->assign("console", $console);
$smarty->assign("sbprotocol", $sbprotocol);
$smarty->assign("hostname", $hostname);
$smarty->assign("totalPlayers", $totalPlayers);
$smarty->assign("maxPlayers", $maxPlayers);
$smarty->assign("allowedClients", $allowedClients);
$smarty->assign("currentMap", $currentMap);
$smarty->assign("sbrconpass", $sbrconpass);
$smarty->assign("sbip", $sbip);
$smarty->assign("sbport", $sbport);
$smarty->assign("currentMap", $currentMap);
$smarty->assign("console", $console);
$smarty->assign("gameName", $sbname);

// Display the template
$smarty->display('modules/server-box.tpl');
}
}
?>