<?php
/*
 * Smarty plugin
 * -------------------------------------------------------------
 * File:     function.gcp_server_box.php
 * Type:     function
 * Name:     gcp_server_box
 * Purpose:  displays GameCP's server status box
 * -------------------------------------------------------------
 */
function smarty_function_gcp_server_box($params, &$smarty)
{
global $GameCP, $safesql;


$cid=$params['cid'];
$definedGid=$params['gid'];

if(!$cid){ return("Fatal Error: Missing client id."); }

$ip=$_GET['ip'];
$port=$_GET['port'];


$cid=$GameCP->whitelist($cid, "int");
$definedGid = $GameCP->whitelist($definedGid, "int");
$ip=$GameCP->whitelist($ip, "clean");
$port=$GameCP->whitelist($port, "int");


// Clear any old variabels.
$smarty->clearAssign("showStatus"); 
$smarty->clearAssign("sbipport"); 
$smarty->clearAssign("sbugcode"); 
$smarty->clearAssign("ucid"); 
$smarty->clearAssign("ugid"); 
$smarty->clearAssign("sbfsgame"); 
$smarty->clearAssign("console"); 
$smarty->clearAssign("sbprotocol"); 
$smarty->clearAssign("hostname"); 
$smarty->clearAssign("totalPlayers"); 
$smarty->clearAssign("maxPlayers"); 
$smarty->clearAssign("allowedClients"); 
$smarty->clearAssign("currentMap"); 
$smarty->clearAssign("sbrconpass"); 
$smarty->clearAssign("sbip"); 
$smarty->clearAssign("currentMap"); 
$smarty->clearAssign("console"); 
$smarty->clearAssign("gameName"); 
$smarty->clearAssign("quickConfig");
$smarty->clearAssign("servername");

if($definedGid){ $ugQuery = " AND UG.id = '$definedGid' LIMIT 1"; }

// Generate a box for each result
if($ip && $port){ $cQuery = "AND UG.ip = '$ip' AND UG.port='$port' LIMIT 1"; } else { $cQuery = ""; }
$resultQ = sql_query($safesql->query("SELECT 
	UG.ip, UG.port, G.protocol, G.name as 'gname', UG.maxplayers, UG.id as 'ugid',
	G.usermapdir, G.mapextension,
	UG.subdirectory,

	UG.rconpass, G.gcode,
	UG.queryport, G.quickmod,
	G.fsgame, U.username as 'uname', S.os, G.quickconfig,
	UG.servername,
	S.sid, S.winport,
	G.winusermapdir, G.winmapdir,
	UG.vars as 'ugvars', UG.customvars, G.vars, G.mapimgdir, UG.lastmaps, UG.lastmapstime

	FROM
		usergames UG, game G, users U, iptable I, servers S 
	WHERE
		I.ip = UG.ip AND I.sid = S.sid AND U.id = UG.cid AND UG.gid = G.id AND U.id = '%i' AND UG.active = '1' $cQuery $ugQuery", array($cid))) or die(mysql_error());

	while($result = mysql_fetch_array($resultQ)) {
		$sbugid = $result['ugid'];
		$sbip = $result['ip'];
		$sbport = $result['port'];
		$sbname = $result['gname'];
		$allowedClients = $result['maxplayers'];
		$sbgcode=$result['gcode'];
		$sbprotocol=$result['protocol'];
		$sbqueryport=$result['queryport'];
		$sbquickMod=$result['quickmod'];
		$sbfsgame=$result['fsgame'];
		$sbrconpass = $result['rconpass'];
		$mapdir=$result['usermapdir'];
		$fusername=$result['uname'];
		$sid=$result['sid'];
		$winport=$result['winport'];
		$os=$result['os'];
		$servername=$result['servername'];
		$mapextension=$result['mapextension'];
		$winusermapdir=$result['winusermapdir'];
		$winmapdir=$result['winmapdir'];
		$quickConfig=$result['quickconfig'];
		$lastmapstime=$result['lastmapstime'];
		$lastmaps=@unserialize($result['lastmaps']);
		$subdirectory=$result['subdirectory'];
		$mapimgdir=$result['mapimgdir'];
		$vars = @unserialize($result['vars']);
		$ugvars = @unserialize($result['ugvars']);
		$userCustomCvars = @unserialize($result['customvars']);

		$map = $sbfsgame;
	
		if(isset($_SESSION['gamecp']['subaccount']) && $_SESSION['gamecp']['subaccount'] == "yes" && !in_array($result['ugid'], $_SESSION['gamecp']['subuser']['games'])) break;

		$sbugcode=strtoupper($sbgcode);
		$mapList=array();
		if($os == "1") $mapdir=$winusermapdir;
		
		$GameCP->loadIncludes("game");
		$Game=new Game();
		$userGameCvars=$Game->MergeVars($vars, $ugvars, true);
		
		if($subdirectory == "yes"){ 
			if(ipsubdir == "true"){
				$thesubdir=$sbip."-".$sbport;
			} else $thesubdir="service".$sbugid;
			$homemapdir="/home/$fusername/$thesubdir/$mapdir";
			$cfgbasedir="/home/$fusername/$thesubdir";
		} else {
			$homemapdir="/home/$fusername/$mapdir";
			$cfgbasedir="/home/$fusername";
			$thesubdir="";
		}
			

			// TO-DO whole thing can be optimized much better...
		if(trim($mapdir) != ""){
			if($os == "1"){ 
				// Do Windows - convert home path [easy]
				$homemapdir=str_replace("/", "\\", $homemapdir);
				if(!is_array($lastmaps) || (time()-$lastmapstime > 60 && isset($_SESSION['gamecp']['map_load'])) ){
					$GameCP->loadIncludes("backend");
					$Backend=new Backend();
					$usermaplist=$Backend->QueryResponse($sid, $winport, "filelist2:_:\$MAINDIR".$homemapdir);
					$usermaplistA = explode("::", $usermaplist);

					foreach($usermaplistA as $r => $v){
						$map1=explode(":_:", $v);
						$map2=explode(".", $map1[0]);
						if($mapextension != "")
						{
							if(preg_match('/.$mapextension/i',$map2[0])){ 
								if(!in_array($map2[0], $mapList)) $mapList[]=$map2[0];
							}
						} else {
							if(!in_array($map2[0], $mapList)) $mapList[]=$map2[0];
						}
					}

					sql_query($safesql->query("UPDATE usergames SET lastmaps='%s', lastmapstime='%s' WHERE id='%i'", array(serialize($mapList), time(), $sbugid)));

				}else $mapList=$lastmaps;

			} else {
				// Do Linux	
				if($mapextension != ""){
					$cmd="ls -x1 $homemapdir | grep -i \"$mapextension\$\"";
				} else $cmd="ls -x1 $homemapdir";

				if(!is_array($lastmaps) || (time()-$lastmapstime > 60 && isset($_SESSION['gamecp']['map_load'])) ){
					$GameCP->loadIncludes("backend");
					$Backend=new Backend();
					$usermaplist=$Backend->QueryResponse($sid, '', "command:_:".$GameCP->whitelist($cmd, 'shell'), $fusername);

					$usermaplistA=explode("\n", $usermaplist);
					foreach($usermaplistA as $r => $v){
						$map2=explode(".", $v);
						if(!in_array($map2[0], $mapList)) $mapList[]=$map2[0];
					}
					sql_query($safesql->query("UPDATE usergames SET lastmaps='%s', lastmapstime='%s' WHERE id='%i'", array(serialize($mapList), time(), $sbugid)));
				}else $mapList=$lastmaps;
			}

			$_SESSION['gamecp']['map_load']=true;
		}
		
		/* sort the array */
		if(is_array($usermaplistA)) asort($usermaplistA);
		// Grab the quick mods
		$quickMod=explode("::", $sbquickMod);
		if(is_array($quickMod) && count($quickMod) > "0"){
			$qm2=array();
			foreach($quickMod as $qma => $gmb){
				if(trim($gmb) != "") $qm2[]=trim($gmb);
			}
			$smarty->assign("quickMod", $qm2);
		} else $smarty->assign("quickMod", "");
		
		$quickConfig=unserialize($quickConfig);
		$i="0";
		$cfgList=array();
		if($thesubdir)$thesubdir=$thesubdir."/";
		if(is_array($quickConfig) && count($quickConfig) > 0){
			foreach($quickConfig as $cfg){
				$cfgs=explode(":",$cfg);
				if($cfgs[0]){
					if($cfgs[1]){
						$cfgList[$i]['name']=$cfgs[0];
						$cfgList[$i]['file']=$cfgs[1];
					} else {
						$cfgList[$i]['name']=$cfgs[0];
						$cfgList[$i]['file']=$cfgs[0];
					}
					$i++;
				}
			}
		}

		if(is_array($cfgList)) $smarty->assign("quickConfig", $cfgList);

		$GameCP->loadIncludes("query");
		$Query=new Query();
		$sbqstat=$Query->GameQ($sbugid);

		// Make sure the vars are good
		if(isset($sbqstat[1])){ $totalPlayers=$sbqstat[1]; } else { $totalPlayers="0"; }
		if(isset($sbqstat[0])){ $maxPlayers=$sbqstat[0]; } else { $maxPlayers="0"; }
		if(isset($sbqstat[6])){ $currentMap=$sbqstat[6]; } else { $currentMap=""; }
		if(isset($sbqstat[7])){ $hostname=$sbqstat[7]; } else { $hostname=""; }
		if($sbqstat[2] != "down"){ $showStatus="yes"; } else { $showStatus="no"; }

		if(!isset($console)){ $console = ""; }

		// Assign some smarty vars
		if(is_file(path."/uglygs/stats/servers/$sbugcode$sbip:$sbport.php")) { $smarty->assign("showStatsLink", "yes"); }
		
		if(is_file(path."/includes/stats/$sbip:$sbport/box_graph.png")) { $smarty->assign("showStatsLink", "yes"); }


		$rconProtocols=array();
		$rconProtocols[]="cssource";
		$rconProtocols[]="csgo";
		$rconProtocols[]="bf2";
		$rconProtocols[]="halflife";
		$rconProtocols[]="cod";
		$rconProtocols['q3']="quake3";
		$rconProtocols[]="gamespy";
		$rconProtocols[]="bf1942";

		if($sbprotocol == "quake3" && $sbgcode != "q3s") unset($rconProtocols['q3']);

		if(in_array($sbprotocol, $rconProtocols)) $smarty->assign("showRcon", "true");



		if(isset($sbqstat[6]) && $sbqstat[6]){
			$map=$sbqstat[6];
		} else {
			$livestats2=$Query->GameQ($sbugid, 'rules');
			if($livestats2['gq_mapname'])$map=$livestats2['gq_mapname'];
			if($livestats2['sv_map'])$map=$livestats2['gq_mapname'];
			if($livestats2['g_map'])$map=$livestats2['gq_mapname'];
		}
		

		$smarty->assign("showmap", $Game->MapImage($mapimgdir, $map));
		$smarty->assign("map", $map);

		$smarty->assign("cfgbasedir", $cfgbasedir);


		$smarty->assign("showStatus", $showStatus);
		$smarty->assign("sbipport", $sbip.":".$sbport);
		$smarty->assign("sbugcode", $sbugcode);
		$smarty->assign("thesubdir", $thesubdir);
		$smarty->assign("fname", $fusername);
		$smarty->assign("ucid", $cid);
		$smarty->assign("ugid", $sbugid);
		$smarty->assign("sbfsgame", $sbfsgame);
		$smarty->assign("console", $console);
		$smarty->assign("sbprotocol", $sbprotocol);
		$smarty->assign("hostname", $hostname);
		$smarty->assign("totalPlayers", $totalPlayers);
		$smarty->assign("maxPlayers", $maxPlayers);
		$smarty->assign("allowedClients", $allowedClients);
		$smarty->assign("currentMap", $currentMap);
		$smarty->assign("sbrconpass", $sbrconpass);
		$smarty->assign("sbip", $sbip);
		$smarty->assign("sid", $sid);
		$smarty->assign("sbport", $sbport);
		$smarty->assign("currentMap", $currentMap);
		$smarty->assign("console", $console);
		$smarty->assign("gameName", $sbname);
		$smarty->assign("mapList", $mapList);
		$smarty->assign("servername", $servername);

		$smarty->assign("userGameCvars", $userGameCvars);
		$smarty->assign("userCustomCvars", @$userCustomCvars);

		// Display the template
		$smarty->display('modules/server-box.tpl');
	}
}
?>