<?php
/*
 * Smarty plugin
 * -------------------------------------------------------------
 * File:     function.gcp_server_list.php
 * Type:     function
 * Name:     gcp_server_list
 * Purpose:  displays GameCP's server list
 * -------------------------------------------------------------
 */
function smarty_function_gcp_server_list($params, &$smarty)
{
	global $GameCP, $safesql, $deviceType;
	if($deviceType != "computer") $_REQUEST['mini']=true;

$sql=$params['sql'];
$pageTitle=$params['pageTitle'];
$status=$params['status'];

$sortTableName=$params['sortTableName'];
$formName=$params['formName'];
if(!$formName)$formName="sci";
$jsCheckScript=$params['jsCheckScript'];

if ($status=='inactive'){
	$active='0';
}elseif($status=='suspended'){
	$active='2';
}else $active='1';

$indexQ=$smarty->getTemplateVars('indexQ');
$sortS=$smarty->getTemplateVars('sortS');
$sortG=$smarty->getTemplateVars('sortG');
$sortU=$smarty->getTemplateVars('sortU');

$sql="SELECT SQL_CALC_FOUND_ROWS
	UG.ip,
	UG.port,
	UG.scontrol,
	UG.cid as 'uid',
	UG.queryport, 
	UG.servername, 
	UG.status, 
	UG.startserver,
	UG.id as 'ugid',
	UG.maxplayers,
	UG.queryport,
	UG.homepage,
	G.userupdate,
	G.reinstall, 
	G.disableconsole, 
	G.disableconfigs,
	G.mapdir,
	G.usermapdir,
	G.winmapdir, 
	G.winusermapdir,
	G.name as 'gname',
	G.protocol,
	G.gcode,
	G.userupdate,
	G.reinstall, 
	UG.status, 
	concat(UG.ip,':',UG.port) as 'address',
	(SELECT sid FROM iptable I WHERE I.ip=UG.ip) as 'ipsid',
	(SELECT location FROM servers S WHERE S.sid=ipsid) as 'location', 
	(SELECT os FROM servers S WHERE S.sid=ipsid) as 'os',
	(SELECT name FROM users U WHERE U.id=UG.cid) as 'name',
	(SELECT email FROM users U WHERE U.id=UG.cid) as 'email',
	(SELECT firstname FROM users U WHERE U.id=UG.cid) as 'firstname',
	(SELECT lastname FROM users U WHERE U.id=UG.cid) as 'lastname'
FROM 
	usergames UG JOIN game as G ON G.id=UG.gid
WHERE 
	UG.active='$active' 
	RSIDQUERY
	$indexQ $sortS";



if($_SESSION['gamecp']['userinfo']['ulevel'] == "4"){
	$sql=str_replace("RSIDQUERY", " AND (SELECT rsid FROM users U WHERE U.id=UG.cid) = '".$_SESSION['gamecp']['userinfo']['id']."'", $sql);
}elseif($_SESSION['gamecp']['userinfo']['ulevel'] != "1" && $_SESSION['gamecp']['userinfo']['ulevel'] != "2" && $_SESSION['gamecp']['userinfo']['ulevel'] != "3"){
	$sql=str_replace("RSIDQUERY", "AND UG.cid='".$_SESSION['gamecp']['userinfo']['id']."'", $sql);
} else $sql=str_replace("RSIDQUERY", "", $sql);

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1" && $_SESSION['gamecp']['userinfo']['ulevel'] != "2" && $_SESSION['gamecp']['userinfo']['ulevel'] != "3" && $_SESSION['gamecp']['userinfo']['ulevel'] != "4"  && $_SESSION['gamecp']['userinfo']['ulevel'] != "5") $sql=$sql." AND UG.cid = '". $_SESSION['gamecp']['userinfo']['id']."'";

$sql=$sql." ORDER BY address";

//echo $sql;

// Clear any old variabels.
$smarty->clearAssign("rowServerDetails"); 
$ServerList=array();
$listed=array();
$i = "0"; 

/* page control */
$result=Smarty_PageControl($sql, $formName, $formName."Form");

while ($rowServerDetails = mysql_fetch_array($result)){
	if($_SESSION['gamecp']['userinfo']['ulevel'] == "5"){
		$usersServersQ = sql_query("SELECT servers FROM users WHERE id='". $_SESSION['gamecp']['userinfo']['id'] ."'") or die(mysql_error());
		$usersServers = mysql_fetch_array($usersServersQ);
		$userServer=unserialize($usersServers[0]);
		if(in_array($rowServerDetails['sid'], $userServer)){
			$addRow = true;
		} else $addRow = false;
	} else $addRow = true;

	if($rowServerDetails['active'] == "2") $addRow=false;
	if(isset($_SESSION['gamecp']['subaccount']) && $_SESSION['gamecp']['subaccount'] == "yes" && !in_array($rowServerDetails['ugid'], $_SESSION['gamecp']['subuser']['games'])) $addRow=false;
	if(in_array($rowServerDetails['ugid'], $listed)) $addRow=false;
	if($addRow == true){

		if($rowServerDetails['firstname'] || $rowServerDetails['lastname']){
			$rowServerDetails['name']=$rowServerDetails['firstname'].' '.$rowServerDetails['lastname'];
		} elseif($rowServerDetails['email']) $rowServerDetails['email']=$rowServerDetails['email'];

		$listed[]=$rowServerDetails['ugid'];
		$ServerList[$i]=array("ugid" => $rowServerDetails['ugid'],
			"ipport" => $rowServerDetails['ip']. ":". $rowServerDetails['port'], 
			"game" => $rowServerDetails['gname'],
			"rowusername" => $rowServerDetails['name'],
			"scontrol" => $rowServerDetails['scontrol'],
			"ucid" => $rowServerDetails['uid'],
			"os" => $rowServerDetails['os'],
			"status" => $rowServerDetails['status'],
			"servername" => $rowServerDetails['servername'],
			"reinstall" => $rowServerDetails['reinstall'],
			"userupdate" => $rowServerDetails['userupdate'],
			"disableconsole" => $rowServerDetails['disableconsole'],
			"disableconfigs" => $rowServerDetails['disableconfigs'],
			"mapdir" => $rowServerDetails['mapdir'],
			"usermapdir" => $rowServerDetails['usermapdir'],
			"winmapdir" => $rowServerDetails['winmapdir'],
			"winusermapdir" => $rowServerDetails['winusermapdir'],
			"location" => $rowServerDetails['location']
			);
		$i++;
	}
}	


if($ServerList && count($ServerList) > 0)$smarty->assign('rowServerDetails', $ServerList);

if(!$jsCheckScript) $jsCheckScript=""; 

$smarty->assign("pageTitle", $pageTitle); 
$smarty->assign("sortTableName", $sortTableName); 
$smarty->assign("jsCheckScript", $jsCheckScript); 
$smarty->assign("formName", $formName); 

if(is_dir(path."/tracker")) $smarty->assign("gcptracker", true); 

$smarty->assign("displayControls", "yes"); 
$smarty->assign("showServerList", count($ServerList)); 

$smarty->display('modules/server-list.tpl');

// Clear re-used variables
$smarty->clearAssign("pageTitle"); 
$smarty->clearAssign("displayControls"); 

}
?>