<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/

class Installer{

	var $Error=array();
	var $safe_mode=false;

	var $sql_user;
	var $sql_pass;
	var $sql_host;
	var $sql_db;

	function MasterIP(){
		if(!isset($_SERVER['SERVER_ADDR'])){
			if(isset($_SERVER['LOCAL_ADDR'])){
				$_SERVER['SERVER_ADDR']=$_SERVER['LOCAL_ADDR'];
			} else $_SERVER['SERVER_ADDR']=$_SERVER['HTTP_HOST'];
		}
		return gethostbyname($_SERVER['SERVER_ADDR']);
	}

	function checkColumn($table, $field){
		$checkQ=mysql_query("SHOW COLUMNS FROM $table");
		while ($chk = mysql_fetch_array($checkQ)){
			if($chk[0] == $field) return "0";  
		}
	}

	function checkRow($table, $col, $val){
		$checkQ=mysql_query("SELECT * FROM $table WHERE $col='$val' LIMIT 1;");
		$chk=mysql_num_rows($checkQ);
		if($chk >= "1") return "0"; 
	}

	function checkTable($table){
		$checkQ=mysql_query("SHOW TABLES");
		while ($chk = mysql_fetch_array($checkQ)){
			if($chk[0] == $table) return "0"; 
		}
	}

	function CheckMySQL($alt=FALSE) {
		if($alt){
			$file="../includes/mysql.inc.php";
		} else $file="includes/mysql.inc.php";

		if(@file_exists($file)) {
			$lines = file($file);
			if(is_array($lines)){
				foreach ($lines as $line_num => $line) {
					if(preg_match("/mysql_connect/i", $line) || preg_match("/mysql_pconnect/i", $line)) return true;
				}
			}
			return false;		
		} else return false;
		
	}

	function GetOS(){
		if(DIRECTORY_SEPARATOR == '\\'){	
			return "windows";
		} else return "nix";
	}


	function AddMySQLAccount($adminuser, $adminpass, $host, $user, $pass, $db){
		if(!$host)		die("Missing host.");
		if(!$db)		die("Missing database.");
		if(!$adminuser) die("Missing admin user.");
		if(!$user)		die("Missing user.");
		if(!$pass)		die("Missing password.");
		
		if(!$this->CreateMySQLConnect($host, $adminuser, $adminpass, "mysql")) die("Unable to connect to MySQL server.");
		
		mysql_query("CREATE DATABASE $db;") or die(mysql_error());
			
		mysql_query("CREATE USER '$user'@'%' IDENTIFIED BY '$pass';") or die(mysql_error());
		mysql_query("CREATE USER '$user'@'localhost' IDENTIFIED BY '$pass';") or die(mysql_error());

		mysql_query("GRANT USAGE ON *.* TO '$user'@'%';") or die(mysql_error());
		mysql_query("GRANT SELECT,INSERT,UPDATE,DELETE,CREATE,DROP,INDEX,ALTER ON $db.* TO '$user'@'%';") or die(mysql_error());

		mysql_query("GRANT USAGE ON *.* TO '$user'@'localhost';") or die(mysql_error());
		mysql_query("GRANT SELECT,INSERT,UPDATE,DELETE,CREATE,DROP,INDEX,ALTER ON $db.* TO '$user'@'localhost';") or die(mysql_error());

		mysql_query("FLUSH PRIVILEGES;") or die(mysql_error());
		mysql_close($this->conn);
		if(!$this->CreateMySQLConnect($host, $adminuser, $adminpass, "mysql")) die("Unable to connect to new MySQL database.");

	}


	function CreateMySQLConnect($host, $user, $pass, $db){
		$this->conn = @mysql_connect($host, $user, $pass) or die(mysql_error());
		mysql_select_db($db, $this->conn) or die(mysql_error());
		return true;
	}


	function RandomPassword() { 
		$salt = "^#_abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890"; 
		srand((double)microtime()*1000000);  
		$i = 0; 
		while ($i < 24) {  // change for other length
			$num = rand() % 33; 
			$tmp = substr($salt, $num, 1); 
			@$pass = $pass . $tmp; 
			$i++; 
		} 
		return strip_tags($pass);
	} 


	function ValidateMySQL($host, $user, $pass, $db){
		$conn = @mysql_connect($host, $user, $pass);
		if(!$conn) return false;
		if(!mysql_select_db($db, $conn)) return false;
		@mysql_close($conn);
		return true;
	}

	function GetPath(){
		chdir("..");
		if(DIRECTORY_SEPARATOR == '\\'){
			$sitepath=rtrim(getcwd(), "\\");
		} else $sitepath=rtrim(getcwd(), "/");

		chdir("installer");
		return $sitepath;
	}

	function ValidateInstall(){
		$PATH=$this->GetPath();
		$templates_c=$PATH."/includes/cache/";
		$mysql_f=$PATH."/installer/resources/mysql.inc.php";
		$inc_d=$PATH."/includes";

		if (ini_get('safe_mode') == 1 || strtolower(ini_get('safe_mode')) == "yes"){
			$this->Error[]=array("safe_mode", true);
			$this->safe_mode = true;
		}

		if (!extension_loaded('mysql'))					$this->Error[]=array("php_mysql", true, "Connects PHP to your MySQL server");
		if (!extension_loaded('session'))				$this->Error[]=array("php_session", true, "Allows PHP to save data per session");
		if (!extension_loaded('ftp'))					$this->Error[]=array("php_ftp", true, "Connects PHP to ftp servers");
		if (!extension_loaded('openssl'))				$this->Error[]=array("php_openssl", true, "Connects PHP to secure servers");
		
		if (version_compare(PHP_VERSION, '5.0.0', '<' )) $this->Error[]=array("php version", true, "GameCP requires PHP 5.0 or greater");
		if (version_compare(PHP_VERSION, '5.5.0', '>=' )) $this->Error[]=array("php version", true, "GameCP requires PHP 5.4 or less");
		
		$mv=ini_get('max_input_vars');
		if($mv !='' && $mv <  '1000') $this->Error[]=array("max_input_vars", true, "PHP max_input_vars below 1000");

		if((int)ini_get('register_globals') == 1) $this->Error[]=array("register_globals", true, "Disable PHP register_globals.");

		if (!is_writable($templates_c)) $this->Error[]=array("cache", true, "Unable to write to: $templates_c");
		if (!is_writable($inc_d)) $this->Error[]=array("includes", true, "Unable to write to: $inc_d");
		if (!is_writable($PATH)) $this->Error[]=array("site_path", true, "Unable to write to: $PATH");
		
		$session_path=realpath(session_save_path());
		if ($session_path !='' && (!is_dir($session_path) || !is_writable($session_path))) $this->Error[]=array("session_save_path", true, "Unable to write to: ".$session_path);

		if(count($this->Error) > 0){
			return $this->Error;
		} else return true;
	}


	function RemoveRecursiveDir($directory, $empty=FALSE){
		 if(substr($directory,-1) == '/') $directory = substr($directory,0,-1);
		 if(!file_exists($directory) || !is_dir($directory)) {
			 return FALSE;
		 }elseif(is_readable($directory)){
			$handle = opendir($directory);
			while (FALSE !== ($item = readdir($handle))){
				if($item != '.' && $item != '..'){
					$path = $directory.'/'.$item;
					if(is_dir($path)) {
						$this->RemoveRecursiveDir($path);
					} else unlink($path);
				}
			}
			closedir($handle);
			if($directory !="../includes/cache" && $empty == FALSE){
				if(!rmdir($directory))return FALSE;
			}
		}
		return true;
	}


	function ClearCache(){
		$this->RemoveRecursiveDir("../includes/cache");
		$this->RemoveJSGzip();
	}

	function RemoveJSGzip($basedir="../includes/core/javascript"){
		$this->RemoveFile($basedir."/forms/ajax.js.gz");
		$this->RemoveFile($basedir."/forms/forms.js.gz");
		$this->RemoveFile($basedir."/forms/gcpjs.js.gz");
		$this->RemoveFile($basedir."/jquery/jquery.form.min.js.gz");
		$this->RemoveFile($basedir."/jquery/jquery.min.js.gz");
		$this->RemoveFile($basedir."/jquery/jquery.superfish.min.js.gz");
		$this->RemoveFile($basedir."/jquery/jquery.tablesorter.min.js.gz");
		$this->RemoveFile($basedir."/jquery/jquery.validate.min.js.gz");
		$this->RemoveFile($basedir."/jquery/jquery-ui.min.js.gz");
	}

	function RemoveFile($file){
		if($file != "" && is_file($file)) return @unlink($file);
	}

	function CheckEncryption(){
		require_once("../includes/mysql.inc.php");

		$checkQ=mysql_query("SELECT value FROM settings WHERE name='encrypw' LIMIT 1;");
		return mysql_num_rows($checkQ);
	
	}


	function Update(){
		require_once("../includes/mysql.inc.php");
		$this->ImportMySQL('resources/update.sql', true);
		require_once("resources/update.php");
		$this->ClearCache();
		return true;
	}

	function Install($data){
		$PATH=$this->GetPath();

		$mysql_inc="$PATH/includes/mysql.inc.php";

		if(!$this->CreateMySQLFile($mysql_inc, $data['sqluser'], $data['sqlpass'], $data['sqlhost'], $data['sqldb'])){
			echo "Setup Wizard was unable to write to '$mysql_inc'. Please check the file permissions to ensure the Setup Wizard has access to this file.";
		} else {
			require_once($mysql_inc);
			$this->ImportMySQL('resources/gamecp.sql');			
			$this->InsertData($data);
			mysql_close($conn);
			return "ok";
		}
	}

	function InsertData($data){
		define('path','..');

		require_once("../includes/core/classes/gamecp/class.inc.php");
		$GameCP=new GameCP();
		require_once("../includes/core/classes/mysql/SafeSQL.class.php");
		$safesql = new SafeSQL_MySQL;

		require_once(path.'/includes/core/classes/gamecp/event.inc.php');
		$Event = new Event();
	
		mysql_query("INSERT INTO settings SET name='encrypw', value='1';");
		define("encrypw", "1");

		mysql_query("INSERT INTO `users` SET  
						name='".$data['username']."',
						username='".$data['username']."',
						email='".$data['email']."',
						userlevel='1', active='1', mainadmin='1'") or die("Setup Wizard was unable to create your user." . mysql_error());
		
		$GameCP->SetPassword(mysql_insert_id(), $data['password']);

		mysql_query("UPDATE users SET permissions='a:46:{s:7:\"payment\";s:1:\"1\";s:9:\"donations\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:5:\"taxes\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:10:\"promotions\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:8:\"products\";a:7:{s:4:\"view\";s:1:\"1\";s:3:\"new\";s:1:\"1\";s:10:\"newproduct\";s:1:\"1\";s:8:\"addprice\";s:1:\"1\";s:8:\"newprice\";s:1:\"1\";s:7:\"reorder\";s:1:\"1\";s:12:\"viewpackages\";s:1:\"1\";}s:13:\"productaddons\";a:4:{s:6:\"remove\";s:1:\"1\";s:10:\"removetype\";s:1:\"1\";s:4:\"save\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";}s:8:\"gateways\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:10:\"currencies\";a:7:{s:11:\"updaterates\";s:1:\"1\";s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:17:\"billingcategories\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:6:\"update\";a:2:{s:3:\"run\";s:1:\"1\";s:8:\"download\";s:1:\"1\";}s:12:\"ttcategories\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:5:\"tools\";a:15:{s:6:\"custom\";s:1:\"1\";s:6:\"autoip\";s:1:\"1\";s:12:\"submitautoip\";s:1:\"1\";s:3:\"sql\";s:1:\"1\";s:9:\"submitsql\";s:1:\"1\";s:6:\"backup\";s:1:\"1\";s:8:\"backupv2\";s:1:\"1\";s:4:\"cron\";s:1:\"1\";s:7:\"cleanup\";s:1:\"1\";s:8:\"optimize\";s:1:\"1\";s:12:\"run_optimize\";s:1:\"1\";s:7:\"phpinfo\";s:1:\"1\";s:8:\"phpinfo2\";s:1:\"1\";s:9:\"portcheck\";s:1:\"1\";s:9:\"checkport\";s:1:\"1\";}s:8:\"terminal\";s:1:\"1\";s:8:\"settings\";a:5:{s:4:\"edit\";s:1:\"1\";s:4:\"logs\";s:1:\"1\";s:8:\"testmail\";s:1:\"1\";s:18:\"disableMaintenance\";s:1:\"1\";s:6:\"update\";s:1:\"1\";}s:8:\"schedule\";a:2:{s:6:\"remove\";s:1:\"1\";s:4:\"save\";s:1:\"1\";}s:6:\"portal\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:6:\"orders\";a:8:{s:4:\"edit\";s:1:\"1\";s:3:\"run\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:7:\"pending\";s:1:\"1\";s:5:\"fraud\";s:1:\"1\";s:4:\"paid\";s:1:\"1\";s:5:\"saveq\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";}s:6:\"online\";s:1:\"1\";s:6:\"notify\";a:6:{s:4:\"edit\";s:1:\"1\";s:11:\"sendmasspre\";s:1:\"1\";s:8:\"sendmass\";s:1:\"1\";s:4:\"send\";s:1:\"1\";s:7:\"sendpre\";s:1:\"1\";s:7:\"sendall\";s:1:\"1\";}s:10:\"newservice\";a:2:{s:3:\"new\";s:1:\"1\";s:3:\"add\";s:1:\"1\";}s:4:\"news\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:10:\"newmachine\";a:2:{s:3:\"add\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:8:\"machines\";a:21:{s:4:\"edit\";s:1:\"1\";s:9:\"syncvoice\";s:1:\"1\";s:10:\"updateftpd\";s:1:\"1\";s:11:\"installcron\";s:1:\"1\";s:13:\"updatebackend\";s:1:\"1\";s:9:\"massremip\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:8:\"removeip\";s:1:\"1\";s:8:\"updateip\";s:1:\"1\";s:6:\"update\";s:1:\"1\";s:8:\"addrange\";s:1:\"1\";s:5:\"addip\";s:1:\"1\";s:6:\"editip\";s:1:\"1\";s:6:\"graphs\";s:1:\"1\";s:7:\"migrate\";s:1:\"1\";s:8:\"migrate2\";s:1:\"1\";s:8:\"migrate3\";s:1:\"1\";s:8:\"migrate4\";s:1:\"1\";s:10:\"directions\";s:1:\"1\";s:10:\"viewdetail\";s:1:\"1\";}s:12:\"installgames\";s:1:\"1\";s:11:\"gameupdates\";a:6:{s:6:\"remove\";s:1:\"1\";s:6:\"manage\";s:1:\"1\";s:3:\"run\";s:1:\"1\";s:4:\"view\";s:1:\"1\";s:7:\"addedit\";s:1:\"1\";s:8:\"doupdate\";s:1:\"1\";}s:5:\"games\";a:9:{s:6:\"export\";s:1:\"1\";s:6:\"import\";s:1:\"1\";s:5:\"clone\";s:1:\"1\";s:10:\"removeGame\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"update\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:6:\"emails\";a:9:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:4:\"add2\";s:1:\"1\";s:5:\"edit3\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:3:\"new\";s:1:\"1\";s:8:\"sendtest\";s:1:\"1\";}s:13:\"configbuilder\";a:4:{s:11:\"updateitems\";s:1:\"1\";s:10:\"removeitem\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";}s:8:\"commands\";a:5:{s:3:\"pre\";s:1:\"1\";s:4:\"save\";s:1:\"1\";s:8:\"sendsave\";s:1:\"1\";s:4:\"send\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";}s:6:\"admins\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:6:\"addons\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"clone\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:15:\"addoncategories\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:5:\"voice\";a:11:{s:9:\"removeban\";s:1:\"1\";s:13:\"removeallbans\";s:1:\"1\";s:6:\"addban\";s:1:\"1\";s:9:\"unsuspend\";s:1:\"1\";s:7:\"suspend\";s:1:\"1\";s:9:\"teamspeak\";s:1:\"1\";s:7:\"control\";s:1:\"1\";s:10:\"managevent\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:8:\"savevent\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";}s:8:\"services\";a:17:{s:12:\"taskschedule\";s:1:\"1\";s:12:\"timeschedule\";s:1:\"1\";s:4:\"mass\";s:1:\"1\";s:6:\"fastdl\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:6:\"backup\";s:1:\"1\";s:9:\"saveSched\";s:1:\"1\";s:11:\"deleteSched\";s:1:\"1\";s:10:\"changeuser\";s:1:\"1\";s:9:\"unsuspend\";s:1:\"1\";s:7:\"suspend\";s:1:\"1\";s:14:\"restoreconfigs\";s:1:\"1\";s:8:\"editgame\";s:1:\"1\";s:8:\"addaddon\";s:1:\"1\";s:9:\"addaddon2\";s:1:\"1\";s:8:\"newgame2\";s:1:\"1\";}s:7:\"support\";a:13:{s:10:\"massupdate\";s:1:\"1\";s:6:\"update\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"new\";s:1:\"1\";s:4:\"view\";s:1:\"1\";s:5:\"viewc\";s:1:\"1\";s:9:\"viewreply\";s:1:\"1\";s:10:\"viewactive\";s:1:\"1\";s:3:\"all\";s:1:\"1\";s:14:\"deletetmpfiles\";s:1:\"1\";s:8:\"download\";s:1:\"1\";s:10:\"uploadfile\";s:1:\"1\";}s:4:\"maps\";a:2:{s:7:\"install\";s:1:\"1\";s:9:\"uninstall\";s:1:\"1\";}s:7:\"clients\";a:22:{s:8:\"changepw\";s:1:\"1\";s:13:\"removesubuser\";s:1:\"1\";s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"clone\";s:1:\"1\";s:3:\"new\";s:1:\"1\";s:9:\"updatesub\";s:1:\"1\";s:14:\"editsubaccount\";s:1:\"1\";s:13:\"newsubaccount\";s:1:\"1\";s:6:\"export\";s:1:\"1\";s:6:\"import\";s:1:\"1\";s:13:\"resetpassword\";s:1:\"1\";s:10:\"addsubacct\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:6:\"cancel\";s:1:\"1\";s:8:\"moveuser\";s:1:\"1\";s:5:\"move2\";s:1:\"1\";s:5:\"move3\";s:1:\"1\";s:9:\"swapshell\";s:1:\"1\";s:14:\"viewsubaccount\";s:1:\"1\";}s:9:\"dashboard\";s:1:\"1\";s:5:\"files\";a:14:{s:8:\"download\";s:1:\"1\";s:4:\"wget\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:6:\"upload\";s:1:\"1\";s:9:\"doextract\";s:1:\"1\";s:11:\"quickmanage\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:2:\"cd\";s:1:\"1\";s:6:\"rename\";s:1:\"1\";s:5:\"mkdir\";s:1:\"1\";s:6:\"mkfile\";s:1:\"1\";s:11:\"addshortcut\";s:1:\"1\";s:14:\"removeshortcut\";s:1:\"1\";s:12:\"Save Changes\";s:1:\"1\";}s:7:\"console\";s:1:\"1\";s:12:\"serverstatus\";s:1:\"1\";s:7:\"process\";s:1:\"1\";s:7:\"configs\";a:10:{s:3:\"add\";s:1:\"1\";s:3:\"new\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:7:\"execute\";s:1:\"1\";s:6:\"update\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:11:\"editconfigs\";s:1:\"1\";s:7:\"builder\";s:1:\"1\";s:11:\"builderedit\";s:1:\"1\";s:10:\"builderrun\";s:1:\"1\";}s:10:\"cmdbackend\";a:4:{s:4:\"mass\";s:1:\"1\";s:12:\"submitscreen\";s:1:\"1\";s:7:\"viewlog\";s:1:\"1\";s:11:\"downloadlog\";s:1:\"1\";}s:7:\"billing\";a:2:{s:5:\"print\";s:1:\"1\";s:4:\"view\";s:1:\"1\";}s:7:\"modules\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:6:\"action\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}}' WHERE mainadmin ='1'");

		mysql_query("UPDATE settings SET value='".strtolower($data['style'])."' WHERE name='styleadmin'"); 
		mysql_query("UPDATE settings SET value='".strtolower($data['style'])."' WHERE name='styleclient'"); 
		mysql_query("UPDATE settings SET value='".$data['license']."' WHERE name='gcplickey'"); 

		$sitepath=$this->GetPath();

		if(DIRECTORY_SEPARATOR == '\\'){
			$sitepath=str_replace("\\", "\\\\",$sitepath);
			mysql_query("UPDATE settings SET value='1' WHERE name='webcron'"); 
		}

		$siteurl=explode("/installer", $_SERVER["PHP_SELF"]);

		mysql_query("UPDATE settings SET value='".$sitepath."' WHERE name='path'"); 
		mysql_query("UPDATE settings SET value='".rtrim("http://".$_SERVER['HTTP_HOST'].$siteurl[0], "/")."' WHERE name='url'"); 
		mysql_query("UPDATE settings SET value='".$data['email']."' WHERE name='emailNotify'"); 
		mysql_query("UPDATE settings SET value='".$data['email']."' WHERE name='emailSendFrom'"); 
		mysql_query("UPDATE settings SET value='".$data['email']."' WHERE name='emailSendReply'"); 

	}

	function ImportMySQL($filename, $ignore=FALSE){
	   $lines = file($filename);
	   if(!$lines) return false;
	   
	   $scriptfile = false;

	   foreach($lines as $line){
			$line = trim($line);
			if(!preg_match('/^--/', $line)){
				$scriptfile.=$line;
				if(substr($line, -1) == ";") $scriptfile.=":_GCP_:";
			}
	   }

	   if(!$scriptfile) return false;
	   
	   $queries = explode(':_GCP_:', $scriptfile);

	   foreach($queries as $query){
		 $query = trim($query);

		  if($query == "") { continue; }
		  
		  if($ignore == false){
			  if(!mysql_query($query)){
				echo "<textarea>".$query."</textarea><br><br>";
				die(mysql_error());	
			  }
		  } else mysql_query($query);

	   }
	   
	   return true;
	} 



	function CreateMySQLFile($filename, $user, $pass, $host, $db){

		$this->sql_user=$user;
		$this->sql_pass=$pass;
		$this->sql_host=$host;
		$this->sql_db=$db;

		$user=str_replace('"', '\"', $user);
		$pass=str_replace('"', '\"', $pass);
		$host=str_replace('"', '\"', $host);

		$output = "<?php \n"
		."\$conn = @mysql_connect(\"$host\", \"$user\", \"$pass\") or die (\"Unable to connect to MySQL server.\");\n"
		."@mysql_select_db(\"$db\", \$conn) or die (\"Unable to select MySQL database.\");\n"
		."?>";

		//if(!is_writeable($filename)) return false;
		if (!$handle = fopen($filename, 'w')) return false;
		if (!fwrite($handle, $output)) return false;
		fclose($handle);

		return true;
	}

}
?>
