<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/

if(function_exists("date_default_timezone_set") && function_exists("date_default_timezone_get")) @date_default_timezone_set(@date_default_timezone_get());

if (isset($_REQUEST['debugging'])) {
	error_reporting(2039);
} else error_reporting(0);


require_once("include.inc.php");

$Installer=new Installer();


if(!is_writeable("cache")){
	echo "Unable to write to: ". getcwd()."/cache/";
	exit;
}

require_once('../includes/smarty/libs/Smarty.class.php');

$smarty = new Smarty();
$smarty->config_dir = '../includes/smarty/';
$smarty->plugins_dir = '../includes/smarty/libs/plugins/';
$smarty->template_dir = 'template';
$smarty->compile_dir = 'cache';
$smarty->compile_check = false;
$smarty->debugging = false;
$smarty->force_compile = false;
$smarty->caching = false;
$smarty->cache_lifetime = 120;

if(isset($_REQUEST['mode'])){
	switch($_REQUEST['mode']){
		case "checkValidation":
			$revalidate=$Installer->ValidateInstall();
			if (is_array($revalidate)){
				$smarty->assign("ValidateInstall", $revalidate);
				$smarty->display("errorloop.tpl");
			}
		break;
		case "checkSQL":
			if ($Installer->ValidateMySQL($_POST['host'], $_POST['user'], $_POST['pass'], $_POST['db'])) echo "ok";		
		break;
		case "updateGameCP":
			if($Installer->Update()) echo "ok";
		break;
		case "installGameCP":
			echo $Installer->Install($_REQUEST);
		break;
		case "createsql":
			$smarty->assign("masterip", $Installer->MasterIP());
			$smarty->display("addsql.tpl");
		break;
		case "addsqluser":
			echo $Installer->AddMySQLAccount($_POST['adminsqluser'], $_POST['adminsqlpass'],$_POST['sqlhost'], $_POST['sqluser'], $_POST['sqlpass'], $_POST['sqldb']);
		break;
		case "getpassword":
			echo $Installer->RandomPassword();
		break;
	}
} else {

	if($Installer->CheckMySQL(true)){
		/* upgrade the install */
		$smarty->assign("encrypted", $Installer->CheckEncryption());
		$smarty->assign("doUpgrade", true);
	} else {
		/* brand new install! */
		$self=explode("installer/", $_SERVER["PHP_SELF"]);

		$smarty->assign("doUpgrade", false);
		$smarty->assign("ValidateInstall", $Installer->ValidateInstall());
		$smarty->assign("website", rtrim("http://".$_SERVER['HTTP_HOST'].$self[0], "/"));
		$smarty->assign("masterip", $Installer->MasterIP());
	}

	$smarty->display("header.tpl");
	$smarty->display("main.tpl");
	$smarty->display("footer.tpl");
}

?>