<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/

class Migrate{

	function Start(){
		global $smarty;

		$smarty->assign("serverList", $this->ServerList());
		$smarty->assign("gameList", $this->UserGames());
		$smarty->display("migrate/ssh2x/start.tpl");
	}

	function Step1(){
		global $smarty;

		session_start();
		$_SESSION['gamecp']['error']=array();
		$_SESSION['users']=array();
		$_SESSION['gamecp']['migrate']=array();
		if(isset($_SESSION['exec'])) unset($_SESSION['exec']);
		foreach($this->ServerList() as $s=>$l){
			$_SESSION['gamecp']['migrate'][$l['id']]=array();
			$_SESSION['gamecp']['migrate'][$l['id']]['sid']=$l['sid'];
			$_SESSION['gamecp']['migrate'][$l['id']]['os']=$l['os'];
			$_SESSION['gamecp']['migrate'][$l['id']]['port']=$l['sshport'];
			if(!$l['winport']){
				$l['winport']="240";
				mysql_query("UPDATE servers SET winport='240' WHERE id='".$l['id']."'");
			}
			$_SESSION['gamecp']['migrate'][$l['id']]['backendport']=$l['winport'];
			$_SESSION['gamecp']['migrate'][$l['id']]['passphrase']=$l['passphrase'];
			$_SESSION['gamecp']['migrate'][$l['id']]['status']='pending';
			if(isset($_REQUEST['ubuntu'])){
				$ub=array();
				foreach($_REQUEST['ubuntu'] as $u=>$b) $ub[]=$u;
				if(in_array($l['id'], $ub)){
					$_SESSION['gamecp']['migrate'][$l['id']]['ostype']='ubuntu';
				} else $_SESSION['gamecp']['migrate'][$l['id']]['ostype']='linux';
			}
		}

		foreach($this->UserGames() as $u=>$ug) $_SESSION['users'][]=$ug;
		
		/* mysql fix thangs to bogdan */
		mysql_query("CREATE TABLE `settingstmp` ( `name` varchar( 32 ) NOT NULL ,`value` text ) ENGINE = MyISAM DEFAULT CHARSET = utf8;");
		mysql_query("INSERT INTO `settingstmp` SELECT * FROM `settings`;");
		mysql_query("TRUNCATE `settings`;");
		mysql_query("INSERT INTO `settings` SELECT name, value FROM `settingstmp` group by lower(name);");
		mysql_query("DROP TABLE `settingstmp`;");
		mysql_query("ALTER TABLE `settings` ADD PRIMARY KEY ( `name` ) ;");


		$smarty->display("migrate/ssh2x/step1.tpl");
	}

	function GetStatus(){
		$id=$_SESSION['exec']['id'];
		$status=$this->GetScreen();
		if($status[0] == ""){
			$_SESSION['exec']['status']="stop";
			if(preg_match("/GameCP Remote Service/s", $status[1])){ 
				if($this->ValidateRemote()){
					$_SESSION['exec']['status']="migrate";
				} else $_SESSION['gamecp']['error'][]="Server #$id: remote was installed but cannot be connected to";
			} else $_SESSION['gamecp']['error'][]="Server #$id: remote was installed but failed to start<blockquote>$status[1]</blockquote>";
		}
	}

	function Step2(){
		session_start();
		// when done add a session check to make sure you cant re-run this
		if(isset($_SESSION['gamecp']['migrate'])){
			if(isset($_SESSION['exec'])){
				$id=$_SESSION['exec']['id'];
				$serverInfo=$_SESSION['gamecp']['migrate'][$id];

				switch($_SESSION['exec']['status']){
					case "start":
						echo "Installing server #$id";
						$_SESSION['exec']['status']="run";
						$this->UpdateGameCP($id);
					break;

					case "run":
						echo "Installing server #$id...";
						$this->GetStatus();
					break;

					case "migrate":
						echo "Migrating server #$id...";
						$this->UpdateServices();
					break;


					case "stop":
						echo "Migration of Server #$id completed";
						$this->CleanScreen();
						unset($_SESSION['exec'], $_SESSION['gamecp']['migrate'][$id]);
					break;
				}
			} else {
				// were not running a migrate so lets scan the list for the first pending
				if(is_array($_SESSION['gamecp']['migrate']) && count($_SESSION['gamecp']['migrate']) > 0){
					echo "Selecting server to migrate...";
					foreach($_SESSION['gamecp']['migrate'] as $s=>$l){
						if($l['status']=='pending'){
							$_SESSION['exec']['id']=$s;
							$_SESSION['exec']['status']="start";
							break;
						}
					}
				} else {
					if(count($_SESSION['gamecp']['error']) > 0){
						echo "error";
					} else echo "completed";
				}
			} 
		} else echo "error";
	}

	function UpdateServices(){
		require_once("../includes/core/classes/backend/class.inc.php");
		$Backend=new Backend();
		if(count($_SESSION['users']) == 0){
			$_SESSION['exec']['status']="stop";
		} else {
			foreach($_SESSION['users'] as $u=>$ug){
				$premode=$ug['premode'];
				$ugid=$ug['ugid'];
				$ip=$ug['ip'];
				$port=$ug['port'];
				$startmode=$ug['sci'];
				$name=$ug[0];
				$install=$ug['install'];
				$id=$_SESSION['exec']['id'];
				$sid=$_SESSION['gamecp']['migrate'][$id]['sid'];
				$server_port=$_SESSION['gamecp']['migrate'][$id]['port'];

				$this->ExecSSH("\"pkill -u $name ; rm -f /home/$name/.screenrc* /home/$name/screenlog*\"");

				$this->ExecCommand("addserver:_:$ugid", $name);

				$premode=str_replace("cd $ip-$port ;", "", $premode);
				$premode=str_replace("cd $ip-$port;", "", $premode);
				$premode=str_replace("cd $ugid ;", "", $premode);
				$premode=str_replace("cd $ugid;", "", $premode);
				$premode=str_replace("cd $install ;", "", $premode);
				$premode=str_replace("cd $install;", "", $premode);
				$premode=str_replace("cd $install", "", $premode);
				$premode=str_replace("/orangebox/", "cd orangebox", $premode);
				$premode=str_replace("/orangebox", "cd orangebox", $premode);
				$premode=str_replace('  ', ' ', $premode);
				$premode=trim($premode);
				$startmode=rtrim(str_replace('STARTMODE="', '', $startmode), '"');

				echo "<br><dd>Updating Service #$ugid<br>";
				mysql_query("UPDATE usergames SET premode='$premode', sci='$startmode' WHERE id='$ugid';");
				if($ug['active'] == "1") $this->ControlServer($ugid);
				
				unset($_SESSION['users'][$u]);
				break;
			}
		}
	}

	function ControlServer($id){
		global $GameCP;

		$GameCP->loadIncludes('control');
		$Control=new Control();
		$Control->Usergame($id, "stop", false, true);
		$Control->Usergame($id, "start", false, true);
	}

	function Step3(){
	}

	function Completed(){
		global $smarty;
		$smarty->display("migrate/completed.tpl");
	}

	function Failed(){
		global $smarty;
		session_start();
		$smarty->assign("error", $_SESSION['gamecp']['error']);
		$smarty->display("migrate/failed.tpl");
	}

	function CheckRemote(){
		$maindir=$this->GetSetting('maindir');
		$id=$_SESSION['exec']['id'];
		$sid=$_SESSION['gamecp']['migrate'][$id]['sid'];
		$key="$maindir/primary/$sid";
		$_SESSION['gamecp']['migrate'][$id]['key']=$key;
		if(is_file($key)){
			if($this->CheckRemoteKey()){
				return true;
			} else return false;
		} else return false;
	}

	function CheckRemoteKey(){
		$id=$_SESSION['exec']['id'];
		$sid=$_SESSION['gamecp']['migrate'][$id]['sid'];
		$key=$_SESSION['gamecp']['migrate'][$id]['key'];
		if(trim($this->ExecSSH('"whoami"')) != "root"){
			return false;
		} else return true;
	}

	function CleanScreen(){
		$id=$_SESSION['exec']['id'];
		$this->ExecSSH("\"rm -f /root/migrate$id.log /root/.screenrc.migrate$id\"");
	}

	function GetScreen(){
		$id=$_SESSION['exec']['id'];

		$screenStatus=$this->ExecSSH("\"screen -wipe > /dev/null ; screen -list | grep migrate$id | awk -F . '{ print $1 }' | sed -e s/.//\"");
		$screenLog=$this->ExecSSH("\"tail -n 100 /root/migrate$id.log\"");

		return array(trim($screenStatus), $screenLog);
	}

	function ExecSSH($cmd){
		$id=$_SESSION['exec']['id'];
		$sid=$_SESSION['gamecp']['migrate'][$id]['sid'];
		$port=$_SESSION['gamecp']['migrate'][$id]['port'];
		$key=$_SESSION['gamecp']['migrate'][$id]['key'];
		$cmd="ssh -i $key -o NumberOfPasswordPrompts=0 -o ConnectTimeout=2 -o PasswordAuthentication=no -o StrictHostKeyChecking=no -p $port root@$sid $cmd";
		//echo "<textarea>".$cmd."</textarea><br>";
		return shell_exec($cmd);
	}

	function InstallRemote(){

		$id=$_SESSION['exec']['id'];

		$screenlog="/root/.screenrc.migrate$id";

		$screendir="\"echo logfile /root/migrate$id.log > $screenlog\"";
		$this->ExecSSH($screendir);
		$screendir="\"echo log on >> $screenlog\"";
		$this->ExecSSH($screendir);

		$cmd=addslashes($this->InstallDirections());
		$cmd="'screen -c $screenlog -mdLS migrate$id bash -c \"$cmd\"'";
		$results=$this->ExecSSH($cmd);
	}

	function InstallDirections(){
		$id=$_SESSION['exec']['id'];
		$sid=$_SESSION['gamecp']['migrate'][$id]['sid'];
		$port=$_SESSION['gamecp']['migrate'][$id]['backendport'];
		$passphrase=$_SESSION['gamecp']['migrate'][$id]['passphrase'];
		$ostype=$_SESSION['gamecp']['migrate'][$id]['ostype'];

		if(!$passphrase){
			$passphrase=$this->RandomPassword();
			mysql_query("UPDATE servers SET passphrase='".$passphrase."' WHERE id='".$id."'");
		}
		

		switch($_SESSION['gamecp']['migrate'][$_SESSION['exec']['id']]['os']){
			case "0":
$result="cd /usr/local/gcp;";
if($ostype == "ubuntu"){
$result.="wget http://gamecp.com/get/from/this/mirror/GameCP-Remote-Ubuntu.tar.gz ;
tar zxvf GameCP-Remote-Ubuntu.tar.gz ; rm -f GameCP-Remote-Ubuntu.tar.gz ;";
}else $result.="wget http://gamecp.com/get/from/this/mirror/GameCP-Remote-Linux.tar.gz ;
tar zxvf GameCP-Remote-Linux.tar.gz ; rm -f GameCP-Remote-Linux.tar.gz ;";
	
$result.="chmod +x ./gamecp bin32/gamecp_i386 bin32/update.bin bin64/gamecp_x64 bin64/update.bin ;";

$result.="
if [ ! -f /etc/init.d/gamecp ] ; then cp -f gamecp /etc/init.d/gamecp; fi;
chkconfig --add gamecp ; chkconfig --level 3 gamecp on ;
cat > /usr/local/gcp/gamecp.ini <<DELIM
mysql_host=$databaseip
mysql_user=$dbuser
mysql_pass=$dbpass
mysql_database=$db
serverid=$id
passphrase=$passphrase
debug=off
listenport=$port
user_group=default
DELIM
if [ -f /sbin/iptables ] ; then  iptables -I INPUT -p tcp --dport $port -j ACCEPT; iptables -I INPUT -p udp --dport $port -j ACCEPT; iptables-save; fi ;
grep \"/sbin/nologin\" /etc/shells > /dev/null ; if [ \$? -eq 1 ] ; then echo \"/sbin/nologin\" >> /etc/shells; fi ;
/etc/init.d/gamecp start";
			break;

			case "2":
$result="cd /usr/local/gcp ; 
wget http://gamecp.com/get/from/this/mirror/GameCP-Remote-FreeBSD.tar.gz ;
tar zxvf GameCP-Remote-FreeBSD.tar.gz ; rm -f GameCP-Remote-FreeBSD.tar.gz ;
chmod +x ./gamecp bin32/gamecp_i386 bin32/update.bin bin64/gamecp_x64 bin64/update.bin ;";

$result.="
if [ ! -f /etc/rc.d/gamecp ] ; then cp -f gamecp /etc/rc.d/gamecp; fi;
grep \"GameCP_enable\" /etc/rc.conf > /dev/null ; if [ \$? -eq 1 ]; then echo GameCP_enable=\\\"YES\\\" >> /etc/rc.conf; fi ;
cat > /usr/local/gcp/gamecp.ini <<DELIM
mysql_host=$databaseip
mysql_user=$dbuser
mysql_pass=$dbpass
mysql_database=$db
serverid=$id
passphrase=$passphrase
debug=off
listenport=$port
user_group=default
DELIM
if [ -f /sbin/iptables ] ; then  iptables -I INPUT -p tcp --dport $port -j ACCEPT; iptables -I INPUT -p udp --dport $port -j ACCEPT; iptables-save; fi ;
grep \"/sbin/nologin\" /etc/shells > /dev/null ; if [ \$? -eq 1 ] ; then echo \"/sbin/nologin\" >> /etc/shells; fi ;
/etc/rc.d/gamecp start";
			break;
		}
		return $result;
	}

	
	function ExecCommand($command, $name=FALSE){
		global $GameCP;
		$id=$_SESSION['exec']['id'];
		$sid=$_SESSION['gamecp']['migrate'][$id]['sid'];
		$backendport=$_SESSION['gamecp']['migrate'][$id]['backendport'];

		$GameCP->loadIncludes('backend');
		$Backend=new Backend();

		return $Backend->QueryResponse($sid, '', $command, $name);
	}

	function ValidateRemote(){
		$result=$this->ExecCommand("version");
		$res=explode(".", $result);
		if (is_array($res) && count($res) == 4){
			return true;
		} else return false;
	}

	function UpdateGameCP($id){
		if($this->CheckRemote()){
			$this->InstallRemote();
		} else $_SESSION['gamecp']['error'][]="Server #$id: could not connect using server key file";
		return true;
	}


	/* These functions pull the data from GameCP */
	function RandomPassword() { 
		$salt = "_abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890"; 
		srand((double)microtime()*1000000);  
		$i = 0; 
		while ($i < 10) {  // change for other length
			$num = rand() % 33; 
			$tmp = substr($salt, $num, 1); 
			@$pass = $pass . $tmp; 
			$i++; 
		} 

		return strip_tags($pass);
	} 

	function ServerList(){
		$row=array();
		$q=mysql_query("SELECT * FROM servers WHERE os !='1'");
		while($a=mysql_fetch_array($q)) $row[]=$a;
		return $row;
	}

	function UserGames(){
		$row=array();
		$q=mysql_query("SELECT users.name, usergames.*, game.install, usergames.id as 'ugid' FROM users, usergames, servers, iptable, game WHERE game.id = usergames.gid AND servers.os !='1' AND users.id = usergames.cid AND servers.sid=iptable.sid AND iptable.ip=usergames.ip");
		while($a=mysql_fetch_array($q)) $row[]=$a;
		return $row;
	}
	
	function GetSetting($setting){
		$maindirQ=mysql_query("SELECT value FROM settings WHERE name='$setting'");
		$maindir=mysql_fetch_array($maindirQ);
		return $maindir[0];
	}
}

?>