CREATE TABLE IF NOT EXISTS `module_settings` (
  `pid` int(128) NOT NULL,
  `module` varchar(128) NOT NULL default '',
  `setting` varchar(128) NOT NULL default '',
  `value` longtext NULL
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci ;

CREATE TABLE IF NOT EXISTS `module_services` (
  `id` int(2) NOT NULL auto_increment,
  `date` varchar(128) NOT NULL default '',
  `customfields` longtext NULL,
  `customfieldsog` longtext NULL,
  `pid` int(128) NOT NULL,
  `cid` int(128) NOT NULL,
  `qid` int(128) NOT NULL,
  `notes` longtext NULL,
  `status` varchar(128) NOT NULL default '',
  `ip` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `donations` (
  `id` int(2) NOT NULL auto_increment,
  `cid` varchar(128) NOT NULL default '',
  `gateway` varchar(128) NOT NULL default '',
  `gross` varchar(128) NOT NULL default '',
  `paid` varchar(128) NOT NULL default '',
  `fee` varchar(128) NOT NULL default '',
  `transactionid` varchar(128) NOT NULL default '',
  `status` varchar(128) NOT NULL default '',
  `ipaddr` varchar(128) NOT NULL default '',
  `email` varchar(128) NOT NULL default '',
  `date` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `promotions` (
  `id` int(11) NOT NULL auto_increment,
  `active` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `expire` varchar(255) NOT NULL,
  `value` varchar(255) NOT NULL,
  `type` varchar(255) NOT NULL,
  `products` text NOT NULL,
  `totaluses` int(11) NOT NULL,
  `oneperuser` int(11) NOT NULL,
  `existinguser` int(11) NOT NULL,
  `newuser` int(11) NOT NULL,
  `location` text NOT NULL,
  `recurring` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `promotionsuse` (
  `pmid` int(11) NOT NULL,
  `cid` int(11) NOT NULL
) ENGINE = MyISAM ;

CREATE TABLE IF NOT EXISTS `emailqueue` (
  `id` int(120) NOT NULL auto_increment,
  `content` longtext NOT NULL,
  `subject` varchar(128) NOT NULL default '',
  `time` varchar(128) NOT NULL default '',
  `user` varchar(128) NOT NULL default '',
  `effected` varchar(128) NOT NULL default '',
  `queue` int(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `cron` (
`task` VARCHAR( 255 ) NOT NULL ,
`time` VARCHAR( 255 ) NOT NULL 
) ENGINE = MyISAM CHARACTER SET utf8 COLLATE utf8_general_ci ;


--
-- Table structure for table `addongames`
--

CREATE TABLE IF NOT EXISTS `addongames` (
  `id` int(128) NOT NULL auto_increment,
  `aid` int(128) NOT NULL,
  `gid` int(128) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `addongames`
--


-- --------------------------------------------------------

--
-- Table structure for table `addons`
--

CREATE TABLE IF NOT EXISTS `addons` (
  `id` int(5) NOT NULL auto_increment,
  `gmid` int(5) default NULL,
  `installfile` varchar(128) default NULL,
  `name` varchar(128) NOT NULL,
  `command` longtext,
  `updatecommandline` longtext,
  `uninstallcommandline` longtext,
  `adminonly` varchar(128) default NULL,
  `category` int(5) NULL default '0',
  `notes` text,
  `wincommand` longtext,
  `winupdatecommandline` longtext,
  `winuninstallcommandline` longtext,
  `doupdate` int(1) NOT NULL default '1',
  `doinstall` int(1) NOT NULL default '1',
  `douninstall` int(1) NOT NULL default '1',
  `doenable` int(1) NOT NULL default '1',
  `dodisable` int(1) NOT NULL default '1',
  `enablecmdline` longtext,
  `winenablecmdline` longtext,
  `disablecmdline` longtext,
  `windisablecmdline` longtext,
  `winexeccmd` longtext,
  `execcmd` longtext,
  `restart` int(1) NOT NULL default '0',
  `doexecute` int(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `addons`
--


-- --------------------------------------------------------

--
-- Table structure for table `billing`
--

CREATE TABLE IF NOT EXISTS `billing` (
  `id` int(4) NOT NULL auto_increment,
  `cid` int(12) NOT NULL default '0',
  `date` varchar(10) NOT NULL default '',
  `status` varchar(10) NOT NULL default '',
  `gross` varchar(20) NOT NULL default '',
  `fee` varchar(20) NOT NULL default '',
  `update` int(1) NOT NULL default '0',
  `daystill` int(4) NOT NULL default '0',
  `emailsent` int(2) NOT NULL default '0',
  `subscr_id` text NOT NULL,
  `suspend` int(1) default '1',
  `promo` text,
  `services` text,
  `taxes` text,
  `taxtotal` varchar(20) NOT NULL default '',
  KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `billing`
--


-- --------------------------------------------------------

--
-- Table structure for table `charges`
--

CREATE TABLE IF NOT EXISTS `charges` (
  `id` int(2) NOT NULL auto_increment,
  `date` varchar(25) NOT NULL default '',
  `sum` varchar(25) NOT NULL default '',
  `reason` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `charges`
--


-- --------------------------------------------------------

--
-- Table structure for table `cmdcenter`
--

CREATE TABLE IF NOT EXISTS `cmdcenter` (
  `id` int(4) NOT NULL auto_increment,
  `cmd` longtext NOT NULL,
  `name` varchar(128) NOT NULL default '',
  `ulevel` int(1) NOT NULL default '0',
  `os` int(1) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `cmdcenter`
--


-- --------------------------------------------------------

--
-- Table structure for table `denyextensions`
--

CREATE TABLE IF NOT EXISTS `denyextensions` (
  `deny` varchar(128) NOT NULL
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;

--
-- Dumping data for table `denyextensions`
--


-- --------------------------------------------------------

--
-- Table structure for table `denyfiles`
--

CREATE TABLE IF NOT EXISTS `denyfiles` (
  `deny` varchar(128) NOT NULL
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;

--
-- Dumping data for table `denyfiles`
--

INSERT INTO `denyfiles` (`deny`) VALUES
('screenl'),
('.qmail'),
('Maildir'),
('.kde'),
('.canna'),
('.screen'),
('.ssh'),
('.xemacs'),
('.zshrc'),
('.emacs'),
('.bash_p'),
('.bashrc'),
('.gtkrc'),
('.bash_l'),
('.bash_h'),
('.'),
('..'),
('scontro'),
('.screenrc'),
('.mozilla'),
('.wine'),
('end\r\n'),
('.steam');

-- --------------------------------------------------------

--
-- Table structure for table `denyupload`
--

CREATE TABLE IF NOT EXISTS `denyupload` (
  `deny` varchar(128) NOT NULL
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;

--
-- Dumping data for table `denyupload`
--

INSERT INTO `denyupload` (`deny`) VALUES
('exe'),
('run'),
('bat'),
('batch'),
('sh');

-- --------------------------------------------------------

--
-- Table structure for table `denyusers`
--

CREATE TABLE IF NOT EXISTS `denyusers` (
  `deny` varchar(128) NOT NULL
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;

--
-- Dumping data for table `denyusers`
--

INSERT INTO `denyusers` (`deny`) VALUES
('admin'),
('root'),
('test'),
('apache'),
('nobody'),
('www-data'),
('no'),
('bin'),
('daemon'),
('adm'),
('lp'),
('sync'),
('shutdown'),
('halt'),
('mail'),
('news'),
('uucp'),
('operator'),
('games'),
('gopher'),
('dbus'),
('vcsa'),
('rpm'),
('haldaemon'),
('pcap'),
('nscd'),
('named'),
('netdump'),
('sshd'),
('rpc'),
('mysql'),
('vent');

-- --------------------------------------------------------

--
-- Table structure for table `emails`
--

CREATE TABLE IF NOT EXISTS `emails` (
  `id` int(2) NOT NULL auto_increment,
  `title` text NOT NULL,
  `subject` text NOT NULL,
  `body` text NOT NULL,
  `sms` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `emails`
--

INSERT INTO `emails` (`id`, `title`, `subject`, `body`, `sms`) VALUES
(1, 'Billing-Due', '$domain - You have an invoice due today.', '<p>Hello $UserFirstName<br /><br />This is the Automated Notification System at $domain .<br />This e-mail is to inform you that your bill is due today.<strong><br /><br />Bill Invoice #$BillId<br /></strong>Your total bill amount is: $currency$BillGross<br />Your bill status is: $BillStatus<strong><br /><br />Invoice Description:</strong><br />$BillDetails</p>\r\n<p>You can pay your bill online by logging into your account at: $url</p>\r\n<p><strong>Payment Instructions:</strong></p>\r\n<ol>\r\n<li>Login to the control panel at $url</li>\r\n<li>Locate your bill invoice #$BillId from the Billing interface</li>\r\n<li>Select a Payment method on the bill</li>\r\n<li>Complete payment on the invoice</li>\r\n</ol>\r\n<p>Note: This e-mail will serve as an official invoice for this payment.</p>\r\n<hr />\r\n<p>If you have any questions please contact us.</p>\r\n<p>Thank you<br /> - $domain</p>', ''),
(2, 'User-Suspended', '$domain - Your account has been suspended.', '<p>Hello $UserFirstName</p>\n<p>This is the Automated Notification System at $domain .</p>\n<p>This e-mail is to inform you that your account has been suspended.</p>\n<p>Please contact us if you would like your account restored.</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<hr />\n<p>Thank you<br /> - $domain</p>\n<p>&nbsp;</p>', ''),
(3, 'Server Information.', '$domain - Your Account Information', '<p>Hello $UserFirstName</p>\n<p>This e-mail contains important account information.</p>\n<p>Please review your account details below:</p>\n<hr />\n<p>User Name: $UserCPName<br />User Password: $UserPassword<br />Control Panel: $url</p>\n<p>$UserGameInfo<br />$UserVoiceInfo</p>\n<hr />\n<p>If you have any questions about your account information please contact us.<br /><br />Thank you<br />- $domain</p>', ''),
(4, 'Billing-Pre', '$domain - Your invoice is due in $BillDaysTill days.', '<p>Hello $UserFirstName<br /><br />This is the Automated Notification System at $domain .<br />This e-mail is to inform you that your bill is due in $BillDaysTill  days.<strong><br /><br />Bill Invoice #$BillId<br /></strong>Your total bill amount is: $currency$BillGross<br />Your bill status is: $BillStatus<strong><br /><br />Invoice Description:</strong><br />$BillDetails</p>\r\n<p>You can pay your bill online by logging into your account at: $url</p>\r\n<p><strong>Payment Instructions:</strong></p>\r\n<ol>\r\n<li>Login to the control panel at $url</li>\r\n<li>Locate your bill invoice #$BillId from the Billing interface</li>\r\n<li>Select a Payment method on the bill</li>\r\n<li>Complete payment on the invoice</li>\r\n</ol>\r\n<p>Note: This e-mail will serve as an official invoice for this payment.</p>\r\n<hr />\r\n<p>Thank you<br /> - $domain</p>', ''),
(5, 'Billing-Past', '$domain - You have a past due invoice.', '<p>Hello $UserFirstName<br /><br />This is the Automated Notification System at $domain .<br />This e-mail is to inform you that your bill is due $BillDaysTill  days ago.<strong><br /><br />Bill Invoice #$BillId<br /></strong>Your total bill amount is: $currency$BillGross<br />Your bill status is: $BillStatus<strong><br /><br />Invoice Description:</strong><br />$BillDetails</p>\r\n<p>You can pay your bill online by logging into your account at: $url</p>\r\n<p><strong>Payment Instructions:</strong></p>\r\n<ol>\r\n<li>Login to the control panel at $url</li>\r\n<li>Locate your bill invoice #$BillId from the Billing interface</li>\r\n<li>Select a Payment method on the bill</li>\r\n<li>Complete payment on the invoice</li>\r\n</ol>\r\n<p>Note: This e-mail will serve as an official invoice for this payment.</p>\r\n<hr />\r\n<p>&nbsp;</p>\r\n<p>If you have any questions please contact us.</p>\r\n<p>Thank you<br /> - $domain</p>', ''),
(6, 'Tech-NewTicket', '[Ticket: $Var3] $subject', '<p>Hello $UserFirstName</p>\n<p><strong><br />Your support ticket has been received!</strong></p>\n<p>You can view the ticket at any time&nbsp; @ $url/system/tt.php?mode=edit&amp;tid=$Var3</p>\n<p>Please allow up to 24 hours Monday-Friday for a reply.</p>\n<p>&nbsp;</p>\n<hr />\n<p>Ticket ID: $Var3<br />Category: $Var1<br />Subject: $subject<br />Status: $status</p>\n<p>&nbsp;</p>', ''),
(7, 'Manager-NewUser', '$domain - A new user has been added, $UserCPName', '<p>Hello $UserFirstName</p>\r\n<p>This is the Automated Notification System at $domain .</p>\r\n<p><strong>The following user has been added: </strong>$UserCPName</p>\r\n<p>Please login to: $url  To view the changes.</p>\r\n<hr />\r\n<p>Thank you<br /> - $domain</p>', ''),
(8, 'Tech-ReplyTicket', '[Ticket: $Var3] $subject', '<p>$Var2</p>\n<p>&nbsp;</p>\n<hr />\n<p>Ticket ID: #$Var3<br /> Subject: $subject<br />Status: $status<br /> Ticket URL: <a href="$url/system/tt.php?mode=edit&amp;tid=$Var3" target="_blank">$url/system/tt.php?mode=edit&amp;tid=$Var3</a></p>\n<p>&nbsp;</p>', ''),
(9, 'Tech-NoBranding', '$domain - Your servers branding is missing.', '<p>Hello $UserFirstName</p>\n<p>This is the Automated Notification System at $domain .</p>\n<p>This message was sent to notify you that the server has automatically been disabled. Please add the proper branding to your servers hostname.</p>\n<p>You can login at: $url<br />Username: $UserCPName</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<hr />\n<p>Thank you<br /> - $domain</p>\n<p>&nbsp;</p>', ''),
(10, 'Subuser-create', '$domain - Your Account Information', '<p>Hello $UserFirstName</p>\n<p>This e-mail contains important account information.</p>\n<p>Please review your account details below:</p>\n<hr />\n<p>User Name: $UserCPName<br />User Password: $UserPassword<br />Control Panel: $url</p>\n<p>&nbsp;</p>\n<hr />\n<p>If you have any questions about your account information please contact us.<br /><br />Thank you<br />- $domain</p>', ''),
(11, 'User-ReplyTicket', '[Ticket: $Var3] $subject', '<p><strong>Your ticket reply was received.</strong></p>\n<p>Please allow up to 24 hours Monday-Friday for a reply.</p>\n<p>&nbsp;</p>\n<p>\n<hr style="width: 100%;" />\n<br />$Var2</p>\n<hr />\n<p>Ticket ID: $Var3<br />Category: $Var1<br />Subject: $subject<br /> Status: $status<br /> Ticket URL: <span style="color: #888888;"><a href="$url/system/tt.php?mode=edit&amp;tid=$Var3" target="_blank">$url/system/tt.php?mode=edit&amp;tid=$Var3</a></span></p>\n<p>&nbsp;</p>', ''),
(12, 'Tech-Slots-Exceeded', '$domain - You have exceeded your maximum player limit.', '<p>Hello $UserFirstName</p>\n<p>This is the Automated Notification System at $domain .</p>\n<p>This message was sent to notify you that the server has automatically been disabled.</p>\n<p>You can login at: $url<br />Username: $UserCPName</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<hr />\n<p>Thank you<br /> - $domain</p>\n<p>&nbsp;</p>', ''),
(13, 'Tech-ServerDown', '$domain - A server is down,  $UserCPName $Var1', '<p>Hello $UserFirstName</p>\r\n<p>This is the Automated Notification System at $domain .</p>\r\n<p>The following user has a crashed server: $UserCPName</p>\r\n<p><strong>This server is located at:</strong> $Var1</p>\r\n<p>&nbsp;</p>\r\n<p>&nbsp;</p>\r\n<hr />\r\n<p>Thank you<br /> - $domain</p>\r\n<p>&nbsp;</p>', 'Message From $domain  \r\n\r\nThe following user has a crashed server:\r\n$UserCPName\r\n\r\nThis server is located at:\r\n$Var1\r\n\r\nThank you.'),
(14, 'Tech-Non-private-private', '$domain - $Var3 is not private', '<p>Hello $UserFirstName</p>\r\n<p>This is the Automated Notification System at $domain .</p>\r\n<p>The following user has a non-private server: $Var1</p>\r\n<p>This server is located at: $Var2</p>\r\n<p>The Automated Server Status System reports that the server has a status of non-private but is marked in the system as a private server.</p>\r\n<p>Please manually correct then restart the server.  You can login at:</p>\r\n<p>&nbsp;</p>\r\n<p>&nbsp;</p>\r\n<hr />\r\n<p>Thank you<br /> - $domain</p>\r\n<p>&nbsp;</p>', ''),
(15, 'Lost-Password', '$domain - Your password has been reset.', '<p>Hello $UserFirstName</p>\n<p>This is the Automated Notification System at $domain .</p>\n<p>This email contains important account information from the Automated Notification System at $domain.</p>\n<p>Please do not send this e-mail to anyone you do not want to have access to your services.</p>\n<p><strong>Your new&nbsp; password is:</strong> $Var1<br /></p>\n<hr />\n<p>If you have any questions or problems please contact us.</p>\n<p>Thank you<br />- $domain</p>', ''),
(16, 'Tech-Time-Exceeded', '$domain - Your game servers time has expired!', '<p>Hello $UserFirstName</p>\n<p>This is the Automated Notification System at $domain .</p>\n<p>This message was sent to notify you that the server has automatically been disabled.</p>\n<p>You can login at: $url<br />Username: $UserCPName</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<hr />\n<p>Thank you<br /> - $domain</p>\n<p>&nbsp;</p>', ''),
(17, 'Billing-Add', '$domain - A bill has been created', '<p>Hello $UserFirstName<br /><br />This is the Automated Notification System at $domain .<br />This e-mail is to inform you that a new bill has been added to your account<br /><strong><br />Bill Invoice #$BillId<br /></strong>Your total bill amount is: $currency$BillGross<br />Your bill status is: $BillStatus<strong><br /><br />Invoice Description:</strong><br />$BillDetails</p>\r\n<p>You can pay your bill online by logging into your account at: $url</p>\r\n<p><strong>Payment Instructions:</strong></p>\r\n<ol>\r\n<li>Login to the control panel at $url</li>\r\n<li>Locate your bill invoice #$BillId from the Billing interface</li>\r\n<li>Select a Payment method on the bill</li>\r\n<li>Complete payment on the invoice</li>\r\n</ol>\r\n<p>Note: This e-mail will serve as an official invoice for this payment.</p>\r\n<hr />\r\n<p>If you have any questions please contact us.</p>\r\n<p>Thank you<br /> - $domain</p>', ''),
(18, 'Lost-PasswordReset', '$domain - Reset your lost password.', '<p>Hello $UserFirstName</p>\n<p>This is the Automated Notification System at $domain .</p>\n<p>A user from $Var2 has requested that your password be reset.</p>\n<p><strong>Click the following URL to reset your password:</strong> $Var1</p>\n<hr />\n<p>If you have any questions or problems please contact us.</p>\n<p>Thank you<br />- $domain</p>', ''),
(19, 'User-Unsuspended', '$domain - Your account has been un-suspended.', '<p>Hello $UserFirstName</p>\n<p>This is the Automated Notification System at $domain .</p>\n<p>This e-mail is to inform you that your account has been un-suspended.</p>\n<p>Please contact us if you would like your account restored.</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<hr />\n<p>Thank you<br /> - $domain</p>\n<p>&nbsp;</p>', ''),
(20, 'Service-Suspended', '$domain - Service #$Var1 has been suspended', '<p>Hello $UserFirstName</p>\n<p>This is the Automated Notification System at $domain .</p>\n<p>This e-mail is to inform you that a service #$Var1 has been suspended.</p>\n<p>$Var1</p>\n<p>$BillId</p>\n<p>&nbsp;</p>\n<hr />\n<p>Thank you<br /> - $domain</p>\n<p>&nbsp;</p>', ''),
(21, 'Service-Unsuspended', '$domain - Service #$Var1 has been un-suspended', '<p>Hello $UserFirstName</p>\n<p>This is the Automated Notification System at $domain .</p>\n<p>This e-mail is to inform you that a service has been un-suspended.</p>\n<p>Please contact us if you would like your account restored.</p>\n<p>$Var1</p>\n<p>&nbsp;</p>\n<hr />\n<p>Thank you<br /> - $domain</p>\n<p>&nbsp;</p>', ''),
(22, 'ContactUs', '$domain - Contact form submission', '<p>You have been contacted from your control panel.</p>\n<p><strong>Name</strong>: $cname</p>\n<p><strong>E-mail</strong>: $cemail</p>\n<p><strong>Notes</strong>: $cnotes</p>', ''),
(23, 'Service-Moved', '$domain - Service #$Var2 has been moved', '<p>Hello $UserFirstName</p>\n<p>This is the Automated Notification System at $domain .</p>\n<p>This e-mail is to inform you that a service #$Var2 has been moved.</p>\n<p>Please contact us if you have any problems.</p>\n<p><strong>New address</strong>: $Var1</p>\n<p>&nbsp;</p>\n<hr />\n<p>Thank you<br /> - $domain</p>\n<p>&nbsp;</p>', ''),
(24, 'Payment-Failed', '$domain - Payment Failed  $Var1 #$Var2', '<p>Hello $UserFirstName<br /><br />This is the Automated Notification System at $domain .<br /><strong><br /><br />Payment Failed</strong></p>\n<p>$Var1: #$Var2<strong><br /></strong>Payment amount: $currency$Payment<br /><strong><br /><br /></strong></p>\n<p>You can view your bill online by logging into your account at: $url</p>\n<p>&nbsp;</p>\n<hr />\n<p>Thank you<br /> - $domain</p>', ''),
(25, 'Payment-Pending', '$domain - Payment Pending  $Var1 #$Var2', '<p>Hello $UserFirstName<br /><br />This is the Automated Notification System at $domain .<br /><strong><br /><br />Payment Pending</strong></p>\n<p>$Var1: #$Var2<strong><br /></strong>Payment amount: $currency$Payment<br /><strong><br /><br /></strong></p>\n<p>You can view your bill online by logging into your account at: $url</p>\n<p>&nbsp;</p>\n<hr />\n<p>Thank you<br /> - $domain</p>', ''),
(26, 'Payment-Completed', '$domain - Payment Completed $Var1 #$Var2', '<p>Hello $UserFirstName<br /><br />This is the Automated Notification System at $domain .<br /><strong><br /><br />Payment Received</strong></p>\n<p>$Var1: #$Var2<strong><br /></strong>Payment amount: $currency$Payment<br />Bill status: $Status<strong><br /><br /></strong></p>\n<p>You can view your bill online by logging into your account at: $url</p>\n<p>&nbsp;</p>\n<hr />\n<p>Thank you<br /> - $domain</p>', ''),
(27, 'Payment-Completed-Admin', '$domain - Payment Completed  $Var1 #$Var2', '<p>You have received a payment!</p>\n<p>$Var1 #$Var2</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<p>$Var3</p>', ''),
(28, 'Payment-Failed-Admin', '$domain - Payment Failed  $Var1 #$Var2', '<p>A Payment Has Failed!</p>\n<p>$Var1 #$Var2</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<p>$Var3</p>', ''),
(29, 'Payment-Pending-Admin', '$domain - Payment Pending  $Var1 #$Var2', '<p>You have a pending payment!</p>\n<p>MOST Pending payments will need to be manually validated and updated</p>\n<p>Click the following link to validate, once logged into the panel:</p>\n<p>$url/billing/?billStatus=Completed&amp;bidd=$Var2&amp;idd=$cid&amp;update=status</p>\n<p>&nbsp;</p>\n<p>$Var1 #$Var2</p>\n<p>$Var3</p>', ''),
(30, 'Payment-Pending-Queue', '$domain - Queue Payment Pending  $Var1 #$Var2', '<p>You have a pending payment!</p>\n<p>MOST Pending payments will need to be manually validated and updated</p>\n<p>Click the following link to validate, once logged into the panel:</p>\n<p>$url/manage/orders.php?mode=edit2&qid=$Var2&amp;idd=$cid&amp;update=status</p>\n<p>&nbsp;</p>\n<p>$Var1 #$Var2</p>\n<p>$Var3</p>', ''),
(31, 'Tech-MachineDown', '$domain - A machine is down,  $UserCPName $Var1', '<p>Hello $UserFirstName</p>\r\n<p>This is the Automated Notification System at $domain .</p>\r\n<p>The following machine has crashed:</strong> $Var1</p>\r\n<p>&nbsp;</p>\r\n<p>&nbsp;</p>\r\n<hr />\r\n<p>Thank you<br /> - $domain</p>\r\n<p>&nbsp;</p>', 'Message From $domain  \r\n\r\nThe machine has crashed:\r\n$Var1\r\n\r\nThank you.'),
(32, 'Tech-OverQuota', '$domain - You have exceeded your maximum disk quota.', '<p>Hello $UserFirstName</p>\n<p>This is the Automated Notification System at $domain .</p>\n<p>This message was sent to notify you that you are over your file disk quota on the following server:</p>\n<p>#$Var1</p>\n<p>You can login at: $url<br />Username: $UserCPName</p>\n<p>&nbsp;</p>\n<p>&nbsp;</p>\n<hr />\n<p>Thank you<br />- $domain</p>\n<p>&nbsp;</p>', ''),
(33, 'Billing-Payment', '\$domain - Payment Received #\$BillId', '<p>Hello \$UserFirstName<br /><br />This is the Automated Notification System at \$domain .<br /><strong><br /><br />Payment Received</strong></p>\n<p>Bill Invoice: #\$BillId<strong><br /></strong>Payment amount: \$currency\$Var1<br />Bill status: \$BillStatus<strong><br /><br />Invoice Description:</strong><br />\$BillDetails</p>\n<p>You can view your bill online by logging into your account at: \$url</p>\n<p>&nbsp;</p>\n<hr />\n<p>Thank you<br /> - \$domain</p>', ''),
(34, 'Payment-Donation', 'A new donation has been made', '<p>Hello \$UserFirstName<br /><br />This is the Automated Notification System at \$domain .<br /><strong><br /><br />Donation Received</strong></p>\n<p>Pledge:&nbsp;\$currency\$Paid</p>\n<p>Paid: \$currency\$Gross</p>\n<p>Payment Status: \$Status<br /><strong><br /></strong></p>\n<p>&nbsp;</p>\n<hr />\n<p>Thank you<br />- \$domain</p>', ''),
(35, 'Payment-Donation-Admin', 'Donation Received', '<p>Hello \$UserFirstName<br /><br />This is the Automated Notification System at \$domain .<br /><strong><br /><br />Payment Received</strong></p>\r\n<p><strong>User #\$cid received a donation</strong></p>\r\n<p>Paid:&nbsp;\$currency\$Paid</p>\r\n<p>Gross: \$Gross</p>\r\n<p>Payment Status: \$Status<br /><strong><br /></strong></p>\r\n<p>&nbsp;</p>\r\n<hr />\r\n<p>Thank you<br />- \$domain</p>', ''),
(36, 'Order-Confirmation', 'Order #\$ORDERID received.', '<p>Hello,</p>\n<p>&nbsp;</p>\n<h2>This e-mail is to confirm your order #\$ORDERID has been received.</h2>\n<p>&nbsp;</p>\n<p>Username: \$USERNAME</p>\n<p><strong>\$PRODUCT</strong><br />\$SUBPRODUCT</p>\n<p>Player Limit: \$PLAYERS</p>\n<p>&nbsp;</p>\n<p>If you have any questions or problems with this order please reply to this e-mail including the order number.</p>', '');



-- --------------------------------------------------------

--
-- Table structure for table `eventlogs`
--

CREATE TABLE IF NOT EXISTS `eventlogs` (
  `id` int(10) NOT NULL auto_increment,
  `user` varchar(32) NOT NULL,
  `time` varchar(32) NOT NULL,
  `affecteduser` varchar(32) NOT NULL,
  `comment` text NOT NULL,
  `ip` varchar(32) NOT NULL,
  `page` text NOT NULL,
  `post` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `eventlogs`
--


-- --------------------------------------------------------

--
-- Table structure for table `game`
--

CREATE TABLE IF NOT EXISTS `game` (
  `id` int(200) NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `fsgame` varchar(64) NOT NULL default '',
  `gcode` varchar(64) NOT NULL default '',
  `startmode` text,
  `game` varchar(255) NOT NULL default '',
  `install` varchar(32) NOT NULL default '',
  `protocol` varchar(32) NOT NULL default '',
  `installfile` text,
  `scontrolname` text,
  `premode` text,
  `port` varchar(32) NOT NULL default '',
  `map` varchar(32) NOT NULL default '',
  `queryport` varchar(32) NOT NULL default '',
  `maxplayers` int(8) NOT NULL default '0',
  `config` varchar(32) NOT NULL default '',
  `active` int(2) NOT NULL default '1',
  `hostname` varchar(128) NOT NULL default '',
  `website` varchar(128) NOT NULL default '',
  `motd` text,
  `updated` varchar(128) NOT NULL default '',
  `winexec` varchar(128) NOT NULL default '',
  `winparams` text,
  `mapdir` varchar(128) NOT NULL default '',
  `remove` text,
  `usermapdir` varchar(128) NOT NULL default '',
  `quickmod` varchar(128) NOT NULL default '',
  `wininstall` varchar(128) NOT NULL default '',
  `winappdir` varchar(128) default NULL,
  `gametype` varchar(128) NOT NULL default '',
  `winusermapdir` varchar(128) default NULL,
  `winmapdir` varchar(128) default NULL,
  `winpremode` text,
  `quickconfig` text,
  `mapextension` varchar(32) NOT NULL default '',
  `vars` text,
  `customvars` text,
  `installLine` text,
  `updateLine` text,
  `installedon` longtext,
  `ports` longtext,
  `steammod` varchar(128) NULL default '',
  `steamid` int(1) NULL default '0',
  `reinstall` int(1) NOT NULL default '0',
  `userupdate` int(1) NOT NULL default '0',
  `basepath` varchar(128) NOT NULL default '',
  `gamemonitor` varchar(32) NOT NULL default '',
  `logfile` varchar(128) NOT NULL default '',
  `deleteinstall` int(1) NOT NULL default '0',
  `gameQcode` varchar(128) NOT NULL default '',
  `postmode` text,
  `winpostmode` text,
  `wininstallLine` text,
  `winupdateline` text,
  `winremove` text,
  `branding` text,
  `brandingon` INT( 1 ) NULL DEFAULT '0',
  `maxplayers2` INT( 1 ) NULL DEFAULT '0',
  `files` text,
  `mapimgdir` text,
  `edittype` varchar(128) NOT NULL default '',
  `pidstop` varchar(128) NOT NULL default '',
  `exestop` text,
  `exedir` varchar(128) NOT NULL default '',
  `fastdl_compression` varchar(128) NOT NULL default '',
  `fastdl_include` text,
  `fastdl_exclude` text,
  `fastdl_sync` INT( 1 ) NULL DEFAULT '0',
  `fastdl_enable` INT( 1 ) NULL DEFAULT '0',
  `altinstall` text,
  `altinstallwin` text,
  `disableconsole` INT( 1 ) NULL DEFAULT '0',
  `disableconfigs` INT( 1 ) NULL DEFAULT '0',
  `disableftp` INT( 1 ) NULL DEFAULT '0',
  `disablefirewall` INT( 1 ) NULL DEFAULT '0',
  `lsofcheck` INT( 1 ) NULL DEFAULT '0',
   `stopmode` text,
   `winstopmode` text,
   `winstopconsole` text,
   `stopconsole` text,
 PRIMARY KEY  (`id`)
 ) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;



--
-- Dumping data for table `game`
--


-- --------------------------------------------------------

--
-- Table structure for table `gameconfigs`
--

CREATE TABLE IF NOT EXISTS `gameconfigs` (
  `id` int(5) NOT NULL auto_increment,
  `gid` int(5) NOT NULL,
  `installname` varchar(128) NOT NULL default '0',
  `configdir` varchar(128) NOT NULL default '',
  `configfile` varchar(128) NOT NULL default '',
  `config` LONGTEXT NOT NULL,
  `install` int(1) NOT NULL default '1',
  `winconfigdir` text,
  `name` varchar(128) default NULL,
  `defaultconfig` int(1) NOT NULL default '0',
  `hideconfig` int(1) NOT NULL default '0',
  `edittype` varchar(128) NOT NULL default '',
  `autoexec` int(1) NOT NULL default '0',
  `editable` int(1) NOT NULL default '1',
  `configbuilder` int(1) NOT NULL default '0',
  `fencoding` varchar(12) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `gameconfigs`
--


-- --------------------------------------------------------

--
-- Table structure for table `gamesubinstalls`
--

CREATE TABLE IF NOT EXISTS `gamesubinstalls` (
  `id` int(10) NOT NULL auto_increment,
  `gid` int(10) NOT NULL,
  `sgid` int(10) NOT NULL,
  `hostname` text NOT NULL,
  `maxplayers` int(3) NOT NULL,
  `install` int(1) NOT NULL,
  `limit` int(1) NOT NULL,
  `pubpriv` varchar(32) NOT NULL,
  `subdir` varchar(32) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `gamesubinstalls`
--


-- --------------------------------------------------------

--
-- Table structure for table `gameupdates`
--

CREATE TABLE IF NOT EXISTS `gameupdates` (
  `id` int(128) NOT NULL auto_increment,
  `name` varchar(128) NOT NULL default '',
  `lastran` varchar(128) NOT NULL default '',
  `linuxsize` varchar(128) NOT NULL default '',
  `winsize` varchar(128) NOT NULL default '',
  `description` text NOT NULL,	
  `gid` LONGTEXT NOT NULL,
  `md5sums` LONGTEXT NOT NULL,
  `winrepo` LONGTEXT NOT NULL,
  `linuxrepo` LONGTEXT NOT NULL,
  `archive` text NOT NULL,
  `type` int(1) NOT NULL default '0',
  `waitreply` int(1) NULL,
  `status` int(1) NULL,
  `syncmasterwin` int(1) NULL DEFAULT '0',
  `syncmasterlinux` int(1) NULL DEFAULT '0',
  `date` varchar(128) NOT NULL default '',
  `steamid` varchar(128) NOT NULL default '',
  `steammod` varchar(128) NOT NULL default '',
  `command` LONGTEXT NOT NULL,
  `log` LONGTEXT NOT NULL,
  `wincommand` LONGTEXT NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;


--
-- Dumping data for table `gameupdates`
--


-- --------------------------------------------------------

--
-- Table structure for table `gateways`
--

CREATE TABLE IF NOT EXISTS `gateways` (
  `id` int(2) NOT NULL auto_increment,
  `name` varchar(32) NOT NULL,
  `fullname` text NOT NULL,
  `status` int(1) NOT NULL default '0',
  `testing` int(1) NOT NULL default '0',
  `value1` varchar(128) default NULL,
  `value2` varchar(128) default NULL,
  `value3` varchar(128) default NULL,
  `value4` varchar(128) default NULL,
  `value5` varchar(128) default NULL,
  `value6` varchar(128) default NULL,
  `value7` varchar(128) default NULL,
  `value8` varchar(128) default NULL,
  `value9` varchar(128) default NULL,
  `value10` varchar(128) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `gateways`
--

INSERT INTO `gateways` (`id`, `name`, `fullname`, `status`, `testing`, `value1`, `value2`, `value3`) VALUES
(4, 'bank', 'Bank Transfer', 0, 0, '', '', ''),
(5, '2Checkout.com', '2Checkout Credit Card', 0, 0, '', '', ''),
(6, 'GoogleCheckout.com', 'GoogleCheckout', 1, 0, '', '', ''),
(7, 'BluePay.com', 'BluePay.com', 0, 0, '', '', ''),
(8, 'postal', 'Postal', 0, 0, '', '', ''),
(9, 'PayPal', 'PayPal', 1, 1, '', '', ''),
(10, 'WebMoney', 'WebMoney', 0, 0, '', '', ''),
(11, 'WorldPay', 'WorldPay', 0, 0, '', '', ''),
(12, 'SagePay', 'SagePay', 0, 0, '', '', 'GBP'),
(13, 'bank-receive', 'Bank Transfer', 0, 0, 'Bank Name', 'Account #', 'Routing #'),
(14, 'Authorize.net', 'Authorize.net', 0, 0, '', '', '');

-- --------------------------------------------------------


--
-- Table structure for table `iptable`
--

CREATE TABLE IF NOT EXISTS `iptable` (
  `id` int(3) NOT NULL auto_increment,
  `sid` varchar(30) NOT NULL default '',
  `ip` varchar(30) NOT NULL default '',
  `internal` varchar(128) NOT NULL default '',
  `useinternal` int(1) NOT NULL,
  `assigned` int(2) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `iptable`
--


-- --------------------------------------------------------

--
-- Table structure for table `logintrys`
--

CREATE TABLE IF NOT EXISTS `logintrys` (
  `ip` varchar(128) NOT NULL,
  `time` varchar(128) NOT NULL
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;

--
-- Dumping data for table `logintrys`
--


-- --------------------------------------------------------

--
-- Table structure for table `news`
--

CREATE TABLE IF NOT EXISTS `news` (
  `id` int(10) NOT NULL auto_increment,
  `name` varchar(128) NOT NULL,
  `content` text NOT NULL,
  `gid` int(10) default NULL,
  `sid` varchar(128) default NULL,
  `ulevel` int(3) default NULL,
  `rsid` int(3) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `news`
--


-- --------------------------------------------------------

--
-- Table structure for table `packages`
--

CREATE TABLE IF NOT EXISTS `packages` (
  `id` int(4) NOT NULL auto_increment,
  `name` text NOT NULL,
  `gid` int(4) NOT NULL,
  `active` int(1) NOT NULL default '1',
  `img` text NULL,
  `description` text NULL,
  `module` varchar(128) NULL,
 `category` int(30) NULL DEFAULT '0',
 `tax` int(1) NULL DEFAULT '0',
 `addontax` int(1) NOT NULL,
 `eid` int(128) default NULL,
 PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `packages`
--


-- --------------------------------------------------------

--
-- Table structure for table `payments`
--

CREATE TABLE IF NOT EXISTS `payments` (
  `id` int(4) NOT NULL auto_increment,
  `bid` int(4) NOT NULL,
  `cid` int(4) NOT NULL,
  `subid` int(4) default NULL,
  `total` varchar(32) NOT NULL,
  `time` varchar(128) NOT NULL,
  `ip` varchar(128) NOT NULL default '',
  `transactionid` varchar(128) NOT NULL default '',
  `gateway` varchar(128) NOT NULL default '',
  `fee` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `payments`
--


-- --------------------------------------------------------

--
-- Table structure for table `prices`
--

CREATE TABLE IF NOT EXISTS `prices` (
  `id` int(3) NOT NULL auto_increment,
  `pid` int(3) NOT NULL default '0',
  `name` text NOT NULL,
  `cost` varchar(32) NOT NULL default '',
  `fee` varchar(32) NOT NULL default '',
  `quarterly` varchar(32) NOT NULL default '0',
  `semiannualy` varchar(32) NOT NULL default '0',
  `annauly` varchar(32) NOT NULL default '0',
  `2years` varchar(32) NOT NULL default '0',
  `slots` int(6) NOT NULL,
  `type` varchar(32) NOT NULL,
  `rate` varchar(32) NOT NULL default '',
  `description` text,
  `rank` int(6) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `prices`
--


-- --------------------------------------------------------

--
-- Table structure for table `privileges`
--

CREATE TABLE IF NOT EXISTS `privileges` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(128) NOT NULL,
  `description` varchar(128) NOT NULL,
  `access` varchar(128) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `privileges`
--


-- --------------------------------------------------------

--
-- Table structure for table `queue`
--

CREATE TABLE IF NOT EXISTS `queue` (
  `user` varchar(128) NOT NULL default '',
  `id` int(32) NOT NULL auto_increment,
  `status` int(1) NOT NULL default '0',
  `ref` int(1) NOT NULL default '0',
  `mod` text NOT NULL,
  `rundatestatus` int(1) NOT NULL default '0',
  `rundate` varchar(12) NOT NULL default '',
  `fraudcheck` longtext,
  `result` text,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `queue`
--


-- --------------------------------------------------------

--
-- Table structure for table `schedule`
--

CREATE TABLE IF NOT EXISTS `schedule` (
  `id` int(4) NOT NULL auto_increment,
  `name` varchar(128) NOT NULL,
  `cmd` varchar(128) NOT NULL,
  `cron` text NOT NULL,
  `games` text,
  `servers` text,
  `users` text,
  `mode` varchar(128) default NULL,
  `next_run` varchar(128) default NULL,
  `ran_last` varchar(128) default NULL,
  `cmdid` varchar(128) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `schedule`
--


-- --------------------------------------------------------

--
-- Table structure for table `servers`
--

CREATE TABLE IF NOT EXISTS `servers` (
  `id` int(2) NOT NULL auto_increment,
  `sid` varchar(32) NOT NULL default '0',
  `ip` varchar(32) NOT NULL default '',
  `name` text,
  `quota` int(4) NOT NULL default '100',
  `cost` int(4) NOT NULL default '1',
  `used` int(1) NOT NULL default '0',
  `os` int(1) NOT NULL default '0',
  `ts2` int(1) NOT NULL default '0',
  `ts2port` int(40) NOT NULL default '51234',
  `ts3port` int(40) NOT NULL default '10011',
  `dashboard` int(1) NOT NULL default '1',
  `vent` int(1) NOT NULL default '0',
  `repo` varchar(128) NOT NULL default '',
  `location` varchar(128) NOT NULL default '',
  `master` varchar(3) NOT NULL default '0',
  `winuser` mediumtext,
  `winport` varchar(128) NOT NULL default '240',
  `winadminpass` mediumtext,
  `alias` text,
  `ftpport` int(10) NOT NULL default '21',
  `sshport` int(10) NOT NULL default '22',
  `tsadmin` varchar(64) NOT NULL default '',
  `tspass` varchar(64) NOT NULL default '',
  `slotquota` varchar(64) NOT NULL default '2000',
  `slotused` varchar(64) NOT NULL default '',
  `gamehost` varchar(64) NOT NULL default 'yes',
  `passphrase` varchar(128) NOT NULL default '',
  `ftpmotd` varchar(128) NOT NULL default '',
  `ftpadminport` varchar(128) NOT NULL default '',
  `ftpadminpass` varchar(128) NOT NULL default '',
  `parent` varchar(128) NOT NULL default '',
  `ftpd` varchar(128) NOT NULL default '',
  `webroot` varchar(128) NOT NULL default '',
  `webrooturl` varchar(128) NOT NULL default '',
  `webservices` longtext,
  `mohawk` int(1) NOT NULL default '0',
  `mumble` int(1) NOT NULL default '0',
  `position` varchar(128) default NULL,
  `ts3host` varchar(64) default NULL,
  `ts3admin` varchar(255) default NULL,
  `ts3pass` varchar(255) default NULL,
  `servernotes` mediumtext,
  `statscache` longtext,
  `statstime` varchar(128) NOT NULL default '',
  `cvars` mediumtext,
  `shownotes` int(1) NOT NULL default '0',
  `ipuse` int(3) NOT NULL default '0',
  `iptablesconf` varchar(128) NOT NULL default '/etc/iptables.conf',
  `eacdir` varchar(128) NOT NULL default '',
  `active` int(1) NOT NULL default '1',
  `timeout` int(3) NOT NULL default '30',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `servers`
--


-- --------------------------------------------------------

--
-- Table structure for table `settings`
--

CREATE TABLE IF NOT EXISTS `settings` (
  `name` varchar(32) NOT NULL,
  `value` text,
  PRIMARY KEY (`name`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;

--
-- Dumping data for table `settings`
--

INSERT INTO `settings` (`name`, `value`) VALUES
('encrypw', '1'),
('gcplickey', ''),
('gcplocalkey', ''),
('name', 'Game Server Control Panel'),
('slogan', 'Game Server Control Panel'),
('url', ''),
('path', ''),
('domainName', 'GameCP.com'),
('debugging', '0'),
('DEMO', 'no'),
('THEME', 'x'),
('USERTHEME', 'x'),
('pgrefresh', '0'),
('paypal_email', ''),
('emailSendFrom', ''),
('emailSendReply', ''),
('currencyChar', '$'),
('currencyName', 'USD'),
('displayLimit', '50'),
('suspendDays', '2'),
('notifyPre', '5'),
('notifyPre1', '4'),
('notifyPre2', '3'),
('notifyPre3', '2'),
('notifyPre4', '1'),
('notifyPast3', '2'),
('notifyPast1', '4'),
('notifyPast2', '3'),
('notifyPast', '5'),
('notifyPast4', '1'),
('EMAIL', 'text/html'),
('emailAdmin', 'yes'),
('LOGOUTURL', ''),
('zqueue', '0'),
('doBgImages', 'yes'),
('doMachineStats', 'yes'),
('consoleRefresh', '10'),
('consoleDump', '10000'),
('logoImage', ''),
('maindir', ''),
('mbpassword', ''),
('smsettings', ''),
('userlistmode', '1'),
('popserver', 'smtp.gmail.com'),
('popuser', ''),
('poppw', ''),
('popport', '587'),
('popauth', 'tls'),
('emailUserName', ''),
('notifyadminpayment', '1'),
('adminLogoImage', ''),
('userprefix', 'client'),
('reload_ajax_pages', 'true'),
('track_user_pages', 'true'),
('force_sqlcharset', 'true'),
('tmppath', '/tmp'),
('notifyAdminNewBill', '1'),
('usebilling', '1'),
('usetickets', '1'),
('ttapiurl', ''),
('tturl', ''),
('CLEAREVENTLOGS', '604800'),
('tteSupport', ''),
('portchecking', 'yes'),
('MAINTENANCE', 'no'),
('MAINTENANCEMSG', 'no'),
('MAINTENANCEMSGTXT', ''),
('sendorderreceipt', '1'),
('USESMTP', '0'),
('deleteDays', '60'),
('billurl', ''),
('userpermissions', 'a:14:{s:5:"voice";a:8:{s:9:"removeban";s:1:"1";s:13:"removeallbans";s:1:"1";s:6:"addban";s:1:"1";s:9:"teamspeak";s:1:"1";s:7:"control";s:1:"1";s:10:"managevent";s:1:"1";s:4:"edit";s:1:"1";s:8:"savevent";s:1:"1";}s:8:"services";a:13:{s:12:"taskschedule";s:1:"1";s:12:"timeschedule";s:1:"1";s:4:"mass";s:1:"1";s:6:"fastdl";s:1:"1";s:4:"edit";s:1:"1";s:5:"edit2";s:1:"1";s:6:"backup";s:1:"1";s:9:"saveSched";s:1:"1";s:11:"deleteSched";s:1:"1";s:14:"restoreconfigs";s:1:"1";s:8:"editgame";s:1:"1";s:8:"addaddon";s:1:"1";s:9:"addaddon2";s:1:"1";}s:7:"support";a:13:{s:10:"massupdate";s:1:"1";s:6:"update";s:1:"1";s:3:"add";s:1:"1";s:4:"edit";s:1:"1";s:3:"new";s:1:"1";s:4:"view";s:1:"1";s:5:"viewc";s:1:"1";s:9:"viewreply";s:1:"1";s:10:"viewactive";s:1:"1";s:3:"all";s:1:"1";s:14:"deletetmpfiles";s:1:"1";s:8:"download";s:1:"1";s:10:"uploadfile";s:1:"1";}s:4:"maps";a:2:{s:7:"install";s:1:"1";s:9:"uninstall";s:1:"1";}s:7:"clients";a:11:{s:8:"changepw";s:1:"1";s:13:"removesubuser";s:1:"1";s:6:"update";s:1:"1";s:4:"edit";s:1:"1";s:9:"updatesub";s:1:"1";s:14:"editsubaccount";s:1:"1";s:13:"newsubaccount";s:1:"1";s:10:"addsubacct";s:1:"1";s:5:"edit2";s:1:"1";s:6:"cancel";s:1:"1";s:14:"viewsubaccount";s:1:"1";}s:9:"dashboard";s:1:"1";s:5:"files";a:14:{s:8:"download";s:1:"1";s:4:"wget";s:1:"1";s:6:"remove";s:1:"1";s:6:"upload";s:1:"1";s:9:"doextract";s:1:"1";s:11:"quickmanage";s:1:"1";s:4:"edit";s:1:"1";s:2:"cd";s:1:"1";s:6:"rename";s:1:"1";s:5:"mkdir";s:1:"1";s:6:"mkfile";s:1:"1";s:11:"addshortcut";s:1:"1";s:14:"removeshortcut";s:1:"1";s:12:"Save Changes";s:1:"1";}s:9:"donations";s:1:"1";s:7:"console";s:1:"1";s:7:"configs";a:10:{s:3:"add";s:1:"1";s:3:"new";s:1:"1";s:4:"edit";s:1:"1";s:7:"execute";s:1:"1";s:6:"update";s:1:"1";s:6:"remove";s:1:"1";s:11:"editconfigs";s:1:"1";s:7:"builder";s:1:"1";s:11:"builderedit";s:1:"1";s:10:"builderrun";s:1:"1";}s:10:"cmdbackend";a:4:{s:4:"mass";s:1:"1";s:12:"submitscreen";s:1:"1";s:7:"viewlog";s:1:"1";s:11:"downloadlog";s:1:"1";}s:7:"billing";a:2:{s:5:"print";s:1:"1";s:4:"view";s:1:"1";}s:12:"serverstatus";s:1:"1";s:7:"process";s:1:"1";}'),
('emailadminewserver', '1'),
('sessionTimeout', '12000'),
('portIncrament', '1'),
('portLimit', '30'),
('installPriority', ''),
('defaultlang', 'en'),
('doiptables', '1'),
('doreselleraddon', '1'),
('maxLicence', ''),
('maxProxyScoreLimit', '3'),
('maxScoreLimit', '5'),
('maxRejectFreeMail', 'no'),
('maxRejectCountry', 'yes'),
('maxRejectHighRiskCountry', 'yes'),
('maxRejectanonymousProxy', 'yes'),
('diplay_notifications', 'yes'),
('maxUseSSL', 'no'),
('maxPhoneAuth', 'no'),
('maxEnable', 'no'),
('subuno', 'no'),
('subunokey', ''),
('subunomanual', 'yes'),
('paypalSubscriptions', 'yes'),
('bypassIfNoCredits', 'yes'),
('disableevents', '0'),
('ALLOWTICKETUPLOADS', 'no'),
('TICKETUPLOADPATH', ''),
('usedarkstarvent', 'no'),
('ALLOWUPLOADS', 'no'),
('VENTRILO_REMOTE_ID', ''),
('VENTRILO_REMOTE_ACCESS_KEY', ''),
('VENTRILO_RESELLER_ID', ''),
('phpexec', 'php'),
('ipsubdir', 'false'),
('queue_mail', '0'),
('enable_disk_quota', '0'),
('tteSupportMail', ''),
('indexAdmin', 'a:2:{s:4:"left";s:102:"a:4:{i:0;s:12:"controlicons";i:1;s:11:"activegames";i:2;s:12:"voiceservers";i:3;s:13:"billinggraphs";}";s:5:"right";s:80:"a:4:{i:0;s:4:"news";i:1;s:6:"helper";i:2;s:11:"usersonline";i:3;s:8:"verifier";}";}'),
('indexClient', 'a:2:{s:4:"left";s:93:"a:4:{i:0;s:12:"controlicons";i:1;s:11:"activegames";i:2;s:13:"inactivegames";i:3;s:4:"news";}";s:5:"right";s:81:"a:3:{i:0;s:13:"serverdetails";i:1;s:14:"supporttickets";i:2;s:12:"pendingbills";}";}'),
('indexSubUser', 'a:2:{s:4:"left";s:69:"a:3:{i:0;s:4:"news";i:1;s:11:"activegames";i:2;s:13:"inactivegames";}";s:5:"right";s:31:"a:1:{i:0;s:13:"serverdetails";}";}'),
('styleadmin', 'x'),
('styleclient', 'x'),
('googlemapkey', ''),
('MAILINGADDRESS', ''),
('ordersubdir', 'yes'),
('apacheuser', ''),
('imapdelete', 'no'),
('monitorlock', ''),
('graphlock', ''),
('captcha', 'no'),
('captchapub', ''),
('captchapriv', ''),
('orderssh', 'noftp'),
('orderfmip', 'no'),
('DISABLEXTRACT', 'yes'),
('logintrys', '5'),
('logindelay', '300'),
('cachedelay', '30'),
('rescandelay', '4'),
('backupemail', ''),
('dateformat', 'Y-m-d'),
('dateformattpl', '%Y-%m-%d'),
('dateformatui', 'yy-mm-dd'),
('emailNotify', ''),
('ttuid', ''),
('imapuser', ''),
('imappw', ''),
('imapserver', 'imap.gmail.com'),
('imapport', '993'),
('imapauth', 'ssl'),
('orderstyle', 'x'),
('basicindex', 'false'),
('rrdUseEXEC', 'false'),
('sm_sleeptime', '30'),
('sm_scanquery', '1'),
('sm_maxLoad', '110'),
('sm_smmaxLoad', '100'),
('sm_smmaxLoadon', '0'),
('sm_restartOverloaded', '0'),
('sm_constantScanDelay',  '0'),
('sm_privatekill',  '0'),
('sm_timekill',  '1'),
('sm_downTicket',  '1'),
('sm_downRestart',  '1'),
('sm_doMachineGraphs',  '1'),
('sm_emailNotify',  '0'),
('sm_activeScan',  '1'),
('sm_overlimit',  '1'),
('sm_brandstop',  '2'),
('sm_disablebrand',  '1'),
('sm_disablebrandcheck',  '0'),
('stepdelay',  '360'),
('gzip',  'yes'),
('qstattimeout',  '900'),
('tos',  '<h2>	Terms and Conditions of Use</h2><h3>	1. Terms</h3><p>	By accessing this web site, you are agreeing to be bound by these 	web site Terms and Conditions of Use, all applicable laws and regulations, 	and agree that you are responsible for compliance with any applicable local 	laws. If you do not agree with any of these terms, you are prohibited from 	using or accessing this site. The materials contained in this web site are 	protected by applicable copyright and trade mark law.</p><h3>	2. Use License</h3><ol type="a">	<li>		Permission is granted to temporarily download one copy of the materials 		(information or software) on %domainName%\'s web site for personal, 		non-commercial transitory viewing only. This is the grant of a license, 		not a transfer of title, and under this license you may not:				<ol type="i">			<li>modify or copy the materials;</li>			<li>use the materials for any commercial purpose, or for any public display (commercial or non-commercial);</li>			<li>attempt to decompile or reverse engineer any software contained on %domainName%\'s web site;</li>			<li>remove any copyright or other proprietary notations from the materials; or</li>			<li>transfer the materials to another person or "mirror" the materials on any other server.</li>		</ol>	</li>	<li>		This license shall automatically terminate if you violate any of these restrictions and may be terminated by %domainName% at any time. Upon terminating your viewing of these materials or upon the termination of this license, you must destroy any downloaded materials in your possession whether in electronic or printed format.	</li></ol><h3>	3. Disclaimer</h3><ol type="a">	<li>		The materials on %domainName%\'s web site are provided "as is". %domainName% makes no warranties, expressed or implied, and hereby disclaims and negates all other warranties, including without limitation, implied warranties or conditions of merchantability, fitness for a particular purpose, or non-infringement of intellectual property or other violation of rights. Further, %domainName% does not warrant or make any representations concerning the accuracy, likely results, or reliability of the use of the materials on its Internet web site or otherwise relating to such materials or on any sites linked to this site.	</li></ol><h3>	4. Limitations</h3><p>	In no event shall %domainName% or its suppliers be liable for any damages (including, without limitation, damages for loss of data or profit, or due to business interruption,) arising out of the use or inability to use the materials on %domainName%\'s Internet site, even if %domainName% or a %domainName% authorized representative has been notified orally or in writing of the possibility of such damage. Because some jurisdictions do not allow limitations on implied warranties, or limitations of liability for consequential or incidental damages, these limitations may not apply to you.</p>			<h3>	5. Revisions and Errata</h3><p>	The materials appearing on %domainName%\'s web site could include technical, typographical, or photographic errors. %domainName% does not warrant that any of the materials on its web site are accurate, complete, or current. %domainName% may make changes to the materials contained on its web site at any time without notice. %domainName% does not, however, make any commitment to update the materials.</p><h3>	6. Links</h3><p>	%domainName% has not reviewed all of the sites linked to its Internet web site and is not responsible for the contents of any such linked site. The inclusion of any link does not imply endorsement by %domainName% of the site. Use of any such linked web site is at the user\'s own risk.</p><h3>	7. Site Terms of Use Modifications</h3><p>	%domainName% may revise these terms of use for its web site at any time without notice. By using this web site you are agreeing to be bound by the then current version of these Terms and Conditions of Use.</p><h3>	8. Governing Law</h3><p>	Any claim relating to %domainName%\'s web site shall be governed by the laws of the United States without regard to its conflict of law provisions.</p><p>	General Terms and Conditions applicable to Use of a Web Site.</p><h2>	Privacy Policy</h2><p>	Your privacy is very important to us. Accordingly, we have developed this Policy in order for you to understand how we collect, use, communicate and disclose and make use of personal information. The following outlines our privacy policy.</p><ul>	<li>		Before or at the time of collecting personal information, we will identify the purposes for which information is being collected.	</li>	<li>		We will collect and use of personal information solely with the objective of fulfilling those purposes specified by us and for other compatible purposes, unless we obtain the consent of the individual concerned or as required by law.			</li>	<li>		We will only retain personal information as long as necessary for the fulfillment of those purposes. 	</li>	<li>		We will collect personal information by lawful and fair means and, where appropriate, with the knowledge or consent of the individual concerned. 	</li>	<li>		Personal data should be relevant to the purposes for which it is to be used, and, to the extent necessary for those purposes, should be accurate, complete, and up-to-date. 	</li>	<li>		We will protect personal information by reasonable security safeguards against loss or theft, as well as unauthorized access, disclosure, copying, use or modification.	</li>	<li>		We will make readily available to customers information about our policies and practices relating to the management of personal information. 	</li></ul><p>	We are committed to conducting our business in accordance with these principles in order to ensure that the confidentiality of personal information is protected and maintained. </p>	'),
('showinstallhelp', 'yes'),
('taxEnable', 'no'),
('taxCompound', 'no'),
('taxType', 'inclusive'),
('currencyChar2', ''),
('currencyFormat', '1'),
('sqlcharset', 'utf8'),
('eac', '0'),
('machinestatscache', '300'),
('bccmails', ''),
('queryinternalip', 'no'),
('userrechekcdelay', '90'),
('inactivett', '0'),
('tteShowLink', '1'),
('steam_daily', ''),
('steam_daily_ran', ''),
('steam_user', ''),
('steam_pass', ''),
('steam_code', ''),
('ran_scheduler', ''),
('ran_cache', ''),
('ran_monitor', ''),
('ran_auto', ''),
('ran_quota', ''),
('ran_imap', ''),
('ran_queue', ''),
('ran_user_fix', '1'),
('ran_darkstar_fix', '1'),
('ran_ports_fix', '1'),
('webcron', '0'),
('clientchangemail', '0'),
('masterrepowin', ''),
('masterrepolinux', ''),
('repo_daily_ran', ''),
('neworder_title', 'New Order'),
('donation_title', 'Donation for'),
('payment_title', 'Invoice payment for '),
('neworder_description', 'New Order'),
('donation_description', 'Donation'),
('payment_description', 'Invoice #'),
('auto_setup', '1'),
('', '0'),
('INVOICEHEADER', '');


-- --------------------------------------------------------

--
-- Table structure for table `addoncategorys`
--

CREATE TABLE IF NOT EXISTS `addoncategorys` (
  `id` int(2) NOT NULL auto_increment,
  `rank` int(10) NOT NULL default '0',
  `title` varchar(128) NOT NULL default '',
  `icon` varchar(128) NOT NULL default '',
  `color` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `ttcategorys`
--


-- --------------------------------------------------------

--
-- Table structure for table `ttcategorys`
--

CREATE TABLE IF NOT EXISTS `ttcategorys` (
  `id` int(2) NOT NULL auto_increment,
  `title` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `ttcategorys`
--


-- --------------------------------------------------------

--
-- Table structure for table `ttsystem`
--

CREATE TABLE IF NOT EXISTS `ttsystem` (
  `id` int(12) NOT NULL auto_increment,
  `cid` int(12) NOT NULL default '0',
  `date` varchar(32) NOT NULL default '',
  `resolved` char(3) NOT NULL default '',
  `assigned` int(255) default NULL DEFAULT '0',
  `title` varchar(128) NOT NULL default '',
  `subject` varchar(128) NOT NULL default '',
  `message` text NOT NULL,
  `reply` text NOT NULL,
  `status` varchar(32) NOT NULL default '',
  `summary` text NOT NULL,
  `updated` varchar(32) NOT NULL,
  `games` text NOT NULL,
  `files` text,
  `mail_address` varchar(128) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `ttsystem`
--


-- --------------------------------------------------------

--
-- Table structure for table `userbills`
--

CREATE TABLE IF NOT EXISTS `userbills` (
  `id` int(4) NOT NULL auto_increment,
  `cid` int(4) NOT NULL default '0',
  `bid` int(4) NOT NULL default '0',
  `pid` int(4) NOT NULL default '0',
  `gross` varchar(20) NOT NULL default '',
  `fee` varchar(32) NOT NULL default '',
  `description` text NULL,
  `taxed` int(1) NOT NULL default '0',
  `tax` varchar(20) NOT NULL default '',
  `ugid` varchar(20) NOT NULL default '',
  `uvid` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `userbills`
--


-- --------------------------------------------------------

--
-- Table structure for table `userconfigs`
--

CREATE TABLE IF NOT EXISTS `userconfigs` (
  `id` int(32) NOT NULL auto_increment,
  `ugid` int(32) NOT NULL default '0',
  `config` varchar(128) NOT NULL default '',
  `name` varchar(128) NOT NULL default '',
  `contents` LONGTEXT NOT NULL,
  `configdir` varchar(128) NOT NULL default '',
  `edittype` varchar(128) NOT NULL default '',
  `autoexec` int(1) NOT NULL default '0',
  `editable` int(1) NOT NULL default '1',
  `configbuilder` int(1) NOT NULL default '0',
  `hidecfg` int(1) NOT NULL default '0',
  `cfgid` int(12) NOT NULL default '0',
  `fencoding` varchar(12) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `userconfigs`
--


-- --------------------------------------------------------

--
-- Table structure for table `usergames`
--

CREATE TABLE IF NOT EXISTS `usergames` (
  `id` int(2) NOT NULL auto_increment,
  `cid` varchar(32) NOT NULL default '',
  `config` varchar(32) NOT NULL default '',
  `ip` varchar(32) NOT NULL default '',
  `port` varchar(7) NOT NULL default '',
  `gid` int(2) NOT NULL default '0',
  `active` int(2) NOT NULL default '0',
  `startmap` varchar(32) NOT NULL default '',
  `maxplayers` int(4) NOT NULL default '0',
  `rconpass` varchar(128) NOT NULL default '',
  `suspend` varchar(128) NOT NULL default '',
  `queryport` varchar(32) NOT NULL default '',
  `pubpriv` varchar(32) NOT NULL default '',
  `scan` int(1) NOT NULL default '0',
  `sci` text,
  `logfile` varchar(64) default NULL,
  `clientplayers` int(32) NOT NULL default '0',
  `scontrol` varchar(64) NOT NULL default '',
  `start_time` varchar(64) default NULL,
  `end_time` varchar(64) default NULL,
  `use_sched` varchar(2) default NULL,
  `start_hour` varchar(64) NOT NULL default '',
  `affinity` varchar(24) NOT NULL default '',
  `subdirectory` varchar(3) default NULL,
  `premode` text,
  `addons` text,
  `fastdl` varchar(128) default NULL,
  `gametype` varchar(64) default NULL,
  `servername` varchar(128) NOT NULL default '',
  `billingid` varchar(64) NOT NULL default '',
  `vars` text,
  `customvars` text,
  `status` int(1) NOT NULL default '0',
  `useredit` int(1) NOT NULL default '0',
  `created` varchar(64) NOT NULL default '',
  `restarted` varchar(64) NOT NULL default '',
  `priority` int(1) NOT NULL default '0',
  `homepage` int(1) NOT NULL default '1',
  `mgid` int(100) default NULL,
  `files` text,
  `firewall` int(1) default NULL DEFAULT '1',
  `ports`  LONGTEXT,
  `statscache`  LONGTEXT,
  `statscachetime` varchar(128) default NULL,
  `lastplayers`  LONGTEXT,
  `lastplytime` varchar(128) default NULL,
  `firewallports`  LONGTEXT,
  `notes`  LONGTEXT,
  `lastmaps`  LONGTEXT,
  `lastmapstime` varchar(128) default NULL,
  `lastactivetime` varchar(128) default NULL,
  `startserver` varchar(128) default NULL,
  `defaultinfo` text,
  `branding` text,
  `brandingon` INT( 1 ) NULL DEFAULT '0',
  `addonstatus` text,
  `permissions` LONGTEXT  NOT NULL,
  `updatestatus` INT( 1 ) NULL DEFAULT '0',
  `eac` int(1) NOT NULL default '0',
  `eactype` int(1) NOT NULL default '0',
  `monitor_down` int(1) NOT NULL default '0',
  `stopempty` int(18) default NULL,
  PRIMARY KEY  (`id`),
  KEY `ip` (`ip`),
  KEY `cid` (`cid`),
  KEY `active` (`active`),
  KEY `port` (`port`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `usergames`
--


-- --------------------------------------------------------

--
-- Table structure for table `userprivileges`
--

CREATE TABLE IF NOT EXISTS `userprivileges` (
  `cid` int(11) NOT NULL,
  `pid` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;

--
-- Dumping data for table `userprivileges`
--


-- --------------------------------------------------------

--
-- Table structure for table `users`
--

CREATE TABLE IF NOT EXISTS `users` (
  `id` int(100) NOT NULL auto_increment,
  `name` varchar(32) NOT NULL default '',
  `email` varchar(254) NOT NULL default '',
  `username` varchar(64) NOT NULL default '',
  `userlevel` varchar(2) NOT NULL default '',
  `password` varchar(128) NOT NULL default '',
  `clan` varchar(32) default '',
  `active` int(1) default '0',
  `phone` varchar(128) default '',
  `address` varchar(128) default '',
  `city` varchar(128) default '',
  `state` varchar(128) default '',
  `country` varchar(128) default '',
  `zip` varchar(128) default '',
  `suspend` varchar(128) default '',
  `website` varchar(128) default '',
  `extranotes` text,
  `api_key` text,
  `api_ip` text,
  `firstname` varchar(128) default '',
  `lastname` varchar(128) default '',
  `payment` varchar(32) default '',
  `address2` varchar(128) default '',
  `bash` varchar(32) default '',
  `joindate` varchar(32) default '',
  `limit` int(4) default '1',
  `filemanager` int(1) default '0',
  `storedpw` varchar(128) default '',
  `rsid` int(100) default '0',
  `servers` text,
  `mainadmin` int(1) default '0',
  `demo` int(1) default '0',
  `advedit` int(1) default '0',
  `games` text,
  `portrange` text,
  `lastlogin` varchar(128) default '',
  `billingid` varchar(64) default '',
  `smsaddress` varchar(128) default '',
  `signature` text,
  `slotlimit` int(3) default '0',
  `indexsort` text,
  `userip` varchar(128) default '',
  `theme` varchar(128) default '',
  `style` varchar(128) default '',
  `lang` varchar(32) default 'en',
  `quota` LONGTEXT NULL,
  `shortcuts` LONGTEXT NULL,
  `permissions` LONGTEXT NULL,
  `credit` varchar(128) default '',
  `apiaccess` varchar(128) default 'no',
  `keystring` varchar(128) default '',
  `location` varchar(128) default '',
  `taxid` varchar(128) default '',
  `taxed` int(1) default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=2 ;


-- --------------------------------------------------------

--
-- Table structure for table `userschedule`
--

CREATE TABLE IF NOT EXISTS `userschedule` (
  `id` int(4) NOT NULL auto_increment,
  `name` varchar(128) NOT NULL,
  `cmd` varchar(128) NOT NULL,
  `cron` text NOT NULL,
  `settings` text NOT NULL,
  `ugid` varchar(128) default NULL,
  `next_run` varchar(128) default NULL,
  `ran_last` varchar(128) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `userschedule`
--


-- --------------------------------------------------------

--
-- Table structure for table `usersonline`
--

CREATE TABLE IF NOT EXISTS `usersonline` (
  `name` varchar(64) NOT NULL default '',
  `timestamp` varchar(32) NOT NULL default '',
  `ip` varchar(32) NOT NULL default '',
  `FILE` text NOT NULL,
  `RFILE` text NOT NULL
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;

--
-- Dumping data for table `usersonline`
--


-- --------------------------------------------------------

--
-- Table structure for table `usersubaccounts`
--

CREATE TABLE IF NOT EXISTS `usersubaccounts` (
  `id` int(10) NOT NULL auto_increment,
  `cid` int(10) NOT NULL default '0',
  `name` text NOT NULL,
  `password` text NULL,
  `email` text,
  `perms` varchar(128) default NULL,
  `files` text,
  `active` int(1) NOT NULL default '1',
  `indexsort` text,
  `games` text,
  `keystring` varchar(128) default '',
  `api_key` text,
  `api_ip` text,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

--
-- Dumping data for table `usersubaccounts`
--


-- --------------------------------------------------------

--
-- Table structure for table `uservoice`
--

CREATE TABLE IF NOT EXISTS `uservoice` (
  `id` int(5) NOT NULL auto_increment,
  `cid` int(5) NOT NULL default '0',
  `vid` int(1) NOT NULL default '0',
  `tssid` int(5) NOT NULL default '0',
  `user` varchar(128) NOT NULL default '',
  `pass` varchar(128) NOT NULL default '',
  `maxclients` int(2) NOT NULL default '0',
  `ip` varchar(32) NOT NULL default '',
  `port` varchar(32) NOT NULL default '',
  `servername` text NOT NULL,
  `billingId` int(100) default NULL,
  `active` int(1) NOT NULL default '0',
  `voicetype` varchar(32) default NULL,
  `api_id` int(100) default NULL,
  `api_id2` int(100) default NULL,
  `ts3token` text,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=2 ;

--
-- Dumping data for table `uservoice`
--

CREATE TABLE IF NOT EXISTS `ipban` (
  `id` int(128) NOT NULL auto_increment,
  `ugid` int(128) NOT NULL,
  `ip` varchar(128) NOT NULL,
  `mode` varchar(128) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `paddon` (
  `id` int(3) NOT NULL auto_increment,
  `pid` int(3) NOT NULL default '0',
  `name` text NOT NULL,
  `cost` varchar(32) NOT NULL default '',
  `fee` varchar(32) NOT NULL default '',
  `quarterly` varchar(32) NOT NULL default '0',
  `semiannualy` varchar(32) NOT NULL default '0',
  `annauly` varchar(32) NOT NULL default '0',
  `2years` varchar(32) NOT NULL default '0',
  `rate` varchar(32) NOT NULL default '',
  `pubpriv` varchar(32) NOT NULL default '',
  `cval` text,
  `rank` int(6) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `paddontype` (
  `id` int(3) NOT NULL auto_increment,
  `prodid` int(3) NOT NULL default '0',
  `name` text NOT NULL,
  `type` varchar(32) NOT NULL,
  `cvar` text,
  `rank` int(6) NOT NULL default '0',
  `required` int(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;



CREATE TABLE IF NOT EXISTS `taxes` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `country` varchar(128) NOT NULL,
  `city` varchar(128) NOT NULL,
  `description` mediumtext NOT NULL,
  `active` int(1) NOT NULL,
  `rate` varchar(10) NOT NULL,
  `level` int(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;


ALTER TABLE `users` ADD `currency` varchar(128) default '' ;

CREATE TABLE IF NOT EXISTS `currencies` (
`id` int(128) NOT NULL auto_increment,
`code` varchar(128) NOT NULL,
`prefix` varchar(128) NOT NULL,
`suffix` varchar(128) NOT NULL,
`format` varchar(128) NOT NULL,
`rate` varchar(128) NOT NULL,
PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `categories` (
  `id` int(128) NOT NULL auto_increment,
  `name` varchar(128) NOT NULL,
  `description` LONGTEXT NOT NULL,
  `img` varchar(128) NOT NULL,
  `rank` int(1) NOT NULL,
  `status` int(1) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `config_builderitems` (
  `id` int(120) NOT NULL auto_increment,
  `builderid` int(120) NOT NULL default '0',
  `name` text NOT NULL,
  `type` varchar(32) NOT NULL,
  `cvar` text,
  `editable` int(1) NOT NULL default '1',
  `required` int(1) NOT NULL default '0',
  `rank` int(6) NOT NULL default '0',
  `regexp` longtext NULL,
  `value` longtext NULL,
  `label` varchar(128) NOT NULL,
  `description` longtext NULL,
  `maxlength` varchar(12) NOT NULL, 
  `width` varchar(12) NOT NULL, 
  `rows` varchar(12) NOT NULL,
  `wrap` varchar(1) NOT NULL, 
  `mode` varchar(128) NOT NULL,
  `onval` varchar(128) NOT NULL,
  `offval` varchar(128) NOT NULL,
  `denychars` varchar(128) NOT NULL,
  `delimiter` varchar(128) NOT NULL,
  `prefix` varchar(128) NOT NULL, 
  `suffix` varchar(128) NOT NULL, 
  `seperator` varchar(128) NOT NULL,

  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `config_buildersave` (
  `id` int(120) NOT NULL auto_increment,
  `builderid` int(120) NOT NULL default '0',
  `itemid` int(120) NOT NULL default '0',
  `ugid` int(120) NOT NULL default '0',
  `value` longtext NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


ALTER TABLE  `prices` ADD INDEX  `pid` (  `pid` );