CREATE TABLE IF NOT EXISTS `eventlogs` (
  `id` int(10) NOT NULL auto_increment,
  `user` varchar(32) NOT NULL,
  `time` varchar(32) NOT NULL,
  `affecteduser` varchar(32) NOT NULL,
  `comment` text NOT NULL,
  `ip` varchar(32) NOT NULL,
  `page` text NOT NULL,
  `post` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `module_settings` (
  `pid` int(128) NOT NULL,
  `module` varchar(128) NOT NULL default '',
  `setting` varchar(128) NOT NULL default '',
  `value` longtext NULL
) ENGINE=MyISAM  ;

CREATE TABLE IF NOT EXISTS `module_services` (
  `id` int(2) NOT NULL auto_increment,
  `date` varchar(128) NOT NULL default '',
  `customfields` longtext NULL,
  `customfieldsog` longtext NULL,
  `pid` int(128) NOT NULL,
  `cid` int(128) NOT NULL,
  `qid` int(128) NOT NULL,
  `notes` longtext NULL,
  `status` varchar(128) NOT NULL default '',
  `ip` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8  AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `donations` (
  `id` int(2) NOT NULL auto_increment,
  `cid` varchar(128) NOT NULL default '',
  `gateway` varchar(128) NOT NULL default '',
  `gross` varchar(128) NOT NULL default '',
  `paid` varchar(128) NOT NULL default '',
  `fee` varchar(128) NOT NULL default '',
  `transactionid` varchar(128) NOT NULL default '',
  `status` varchar(128) NOT NULL default '',
  `ipaddr` varchar(128) NOT NULL default '',
  `email` varchar(128) NOT NULL default '',
  `date` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `addoncategorys` (
  `id` int(2) NOT NULL auto_increment,
  `title` varchar(128) NOT NULL default '',
  `icon` varchar(128) NOT NULL default '',
  `color` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `emailqueue` (
  `id` int(120) NOT NULL auto_increment,
  `content` longtext NOT NULL,
  `subject` varchar(128) NOT NULL default '',
  `time` varchar(128) NOT NULL default '',
  `user` varchar(128) NOT NULL default '',
  `effected` varchar(128) NOT NULL default '',
  `queue` int(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `userschedule` (
  `id` int(4) NOT NULL auto_increment,
  `name` varchar(128) NOT NULL,
  `cmd` varchar(128) NOT NULL,
  `cron` text NOT NULL,
  `settings` text NOT NULL,
  `ugid` varchar(128) default NULL,
  `next_run` varchar(128) default NULL,
  `ran_last` varchar(128) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `cron` (
`task` VARCHAR( 255 ) NOT NULL ,
`time` VARCHAR( 255 ) NOT NULL 
) ENGINE = MyISAM ;

CREATE TABLE IF NOT EXISTS `ipban` (
  `id` int(128) NOT NULL auto_increment,
  `ugid` int(128) NOT NULL,
  `ip` varchar(128) NOT NULL,
  `mode` varchar(128) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `currencies` (
  `id` int(128) NOT NULL auto_increment,
  `code` varchar(128) NOT NULL,
  `prefix` varchar(128) NOT NULL,
  `suffix` varchar(128) NOT NULL,
  `format` varchar(128) NOT NULL,
  `rate` varchar(128) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `categories` (
  `id` int(128) NOT NULL auto_increment,
  `name` varchar(128) NOT NULL,
  `description` LONGTEXT NOT NULL,
  `img` varchar(128) NOT NULL,
  `status` int(1) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `promotions` (
  `id` int(11) NOT NULL auto_increment,
  `active` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `expire` varchar(255) NOT NULL,
  `value` varchar(255) NOT NULL,
  `type` varchar(255) NOT NULL,
  `products` longtext NOT NULL,
  `totaluses` int(11) NOT NULL,
  `oneperuser` int(11) NOT NULL,
  `existinguser` int(11) NOT NULL,
  `newuser` int(11) NOT NULL,
  `location` longtext NOT NULL,
  `recurring` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 ;
 

CREATE TABLE IF NOT EXISTS `promotionsuse` (
  `pmid` int(11) NOT NULL,
  `cid` int(11) NOT NULL
) ENGINE = MyISAM ;


CREATE TABLE IF NOT EXISTS `paddon` (
  `id` int(3) NOT NULL auto_increment,
  `name` text NOT NULL,
  `pid` int(3) NOT NULL default '0',
  `cost` varchar(32) NOT NULL default '',
  `fee` varchar(32) NOT NULL default '',
  `quarterly` varchar(32) NOT NULL default '0',
  `semiannualy` varchar(32) NOT NULL default '0',
  `annauly` varchar(32) NOT NULL default '0',
  `2years` varchar(32) NOT NULL default '0',
  `rate` varchar(32) NOT NULL default '',
  `pubpriv` varchar(32) NOT NULL default '',
  `cval` text,
  `rank` int(6) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `paddontype` (
  `id` int(3) NOT NULL auto_increment,
  `prodid` int(3) NOT NULL default '0',
  `name` text NOT NULL,
  `type` varchar(32) NOT NULL,
  `cvar` text,
  `required` int(1) NOT NULL default '0',
  `rank` int(6) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `taxes` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `country` varchar(128) NOT NULL,
  `city` varchar(128) NOT NULL,
  `description` mediumtext NOT NULL,
  `active` int(1) NOT NULL,
  `rate` varchar(10) NOT NULL,
  `level` int(1) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `config_buildergames` (
  `builderid` int(1) NOT NULL default '0',
  `gid` int(1) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT ;

CREATE TABLE IF NOT EXISTS `config_builder` (
  `id` int(120) NOT NULL auto_increment,
  `name` varchar(128) NOT NULL default '',
  `description` longtext  NULL,
  `config` longtext  NULL,
  `winpath` varchar(128) NOT NULL default '',
  `linpath` varchar(128) NOT NULL default '',
  `winfile` varchar(128) NOT NULL default '',
  `linfile` varchar(128) NOT NULL default '',
  `status` int(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `config_builderitems` (
  `id` int(120) NOT NULL auto_increment,
  `builderid` int(120) NOT NULL default '0',
  `name` text NOT NULL,
  `type` varchar(32) NOT NULL,
  `cvar` text,
  `editable` int(1) NOT NULL default '1',
  `required` int(1) NOT NULL default '0',
  `rank` int(6) NOT NULL default '0',
  `regexp` longtext NULL,
  `value` longtext NULL,
  `label` varchar(128) NOT NULL,
  `description` longtext NULL,
  `maxlength` varchar(12) NOT NULL, 
  `width` varchar(12) NOT NULL, 
  `rows` varchar(12) NOT NULL,
  `wrap` varchar(1) NOT NULL, 
  `mode` varchar(128) NOT NULL,
  `onval` varchar(128) NOT NULL,
  `offval` varchar(128) NOT NULL,
  `denychars` varchar(128) NOT NULL,
  `delimiter` varchar(128) NOT NULL,
  `prefix` varchar(128) NOT NULL, 
  `suffix` varchar(128) NOT NULL, 
  `seperator` varchar(128) NOT NULL,

  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `config_buildersave` (
  `id` int(120) NOT NULL auto_increment,
  `builderid` int(120) NOT NULL default '0',
  `itemid` int(120) NOT NULL default '0',
  `ugid` int(120) NOT NULL default '0',
  `value` longtext NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


ALTER TABLE `addoncategorys` ADD `rank` int(10) default '0' ;

ALTER TABLE `categories` ADD `rank` int(10) default '0' ;

ALTER TABLE `addons` ADD `category` int(5) default '0' ;

ALTER TABLE `addons` CHANGE `category` `category` INT( 5 ) NULL DEFAULT '0';

ALTER TABLE `addons` ADD `doexecute` int(1) default '0' ;

ALTER TABLE `addons` ADD `winexeccmd` LONGTEXT NULL ;

ALTER TABLE `addons` ADD `execcmd` LONGTEXT NULL ;

ALTER TABLE `queue` ADD `rundate` varchar(12) default '' ;

ALTER TABLE `queue` ADD `rundatestatus` int(1) default '0' ;

ALTER TABLE `queue` ADD `fraudcheck` LONGTEXT NULL ;

ALTER TABLE `users` ADD `quota` LONGTEXT NULL ;

ALTER TABLE `users` ADD `shortcuts` LONGTEXT NULL ;

ALTER TABLE `users` ADD `permissions` LONGTEXT NULL ;

ALTER TABLE `users` ADD `credit` varchar(128) default '' ;

ALTER TABLE `users` ADD `apiaccess` varchar(128) default 'no' ;

ALTER TABLE `users` ADD `location` varchar(128) default '' ;

ALTER TABLE `users` ADD `theme` varchar(128) default '' ;

ALTER TABLE `users` ADD `style` varchar(128) default '' ;

ALTER TABLE `users` ADD `taxid` varchar(128) default '' ;

ALTER TABLE `users` ADD `suspend` varchar(128) default '' ;

ALTER TABLE `users` ADD `keystring` varchar(128) default '' ;

ALTER TABLE `users` ADD `currency` varchar(128) default '' ;

ALTER TABLE `users` ADD `taxed` INT( 1 )  NULL DEFAULT '0';

ALTER TABLE `users` CHANGE `lang` `lang` VARCHAR( 32 ) NULL DEFAULT 'en' ;

ALTER TABLE `users` ADD `api_key` TEXT NOT NULL , ADD `api_ip` TEXT NOT NULL ;

ALTER TABLE `users` CHANGE  `api_key`  `api_key` TEXT NOT NULL DEFAULT  '';

ALTER TABLE `users` CHANGE  `api_ip`  `api_ip` TEXT NOT NULL DEFAULT  '';

ALTER TABLE `usersubaccounts` ADD `games` LONGTEXT NULL ;

ALTER TABLE  `usersubaccounts` CHANGE  `password`  `password` TEXT NULL ;

ALTER TABLE `usersubaccounts` ADD `keystring` varchar(128) default '' ;

ALTER TABLE `usersubaccounts` CHANGE  `password`  `password` TEXT NOT NULL DEFAULT  '';

ALTER TABLE `usersubaccounts` ADD `api_key` TEXT NOT NULL , ADD `api_ip` TEXT NOT NULL ;

ALTER TABLE `schedule` ADD `users` LONGTEXT NULL;

ALTER TABLE `schedule` ADD `next_run` varchar(128) default '' ;

ALTER TABLE `schedule` ADD `ran_last` varchar(128) default '' ;

ALTER TABLE `schedule` ADD `cmdid` varchar(128) default '' ;

ALTER TABLE  `userschedule` ADD  `settings` TEXT NULL

ALTER TABLE `usergames` ADD `firewall` INT( 1 ) NULL DEFAULT '1';

ALTER TABLE `usergames` ADD `lastplayers` LONGTEXT NULL;

ALTER TABLE `usergames` ADD `statscache` LONGTEXT NULL;

ALTER TABLE `usergames` ADD `ports` LONGTEXT NULL;

ALTER TABLE `usergames` ADD `statscachetime` varchar(128) default '' ;

ALTER TABLE `usergames` ADD `fastdl` varchar(128) default '' ;

ALTER TABLE `usergames` ADD `lastmaps` LONGTEXT NULL;

ALTER TABLE `usergames` ADD `firewallports` LONGTEXT NULL;

ALTER TABLE `usergames` ADD `lastplytime` varchar(128) default NULL;

ALTER TABLE `usergames` ADD `suspend` varchar(128) default NULL;

ALTER TABLE `usergames` ADD `lastmapstime` varchar(128) default NULL;

ALTER TABLE `usergames` ADD `lastactivetime` varchar(128) default NULL;

ALTER TABLE `usergames` ADD `stopempty` INT(18) default NULL;

ALTER TABLE `usergames` CHANGE `status` `status` INT( 1 ) NOT NULL DEFAULT '0';

ALTER TABLE `usergames` CHANGE `lastplayers` `lastplayers` LONGTEXT NULL ;

ALTER TABLE `game` CHANGE  `installedon`  `installedon` LONGTEXT NULL ;

ALTER TABLE `game` ADD `steamid` INT( 10 ) NULL DEFAULT '0';

ALTER TABLE `game` ADD `steammod` varchar(128) default NULL;

ALTER TABLE `usergames` ADD `startserver` varchar(128) default NULL;

ALTER TABLE `usergames` ADD `defaultinfo` LONGTEXT;

ALTER TABLE `usergames` ADD `notes` LONGTEXT;

ALTER TABLE `usergames` ADD `permissions` LONGTEXT NOT NULL;

ALTER TABLE `usergames` ADD `branding` LONGTEXT;

ALTER TABLE `usergames` ADD `brandingon` INT( 1 ) NULL DEFAULT '0';

ALTER TABLE `usergames` ADD `addonstatus` LONGTEXT;

ALTER TABLE `usergames` ADD `updatestatus` INT( 1 ) NULL DEFAULT '0';

ALTER TABLE `usergames` ADD `eac` INT( 1 ) NULL DEFAULT '0';

ALTER TABLE `usergames` ADD `eactype` INT( 1 ) NULL DEFAULT '0';

ALTER TABLE `usergames` ADD `monitor_down` INT( 1 ) NULL DEFAULT '0';

ALTER TABLE `usergames` ADD INDEX  `ip` (  `ip` );

ALTER TABLE `usergames` ADD INDEX  `port` (  `port` );

ALTER TABLE `usergames` ADD INDEX  `cid` (  `cid` );

ALTER TABLE `usergames` ADD INDEX  `active` (  `active` );

ALTER TABLE `userbills` ADD `tax` varchar(20) NULL DEFAULT '0';

ALTER TABLE `userbills` ADD `ugid` varchar(20) NULL DEFAULT '';

ALTER TABLE `userbills` ADD `uvid` varchar(20) NULL DEFAULT '';

ALTER TABLE `userbills` ADD `description` LONGTEXT NULL ;

ALTER TABLE `userbills` ADD `taxed` INT( 1 )  NULL DEFAULT '0'; ;

ALTER TABLE `billing` ADD `promo` LONGTEXT;

ALTER TABLE `billing` ADD `services` LONGTEXT;

ALTER TABLE `billing` ADD `taxes` LONGTEXT;

ALTER TABLE `billing` ADD `taxtotal` varchar(12) default NULL;

ALTER TABLE `prices` ADD `description` LONGTEXT;

ALTER TABLE `userconfigs` ADD `fencoding` varchar(12) default NULL;

ALTER TABLE `userconfigs` ADD `cfgid` INT( 12 )  NULL DEFAULT '0'; ;

ALTER TABLE `userconfigs` CHANGE `contents` `contents` LONGTEXT NOT NULL;

ALTER TABLE `userconfigs` ADD `edittype` varchar(128) default NULL default '';

ALTER TABLE `userconfigs` ADD `autoexec` int(1) default NULL default '0';

ALTER TABLE `userconfigs` ADD `editable` int(1) default NULL default '1';

ALTER TABLE `userconfigs` ADD `configbuilder` int(1) default NULL default '0';

ALTER TABLE `userconfigs` ADD `hidecfg` int(1) default NULL default '0';

ALTER TABLE `packages` ADD `img` LONGTEXT , ADD `description` LONGTEXT ;

ALTER TABLE `game` ADD `ports` LONGTEXT;

ALTER TABLE `game` ADD `altinstall` LONGTEXT;

ALTER TABLE `game` ADD `altinstallwin` LONGTEXT;

ALTER TABLE `game` ADD `files` LONGTEXT;

ALTER TABLE `game` ADD `branding` LONGTEXT;

ALTER TABLE `game` ADD `fastdl_sync` INT( 1 ) NULL DEFAULT '0';

ALTER TABLE `game` ADD `fastdl_enable` INT( 1 ) NULL DEFAULT '0';

ALTER TABLE `game` ADD `fastdl_compression` varchar(128) default NULL default '';

ALTER TABLE `game` ADD `fastdl_include`  LONGTEXT;

ALTER TABLE `game` ADD `fastdl_exclude` LONGTEXT;

ALTER TABLE `game` ADD `brandingon` INT( 1 ) NULL DEFAULT '0';

ALTER TABLE `game` ADD `maxplayers2` INT( 1 ) NULL;

ALTER TABLE `game` ADD `lsofcheck` INT( 1 ) NULL;

ALTER TABLE `game` ADD `mapimgdir` LONGTEXT;

ALTER TABLE `game` ADD `edittype` varchar(128) NOT NULL default '';

ALTER TABLE `game` ADD `pidstop` varchar(128) NOT NULL default '';

ALTER TABLE `game` ADD `exedir` varchar(128) NOT NULL default '';

ALTER TABLE `game` ADD `exestop` LONGTEXT;

ALTER TABLE `game` ADD `disableconsole` INT( 1 ) NULL DEFAULT '0';

ALTER TABLE `game` ADD `disableconfigs` INT( 1 ) NULL DEFAULT '0';

ALTER TABLE `game` ADD `disableftp` INT( 1 ) NULL DEFAULT '0';

ALTER TABLE `game` ADD `disablefirewall` INT( 1 ) NULL DEFAULT '0';

ALTER TABLE `game` ADD `exedir` varchar(128) NOT NULL default '';

ALTER TABLE `game` ADD `stopmode` LONGTEXT;

ALTER TABLE `game` ADD `winstopmode` LONGTEXT;

ALTER TABLE `game` ADD `winstopconsole` LONGTEXT;

ALTER TABLE `game` ADD `stopconsole` LONGTEXT;

ALTER TABLE `gameconfigs` ADD `fencoding` varchar(12) NOT NULL default '';

ALTER TABLE `gameconfigs` ADD `edittype` varchar(128) NOT NULL default '';

ALTER TABLE `gameconfigs` ADD `autoexec` int(1) default NULL default '0';

ALTER TABLE `gameconfigs` ADD `editable` int(1) default NULL default '1';

ALTER TABLE `gameconfigs` ADD `configbuilder` int(1) default NULL default '0';

ALTER TABLE `gameconfigs` CHANGE `config` `config` LONGTEXT NOT NULL;

ALTER TABLE `uservoice` ADD `api_id` int(100) NULL DEFAULT '0';

ALTER TABLE `uservoice` ADD `api_id2` int(100) NULL DEFAULT '0';

ALTER TABLE `servers` ADD `servernotes` LONGTEXT;

ALTER TABLE `servers` ADD `statscache` LONGTEXT;

ALTER TABLE `servers` ADD `statstime` varchar(128) NOT NULL DEFAULT '';

ALTER TABLE `servers` ADD `webroot` varchar(128) NOT NULL DEFAULT '';

ALTER TABLE `servers` ADD `parent` varchar(128) NOT NULL DEFAULT '';

ALTER TABLE `servers` ADD `repo` varchar(128) NOT NULL DEFAULT '';

ALTER TABLE `servers` ADD `dashboard` int(1) NOT NULL DEFAULT '1';

ALTER TABLE `servers` ADD `ts2port` int(40) NOT NULL DEFAULT '51234';

ALTER TABLE `servers` ADD `ts3port` int(40) NOT NULL DEFAULT '10011';

ALTER TABLE `servers` ADD `webrooturl` varchar(128) NOT NULL DEFAULT '';

ALTER TABLE `servers` ADD `webservices` LONGTEXT;

ALTER TABLE `servers` ADD `cvars` LONGTEXT;

ALTER TABLE `servers` ADD `shownotes` INT( 1 ) NOT NULL DEFAULT '0';

ALTER TABLE `servers` ADD `timeout` INT( 3 ) NOT NULL DEFAULT '30';

ALTER TABLE `servers` ADD `ipuse` INT( 3 ) NOT NULL DEFAULT '1';

ALTER TABLE `servers` ADD `iptablesconf` varchar(128) NOT NULL DEFAULT '/etc/iptables.conf';

ALTER TABLE `servers` ADD `eacdir` varchar(128) NOT NULL DEFAULT '';

ALTER TABLE `servers` ADD `active` INT( 1 ) NOT NULL DEFAULT '1';

ALTER TABLE `payments` ADD `transactionid` varchar(128) NOT NULL default '';

ALTER TABLE `payments` ADD `gateway` varchar(128) NOT NULL default '';

ALTER TABLE `payments` ADD `fee` varchar(128) NOT NULL default '';

ALTER TABLE `ttsystem` ADD `mail_id` INT( 255 ) NOT NULL DEFAULT '0';

ALTER TABLE `ttsystem` ADD `assigned` INT( 255 ) default NULL;

ALTER TABLE `ttsystem` ADD `mail_address` varchar(128) default NULL;

ALTER TABLE `settings` ADD PRIMARY KEY ( `name` ) ;

INSERT IGNORE INTO `settings` SET name='neworder_title', value='New Order' ;

INSERT IGNORE INTO `settings` SET name='donation_title', value='Donation for' ;

INSERT IGNORE INTO `settings` SET name='payment_title', value='Invoice payment for' ;

INSERT IGNORE INTO `settings` SET name='neworder_description', value='New Order' ;

INSERT IGNORE INTO `settings` SET name='donation_description', value='Donation' ;

INSERT IGNORE INTO `settings` SET name='payment_description', value='Invoice #' ;

INSERT IGNORE INTO `settings` SET name='auto_setup', value='1' ;

INSERT IGNORE INTO `settings` SET name='steam_user', value='' ;

INSERT IGNORE INTO `settings` SET name='steam_pass', value='' ;

INSERT IGNORE INTO `settings` SET name='steam_code', value='' ;

INSERT IGNORE INTO `settings` SET name='steam_daily', value='' ;

INSERT IGNORE INTO `settings` SET name='steam_daily_ran', value='' ;

INSERT IGNORE INTO `settings` SET name='userprefix', value='client' ;

INSERT IGNORE INTO `settings` SET name='userlistmode', value='1' ;

INSERT IGNORE INTO `settings` SET name='ran_cache', value='' ;

INSERT IGNORE INTO `settings` SET name='ran_monitor', value='' ;

INSERT IGNORE INTO `settings` SET name='ran_auto', value='' ;

INSERT IGNORE INTO `settings` SET name='ran_quota', value='' ;

INSERT IGNORE INTO `settings` SET name='ran_imap', value='' ;

INSERT IGNORE INTO `settings` SET name='ran_queue', value='' ;

INSERT IGNORE INTO `settings` SET name='ran_scheduler', value='' ;

INSERT IGNORE INTO `settings` SET name='dateformatui', value='yy-mm-dd' ;

INSERT IGNORE INTO `settings` SET name='queryinternalip', value='no' ;

INSERT IGNORE INTO `settings` SET name='userrechekcdelay', value='90' ;

INSERT IGNORE INTO `settings` SET name='bccmails', value='' ;

INSERT IGNORE INTO `settings` SET name='inactivett', value='' ;

INSERT IGNORE INTO `settings` SET name='CLEAREVENTLOGS', value='604800' ;

INSERT IGNORE INTO `settings` SET name='gzip', value='true' ;

INSERT IGNORE INTO `settings` SET name='cachedelay', value='90' ;

INSERT IGNORE INTO `settings` SET name='rescandelay', value='45' ;

INSERT IGNORE INTO `settings` SET name='backupemail', value='' ;

INSERT IGNORE INTO `settings` SET name='disableevents', value='0' ;

INSERT IGNORE INTO `settings` SET name='dateformat', value='Y-m-d' ;

INSERT IGNORE INTO `settings` SET name='dateformattpl', value='%Y-%m-%d' ;

INSERT IGNORE INTO `settings` SET name='emailNotify', value='' ;

INSERT IGNORE INTO `settings` SET name='ttuid', value='' ;

INSERT IGNORE INTO `settings` SET name='imapuser', value='' ;

INSERT IGNORE INTO `settings` SET name='imappw', value='' ;

INSERT IGNORE INTO `settings` SET name='imapserver', value='' ;

INSERT IGNORE INTO `settings` SET name='imapport', value='' ;

INSERT IGNORE INTO `settings` SET name='imapauth', value='' ;

INSERT IGNORE INTO `settings` SET name='slogan', value='Game Server Control Panel' ;

INSERT IGNORE INTO `settings` SET name='monitorlock', value='0' ;

INSERT IGNORE INTO `settings` SET name='queue_mail', value='0' ;

INSERT IGNORE INTO `settings` SET name='graphlock', value='0' ;

INSERT IGNORE INTO `settings` SET name='imapdelete', value='no' ;

INSERT IGNORE INTO `settings` SET name='showinstallhelp', value='no' ;

INSERT IGNORE INTO `settings` SET name='orderstyle', value='x' ;

INSERT IGNORE INTO `settings` SET name='basicindex', value='false' ;

INSERT IGNORE INTO `settings` SET name='rrdUseEXEC', value='false' ;

INSERT IGNORE INTO `settings` SET name='diplay_notifications', value='yes' ;

INSERT IGNORE INTO `settings` SET name='sm_sleeptime', value='30';

INSERT IGNORE INTO `settings` SET name='sm_maxLoad', value='110';

INSERT IGNORE INTO `settings` SET name='sm_smmaxLoad', value='100';

INSERT IGNORE INTO `settings` SET name='sm_smmaxLoadon', value='0';

INSERT IGNORE INTO `settings` SET name='sm_restartOverloaded',value='0';

INSERT IGNORE INTO `settings` SET name='sm_constantScanDelay', value='0';

INSERT IGNORE INTO `settings` SET name='sm_privatekill', value= '0';

INSERT IGNORE INTO `settings` SET name='sm_timekill', value= '1';

INSERT IGNORE INTO `settings` SET name='sm_downTicket', value= '1';

INSERT IGNORE INTO `settings` SET name='sm_doMachineGraphs', value= '1';

INSERT IGNORE INTO `settings` SET name='sm_emailNotify', value= '0';

INSERT IGNORE INTO `settings` SET name='sm_activeScan', value= '1';

INSERT IGNORE INTO `settings` SET name='webcron', value= '0';

INSERT IGNORE INTO `settings` SET name='reload_ajax_pages', value= 'true';

INSERT IGNORE INTO `settings` SET name='track_user_pages', value= 'true';

INSERT IGNORE INTO `settings` SET name='force_sqlcharset', value= 'true';

INSERT IGNORE INTO `settings` SET name='sm_brandstop', value= '2';

INSERT IGNORE INTO `settings` SET name='sm_disablebrand', value= '1';

INSERT IGNORE INTO `settings` SET name='sm_disablebrandcheck', value= '0';

INSERT IGNORE INTO `settings` SET name='sm_scanquery', value= '1';

INSERT IGNORE INTO `settings` SET name='clientchangemail', value= '0';

INSERT IGNORE INTO `settings` SET name='subuno', value= 'no';

INSERT IGNORE INTO `settings` SET name='subunomanual', value= 'yes';

INSERT IGNORE INTO `settings` SET name='subunokey', value= '';

INSERT IGNORE INTO `settings` SET name='sendorderreceipt', value= '1';

INSERT IGNORE INTO `settings` SET name='tos', value= '<h2>	Terms and Conditions of Use</h2><h3>	1. Terms</h3><p>	By accessing this web site, you are agreeing to be bound by these 	web site Terms and Conditions of Use, all applicable laws and regulations, 	and agree that you are responsible for compliance with any applicable local 	laws. If you do not agree with any of these terms, you are prohibited from 	using or accessing this site. The materials contained in this web site are 	protected by applicable copyright and trade mark law.</p><h3>	2. Use License</h3><ol type="a">	<li>		Permission is granted to temporarily download one copy of the materials 		(information or software) on %domainName%\'s web site for personal, 		non-commercial transitory viewing only. This is the grant of a license, 		not a transfer of title, and under this license you may not:				<ol type="i">			<li>modify or copy the materials;</li>			<li>use the materials for any commercial purpose, or for any public display (commercial or non-commercial);</li>			<li>attempt to decompile or reverse engineer any software contained on %domainName%\'s web site;</li>			<li>remove any copyright or other proprietary notations from the materials; or</li>			<li>transfer the materials to another person or "mirror" the materials on any other server.</li>		</ol>	</li>	<li>		This license shall automatically terminate if you violate any of these restrictions and may be terminated by %domainName% at any time. Upon terminating your viewing of these materials or upon the termination of this license, you must destroy any downloaded materials in your possession whether in electronic or printed format.	</li></ol><h3>	3. Disclaimer</h3><ol type="a">	<li>		The materials on %domainName%\'s web site are provided "as is". %domainName% makes no warranties, expressed or implied, and hereby disclaims and negates all other warranties, including without limitation, implied warranties or conditions of merchantability, fitness for a particular purpose, or non-infringement of intellectual property or other violation of rights. Further, %domainName% does not warrant or make any representations concerning the accuracy, likely results, or reliability of the use of the materials on its Internet web site or otherwise relating to such materials or on any sites linked to this site.	</li></ol><h3>	4. Limitations</h3><p>	In no event shall %domainName% or its suppliers be liable for any damages (including, without limitation, damages for loss of data or profit, or due to business interruption,) arising out of the use or inability to use the materials on %domainName%\'s Internet site, even if %domainName% or a %domainName% authorized representative has been notified orally or in writing of the possibility of such damage. Because some jurisdictions do not allow limitations on implied warranties, or limitations of liability for consequential or incidental damages, these limitations may not apply to you.</p>			<h3>	5. Revisions and Errata</h3><p>	The materials appearing on %domainName%\'s web site could include technical, typographical, or photographic errors. %domainName% does not warrant that any of the materials on its web site are accurate, complete, or current. %domainName% may make changes to the materials contained on its web site at any time without notice. %domainName% does not, however, make any commitment to update the materials.</p><h3>	6. Links</h3><p>	%domainName% has not reviewed all of the sites linked to its Internet web site and is not responsible for the contents of any such linked site. The inclusion of any link does not imply endorsement by %domainName% of the site. Use of any such linked web site is at the user\'s own risk.</p><h3>	7. Site Terms of Use Modifications</h3><p>	%domainName% may revise these terms of use for its web site at any time without notice. By using this web site you are agreeing to be bound by the then current version of these Terms and Conditions of Use.</p><h3>	8. Governing Law</h3><p>	Any claim relating to %domainName%\'s web site shall be governed by the laws of the United States without regard to its conflict of law provisions.</p><p>	General Terms and Conditions applicable to Use of a Web Site.</p><h2>	Privacy Policy</h2><p>	Your privacy is very important to us. Accordingly, we have developed this Policy in order for you to understand how we collect, use, communicate and disclose and make use of personal information. The following outlines our privacy policy.</p><ul>	<li>		Before or at the time of collecting personal information, we will identify the purposes for which information is being collected.	</li>	<li>		We will collect and use of personal information solely with the objective of fulfilling those purposes specified by us and for other compatible purposes, unless we obtain the consent of the individual concerned or as required by law.			</li>	<li>		We will only retain personal information as long as necessary for the fulfillment of those purposes. 	</li>	<li>		We will collect personal information by lawful and fair means and, where appropriate, with the knowledge or consent of the individual concerned. 	</li>	<li>		Personal data should be relevant to the purposes for which it is to be used, and, to the extent necessary for those purposes, should be accurate, complete, and up-to-date. 	</li>	<li>		We will protect personal information by reasonable security safeguards against loss or theft, as well as unauthorized access, disclosure, copying, use or modification.	</li>	<li>		We will make readily available to customers information about our policies and practices relating to the management of personal information. 	</li></ul><p>	We are committed to conducting our business in accordance with these principles in order to ensure that the confidentiality of personal information is protected and maintained. </p>	';

INSERT IGNORE INTO `settings` SET name='stepdelay', value= '360';

INSERT IGNORE INTO `settings` SET name='qstattimeout', value= '900';

INSERT IGNORE INTO `settings` SET name='INVOICEHEADER', value= '';

INSERT IGNORE INTO `settings` SET name='taxEnable', value= 'no';

INSERT IGNORE INTO `settings` SET name='taxCompound', value= 'no';

INSERT IGNORE INTO `settings` SET name='ALLOWUPLOADS', value= 'no';

INSERT IGNORE INTO `settings` SET name='DISABLEXTRACT', value= 'yes';

INSERT IGNORE INTO `settings` SET name='taxType', value= 'inclusive';

INSERT IGNORE INTO `settings` SET name='currencyChar2', value= '';

INSERT IGNORE INTO `settings` SET name='currencyFormat', value= '1';

INSERT IGNORE INTO `settings` SET name='enable_disk_quota', value= '0';

INSERT IGNORE INTO `settings` SET name='userpermissions', value= '';

INSERT IGNORE INTO `settings` SET name='sqlcharset', value= 'utf8';

INSERT IGNORE INTO `settings` SET name='eac', value= '0';

INSERT IGNORE INTO `settings` SET name='machinestatscache', value= '300';

INSERT IGNORE INTO `settings` SET name='tteShowLink', value= '1';

INSERT IGNORE INTO `settings` SET name='sm_overlimit', value= '1';

INSERT IGNORE INTO `settings` SET name='notifyadminpayment', value= '1';

INSERT IGNORE INTO `settings` SET name='sm_downRestart', value= '1';

ALTER TABLE `gateways` ADD `value4` varchar(128) default NULL ;

ALTER TABLE `gateways` ADD `value5` varchar(128) default NULL ;

ALTER TABLE `gateways` ADD `value6` varchar(128) default NULL ;

ALTER TABLE `gateways` ADD `value7` varchar(128) default NULL ;

ALTER TABLE `gateways` ADD `value8` varchar(128) default NULL ;

ALTER TABLE `gateways` ADD `value9` varchar(128) default NULL ;

ALTER TABLE `gateways` ADD `value10` varchar(128) default NULL ;

ALTER TABLE `packages` ADD `tax` INT( 1 )  NULL DEFAULT '0'; ;

ALTER TABLE `packages` ADD `eid` INT( 128 )  default NULL ; ;

ALTER TABLE `packages` ADD `addontax` INT( 1 )  NULL DEFAULT '0'; ;

ALTER TABLE `packages` ADD `category` INT( 30 )  NULL DEFAULT '0'; ;

ALTER TABLE `packages` CHANGE `img` `img` LONGTEXT NULL;

ALTER TABLE `packages` CHANGE `description` `description` LONGTEXT NULL;

ALTER TABLE `gameupdates` CHANGE `gid` `gid` LONGTEXT NOT NULL;

ALTER TABLE `gameupdates` ADD `wincommand` LONGTEXT;

ALTER TABLE `gameupdates` ADD `waitreply` INT( 1 ) NULL;

ALTER TABLE `gameupdates` ADD `status` INT( 1 ) NULL;

ALTER TABLE `gameupdates` ADD `syncmasterwin` INT( 1 ) NULL;

ALTER TABLE `gameupdates` ADD `syncmasterlinux` INT( 1 ) NULL;

ALTER TABLE `gameupdates` ADD `md5sums` LONGTEXT;

ALTER TABLE `gameupdates` ADD `log` LONGTEXT;

ALTER TABLE `gameupdates` ADD `winrepo` LONGTEXT;

ALTER TABLE `gameupdates` ADD `linuxrepo` LONGTEXT;

ALTER TABLE `gameupdates` ADD `lastran` varchar(128) default NULL ;

ALTER TABLE `gameupdates` ADD `linuxsize` varchar(128) default NULL ;

ALTER TABLE `gameupdates` ADD `winsize` varchar(128) default NULL ;

ALTER TABLE `gameupdates` ADD `steamid` varchar(128) default NULL ;

ALTER TABLE `gameupdates` ADD `steammod` varchar(128) default NULL ;

INSERT IGNORE INTO `settings` SET name='masterrepowin', value= '';

INSERT IGNORE INTO `settings` SET name='masterrepolinux', value= '';

INSERT IGNORE INTO `settings` SET name='gcplickey', value= '';

INSERT IGNORE INTO `settings` SET name='gcplocalkey', value= '';

INSERT IGNORE INTO `settings` SET name='repo_daily_ran', value= '';

INSERT IGNORE INTO `settings` SET name='SHOWEMPTYPRODUCTS', value= '0';

ALTER TABLE  `packages` ADD  `module` VARCHAR( 128 ) NULL;

ALTER TABLE `packages` CHANGE `tax` `tax` INT( 1 ) NOT NULL DEFAULT '0', CHANGE `addontax` `addontax` INT( 1 ) NOT NULL DEFAULT '0';

ALTER TABLE `users` DROP `pid`;

ALTER TABLE `users` DROP `gid`;

ALTER TABLE `users` DROP `tsUser`;

ALTER TABLE `users` DROP `tsPass`;

ALTER TABLE `users` DROP `tsPort`;

ALTER TABLE `users` DROP `tsip`;

ALTER TABLE `users` DROP `installtype`;

ALTER TABLE `users` DROP `ip`;

ALTER TABLE `users` DROP `port`;

ALTER TABLE `users` DROP `sid`;

ALTER TABLE `users` DROP `hostname`;

ALTER TABLE `servers` DROP `wininstalldrive`;

DELETE FROM `settings` WHERE `name` = 'tableheaderbg' OR `name` = 'darktable' OR `name` = 'tsUrl' OR `name` = 'WINPASS' OR `name` = 'WINDRIVE' OR `name` = 'fontcolor' OR `name` = 'CLIENTADDON' OR `name` = 'tsPass' OR `name` = 'tsUser' OR `name` = 'SSHTIMEOUT';

DROP TABLE  `config_builder`;

DROP TABLE  `config_buildergames`;

DROP TABLE  `config_buildersaved`;

DROP TABLE  `instructions`;

DELETE FROM settings WHERE name='databaseip' OR name='dbuser' OR name='databasedb' OR name='dbpass' OR name='ALTLICENSE' OR name='bgcolor' OR name='bordercolor' OR name='tableheaderbg' OR name='alink' OR name='avisited' OR name='aactive' OR name='ahover' OR name='fontsize' OR name='fontsizelarge' OR name='fontsizemed' OR name='fontsizesmall' OR name='linkfontsize';

ALTER TABLE game DROP INDEX name;

ALTER TABLE  prices` ADD INDEX  `pid` (  `pid` );

ALTER TABLE  `users` CHANGE  `email`  `email` VARCHAR( 254 ) NOT NULL DEFAULT  ''

UPDATE `settings` SET value= '' WHERE name='gcplocalkey';

ALTER TABLE  `game` CHANGE  `fastdl_compression`  `fastdl_compression` VARCHAR( 128 ) NULL DEFAULT NULL , CHANGE  `fastdl_include`  `fastdl_include` LONGTEXT NULL DEFAULT NULL , CHANGE  `fastdl_exclude`  `fastdl_exclude` LONGTEXT NULL DEFAULT NULL , CHANGE  `disablefirewall`  `disablefirewall` INT( 1 ) NULL DEFAULT NULL 

ALTER TABLE  `gameupdates` ADD  `log` LONGTEXT NOT NULL ;