
<div id="step1">
	<div class="click">
		<div class="step_body">
			<h3>Welcome to the GameCP Setup Wizard</h3>
			<p>The Setup Wizard will help guide you through the installation of this software.</p>
			<p>Click '{if $doUpgrade}Start Upgrade{else}Start Install{/if}' to begin.</p>


			{if $doUpgrade && $encrypted == "0"}
				<p><h4>Security Upgrade</h4>
				<input type="checkbox" value="1" id="encrypt"><label for="encrypt">Enable password encryption</label></p>
			{else}
				<input type="checkbox" id="encrypt" style="display: none;">
			{/if}


			<noscript><p><br>The Setup Wizard requires that you enable javascript in your web-browser.</p></noscript>

		</div>
		<div class="button" onclick="firstStep({$doUpgrade});">
			{if $doUpgrade}Start Upgrade{else}Start Install{/if}
		</div>
	</div>
</div>

<div id="step2">
	{if $doUpgrade}

		<div id="step2load">
			<img src="template/loader.gif" width="32" height="32" alt="">
			<p>Upgrading, please wait...</p>
		</div>

		<div id="step2true" class="step_body">
			<h3>Upgrading Complete</h3>
			<p>The Setup Wizard has upgraded your GameCP Master Server</p>

			{include file="secureinstall.tpl"}

			<div class="button" onclick="window.location='../system/';">
				Login to Panel	
			</div>
		</div>

		<div id="step2false" class="step_body">
			<h3>Setup Wizard encounted an error!</h3>
			<p>There was an error while trying to update GameCP.</p>

			<div id="step2error"></div>

			<p>Go back and try again. If the problem persists contact GameCP Support.</p>

			<div class="button goback" onclick="$('#step2').fadeOut(function(){ldelim}$('#step1').fadeIn(){rdelim});">
				Go Back
			</div>
		</div>


	{else}
		<div id="step2details" class="step_body">
			<h3>MySQL Server Details</h3>
			<p>The Setup Wizard requires a MySQL username, password &amp; empty database.</p>
			<p>Please supply your MySQL information or <a href="javascript:void(0);" onclick="launchMySQLCreate();">Create a New Account &amp; Database</a></p>

			<table class="sqlform">
				<tr>
					<td><label for="sqluser">Database User</label></td><td><input type="text" name="sqluser" id="sqluser" value="gcp" onclick="if(this.value == 'gcp') this.value='';"></td>
				</tr>
				<tr>
					<td><label for="sqlpass">Database Password</label></td><td><input type="password" name="sqlpass" id="sqlpass"></td>
				</tr>
				<tr>
					<td><label for="sqldb">Database Name</label></td><td><input type="text" name="sqldb" id="sqldb" value="gcp" onclick="if(this.value == 'gcp') this.value='';"></td>
				</tr>
				<tr>
					<td><label for="sqlhost">Database Host</label></td><td><input type="text" name="sqlhost" id="sqlhost" value="127.0.0.1" onclick="if(this.value == '127.0.0.1') this.value='';"></td>
				</tr>
			</table>

			<div id="badsql"><p>Setup Wizard was unable to access MySQL with the supplied information.</p>Please try again.</div>

			<div class="button large" onclick="validateMySQL();">
				Validate Information
			</div>
			<div class="button goback" onclick="$('#step2').fadeOut(function(){ldelim}$('#step1').fadeIn(){rdelim});">
				Go Back
			</div>
		</div>
		<div id="step2error" class="step_body">
			<h3>Setup Wizard encounterd an error</h3>
			<p>There have been one or more errors reported while trying to install GameCP.</p>
			<ul id="step2ul">
				{include file="errorloop.tpl"}
				<li style="display: none;">&nbsp;</li>
			</ul>
			<p>Please correct any errors you see and try again.</p>

			<div class="button" onclick="validateInstall();">
				Try Again
			</div>
		</div>
		{if !is_array($ValidateInstall)}
			<script type="text/javascript">$('#step2details').show();</script>
		{else}
			<script type="text/javascript">$('#step2error').show();</script>
		{/if}

	{/if}
</div>

<div id="step3">
	<h3>Account Details</h3>
	<div class="step_body">
		<table class="detailsform">
			<tr>
				<td><label for="email">E-mail Address</label></td><td><input type="text" name="email" id="email"></td>
			</tr>
			<tr>
				<td><label for="password">Password</label></td><td><input type="password" name="password" id="password"></td>
			</tr>
			<tr style="display:none">
				<td><label for="username">Desired Username</label></td><td><input type="text" value="admin" name="username" id="username"></td>
			</tr>
				<tr>
				<td><label for="license">License Key</label></td><td><input required type="text" name="license" id="license" class="form-control"></td>
			</tr>
		<tr style="display:none">
				<td><label for="style">Default Style</label></td>
				<td>
					<select name="style" id="style">
						<option value="x">Default</option>
					</select>
				</td>
			</tr>
		</table>

		<div id="eula">{include file="eula.tpl"}</div>

		<p><input type="checkbox" name="agree_tos" id="agreetos"><label for="agreetos">I agree to the</label> <a href="javascript:void(0);" class="eulalink" onclick="$('#eula').fadeIn();">GameCP EULA</a></p>

		<div id="step3required">All fields are required.</div>

		<div class="button" onclick="submitProfile();">
			Install
		</div>
		<div class="button goback" onclick="$('#step3').fadeOut(function(){ldelim}$('#step2').fadeIn(){rdelim});">
			Go Back
		</div>
	</div>
</div>

<div id="step4">
	<div id="step4load">
		<img src="template/loader.gif" width="32" height="32" alt="">
		<p>Installing, please wait...</p>
	</div>

	<div id="step4false" class="step_body">
		<h3>Setup Wizard encounted an error!</h3>
		<p>There was an error while trying to install GameCP.</p>

		<div id="step4error"></div>

		<p>Go back and try again. If the problem persists contact GameCP Support.</p>

		<div class="button goback" onclick="$('#step4').fadeOut(function(){ldelim}$('#step3').fadeIn(){rdelim});">
			Go Back
		</div>
	</div>
	<div id="step4true" class="step_body">
		<h3>Congratulations! GameCP has been installed</h3>
		<p>The Setup Wizard has completed the installation of the GameCP Master Server.</p>

		<h4>Account Information</h4>
		<table class="accountinfo">
			<tr><td>Access URL:</td><td>{$website}</td></tr>
			<tr><td>E-mail:</td><td id="displayemail"></td></tr>
			<tr><td>Password:</td><td id="displaypass"></td></tr>
		</table>

		<h4>Login to GameCP</h3>
		<span><a href="{$website}">Click here</a> to login to GameCP now.</span>

		{include file="secureinstall.tpl"}

		<h4>Next Steps</h4>
		<ol>
			<li><a href="http://wiki.gamecp.com/Secure_GameCP">Secure your panel</a></li>
			<li><a href="http://wiki.gamecp.com/Configure_Remote_Servers">Configure a remote server</a></li>
			<li><a href="http://wiki.gamecp.com/w/index.php?title=FTP_Servers">Configure FTPD Servers</a></li>
			<li><a href="http://wiki.gamecp.com/Getting_Started">Configure services</a></li>
			<li><a href="http://wiki.gamecp.com/Creating_a_client">Create a client</a></li>
		</ol>
	</div>
		<h4>Help Resources</h4>
		<ul>
			<li><a href="http://wiki.gamecp.com">Browse the GameCP Wiki</a></li>
		</ul>
	</div>

</div>
