<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/

require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');

if(!isset($mode) || isset($mode) && !$mode) $mode = "edit";

$GameCP->CheckPermissions('clients');

$smarty->assign('page_title', $LNG_CLIENTMANAGEMENT);


if(isset($_REQUEST['idd'])){
	$_REQUEST['idd']=$GameCP->whitelist($_REQUEST['idd'], "int");
	$idd=$_REQUEST['idd'];
	if(!$GameCP->UserCanEdit($idd)){
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$Panel->ErrorExit("You do not have permission to view this page.");
	}
}

if ($_SESSION['gamecp']['userinfo']['ulevel'] == "0") { 
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();

if ($_SESSION['gamecp']['userinfo']['ulevel'] == "1"){
	if($mode == "import2" && DEMO != "yes"){
		$GameCP->loadIncludes("billing");
		$Billing=new Billing();
		$res="";

		set_time_limit(999999);

		if($importline){
			$importline=explode("\n", trim($importline));
			$i="0";
			foreach($importline as $lin => $line){
				$i++;
				$urlvars=unserialize(stripslashes($line));

				$r_result=$Billing->Send($args, $urlvars);
				if ($Billing->GetStatus($r_result) == "completed"){
					$res.= "Import #$i completed.<br>";
				}else $res.= "Import #$i failed.<br>";
			}
		}
		$smarty->assign("res", $res);
		$smarty->display("manageusers/import-completed.tpl");
	}

	if($mode == "import"){
		$smarty->assign("import", "1");
		$smarty->display("manageusers/import.tpl");
	}

	if($mode == "export"){
		$GameCP->loadIncludes("user");
		$User=new User();

		$smarty->assign("exportlist", $User->Export($idd));
		$smarty->display("manageusers/import.tpl");
	}

	if($mode == "resetpassword" && DEMO != "yes"){
			$GameCP->loadIncludes("panel");
			$Panel=new Panel();

			$pass=$Panel->RandomPassword();

			$GameCP->loadIncludes("user");
			$User=new User();
			$GameCP->SetPassword($idd, $pass, false, true);

			$GameCP->loadIncludes("email");

			$Email->templatename = "Lost-Password";
			$Email->userid = $idd;
			$Email->GetTemplateStuff();

			$extravars=array();
			$extravars[]=array("var" => "\$Var1", "value" => $pass);
			$Email->ReplaceStuff($extravars);

			$Email->send();
			$mode="edit2";
	}

	if($mode =="swapshell" && DEMO != "yes")  {
		$idd=$GameCP->whitelist($idd, "int");

		$row = sql_query($safesql->query("SELECT bash FROM users WHERE id= '%i' LIMIT 1;", array($idd))) or die(mysql_error());
		$srv=mysql_fetch_array($row);
		$bash=$srv['bash'];

		if($bash == "no"){
			$loginpath = "yes"; 
		} else $loginpath = "no"; 

		$GameCP->loadIncludes("linux");
		$Linux=new Linux();
		$Linux->SSHAccess($idd, $loginpath);

		sql_query($safesql->query("UPDATE users SET `bash`='%s' WHERE id = '%i'", array($loginpath, $idd)));
		$mode = "edit";
	}
}

if ($mode == "update" && DEMO != "yes") {	
	$idd=$_POST['idd'];

	$userDataQ = sql_query($safesql->query("SELECT bash, name, shortcuts, rsid, email FROM users WHERE id = '%i' LIMIT 1;", array($idd)));
	$userData = mysql_fetch_row($userDataQ);
	$oldloginpath = $userData[0];
	$oldname = strtolower($userData[1]);
	$fname=strtolower($fname);

	if ($_SESSION['gamecp']['userinfo']['ulevel'] != "1"){
		$freseller=$userData[3];
	} else {
		$packageResult = sql_query($safesql->query("SELECT id FROM users WHERE name = '%s' AND userlevel='4' LIMIT 1;", array($freseller))) or die(mysql_error());
		$resel=mysql_fetch_row($packageResult);
		$freseller=$resel[0];
	}

	$GameCP->loadIncludes("backend");
	$Backend=new Backend();

	if($fname != $oldname){
		$unameQ = sql_query($safesql->query("SELECT name FROM users where name='%s' LIMIT 1;", array($fname))) or die(mysql_error());
		$uname = mysql_fetch_row($unameQ);

		if ($fname == $uname[0]){
			$GameCP->loadIncludes("panel");
			$Panel=new Panel();
			$Panel->ErrorExit("User already exists, not adding.");
		}
		if (strtolower($fname) == "admin" || strtolower($fname) == "root" || strtolower($fname) == "test") {
			$GameCP->loadIncludes("panel");
			$Panel=new Panel();
			$Panel->ErrorExit("Server User of $fname is not allowed.");
		}
		

		$GameCP->loadIncludes("user");
		$User=new User();

		$GameCP->loadIncludes("control");
		$Control=new Control();

		$GameCP->loadIncludes("panel");
		$Panel=new Panel();

		$row = sql_query($safesql->query("SELECT distinct(I.sid), U.name, S.os, UG.id, UG.status FROM users U, iptable I, usergames UG, servers S WHERE U.id= '%i' AND I.ip = UG.ip AND UG.cid=U.id AND I.sid = S.sid", array($idd))) or die(mysql_error());
		while($srv=mysql_fetch_array($row)){
			if($srv[4] == "0") $Control->Usergame($srv[3], "stop");
		}
	}

	/* admins or managers */
	$wasActive = sql_query($safesql->query("SELECT active FROM users WHERE id = '%i' LIMIT 1;", array($idd)));
	$wasActive = mysql_fetch_row($wasActive); 
	$wasActive = $wasActive[0];

	if($wasActive == "1" && $factive == "0" ) { 
		$GameCP->loadIncludes("suspend");
		$Suspend=new Suspend();
		$Suspend->User($idd);
	}

	if($wasActive == "0" && $factive == "1" ) { 
		$GameCP->loadIncludes("suspend");
		$Suspend=new Suspend();
		$Suspend->UserRestore($idd);
	}

	if($loginpath != $oldloginpath) { 

		$GameCP->loadIncludes("linux");
		$Linux=new Linux();

		$Linux->SSHAccess($idd, $loginpath);
	}

	$GameCP->loadIncludes("user");
	$User=new User();
	$fname=$User->CleanName($fname);

	if(isset($quota) && is_array($quota) && count($quota) > 0){
		foreach($quota as $q => $a){
			if(!$a['size']) unset($quota[$q]);
		}
		if(count($quota) > 0){
			$quota=serialize($quota);
		} else $quota='';
	} else $quota='';

	if(!$flimit) $flimit = "0";
	if(!$demouser) $demouser = "0";
	if(!$filemanager) $filemanager = "0";
	if(!isset($taxed)) $taxed = "0";
	if(isset($_REQUEST['permissions'])){
		$permissions=$_REQUEST['permissions'];
	} else $permissions=array();

	sql_query($safesql->query("UPDATE users SET 
		name = '%s',
		username = '%s',
		email = '%s', 
		smsaddress = '%s', 
		userlevel = '%i',
		clan = '%s',  
		active = '%s',
		phone = '%s',
		address = '%s', 
		city = '%s', 
		state = '%s', 
		country = '%s', 
		zip = '%s',
		website = '%s',
		extranotes = '%s',
		firstname = '%s',
		lastname = '%s',
		payment = '%s',
		address2 = '%s',
		billingid = '%s',
		taxed = '%s',
		taxid = '%s',
		theme = '%s',
		style = '%s',
		location = '%s',
		bash = '%s',
		`limit`='%i', 
		filemanager='%s', 
		demo='%s',
		lang='%s',
		permissions='%s',
		credit = '%s',
		quota = '%s',
		currency = '%s',
		suspend = '%s',
		apiaccess = '%s',
		rsid='%s'
		
	WHERE id = '%i'", array(
		$GameCP->whitelist($fname, "username"),
		$GameCP->whitelist($fname, "username"),
		$GameCP->whitelist($femail, "useredit"),
		$GameCP->whitelist($smsaddress, "useredit"),
		$GameCP->whitelist($userlevel),
		$GameCP->whitelist($clan, "useredit"),
		$GameCP->whitelist($factive),
		$GameCP->whitelist($phone, "useredit"),
		$GameCP->whitelist($address, "useredit"),
		$GameCP->whitelist($city, "useredit"),
		$GameCP->whitelist($state, "useredit"),
		$GameCP->whitelist($country, "useredit"),
		$GameCP->whitelist($zip, "useredit"),
		$GameCP->whitelist($clienturl, "useredit"),
		$GameCP->whitelist($extrainfo, "useredit"),
		$GameCP->whitelist($firstname, "useredit"),
		$GameCP->whitelist($lastname, "useredit"),
		$GameCP->whitelist($payment, "useredit"),
		$GameCP->whitelist($address2, "useredit"),
		$GameCP->whitelist($billingid, "int"),
		$GameCP->whitelist($taxed, "int"),
		$GameCP->whitelist($taxid, "useredit"),
		$GameCP->whitelist($usertheme, "useredit"),
		$GameCP->whitelist($userstyle, "useredit"),
		$GameCP->whitelist($location, "useredit"),
		$GameCP->whitelist($loginpath),
		$GameCP->whitelist($flimit),
		$GameCP->whitelist($filemanager),
		$GameCP->whitelist($demouser),
		$GameCP->whitelist($_REQUEST['lang']),
		serialize($permissions),
		$GameCP->whitelist($credit, "int"),
		$quota,
		$GameCP->whitelist($currency),
		strtotime($_REQUEST['suspend']),
		$GameCP->whitelist($apiaccess),
		$GameCP->whitelist($freseller),
		$GameCP->whitelist($idd, 'int')
	))) or die(mysql_error());

	$row = sql_query($safesql->query("SELECT distinct(I.sid), U.name, S.os, UG.id, UG.status FROM users U, iptable I, usergames UG, servers S WHERE U.id= '%i' AND I.ip = UG.ip AND UG.cid=U.id AND I.sid = S.sid", array($idd))) or die(mysql_error());
	while($srv=mysql_fetch_array($row)){
		$sid=$srv[0];
		$user=$srv[1];
		$os=$srv[2];
		$ugid=$srv[3];
		$status=$srv[4];
		
		if($fname != $foldname){
			$Control->Usergame($ugid, "stop");

			if($os != "1" && $os != "3"){
				$userInfo=$Panel->GetUser('', $fname);
				$fpassword=$userInfo['password'];
				
				$ubash = $User->GetShell($loginpath, $demouser);

				$Backend->QueryResponse($sid, $winport, "adduser:_:$ubash:_:$fname:_:$fpassword");
				$hook_vars=array($fname, $fpassword, $ubash);
				run_hook("add_user_toserver");

				$serveruserA = "a".trim($Backend->QueryResponse($sid, $winport, "checkuser:_:$fname"))."b";
				if ($serveruserA == "aexistsb"){
					$Backend->QueryResponse($sid,'', "command:_:mv /home/$oldname/* /home/$fname/ ; chown -R $fname:$fname /home/$fname ; chmod 700 /home/$fname");
					$Backend->Query($sid,'', "deluser:_:$oldname");
					$hook_vars=$oldname;
					run_hook("remove_user_fromserver");

				}
				$Control->Build($ugid, "add"); 
				
			} else {
				$Backend->QueryResponse($sid, $winport, "removeserver:_:gcp-$oldname-$ugid");
				$Backend->QueryResponse($sid,'', "movedir:_:\$MAINDIRhome\\$oldname:_:\$MAINDIRhome\\$fname");
				$Control->Build($ugid, "add");

				$GameCP->loadIncludes("backend");
				$Backend->UpdateFTP($sid);
			}
			if($status == "0") $Control->Usergame($ugid, "start");
		}

		if($os == '1' && $loginpath != $oldloginpath && $_SESSION['gamecp']['userinfo']['ulevel'] == "1") $Backend->UpdateFTP($sid);
	}

	if($fname != $foldname){
		$shortcuts=unserialize($userData[2]);
		if(is_array($shortcuts) && count($shortcuts) > 0){
			$shortfinal=array();
			foreach($shortcuts as $sc => $uts)$shortfinal[]=array("item" => str_replace("/home/$foldname", "/home/$fname", $uts['item']), "game" => $uts['game']);
			sql_query($safesql->query("UPDATE users SET shortcuts ='%s' WHERE id = '%i'", array(serialize($shortfinal),$GameCP->whitelist($idd, "int"))))  or die(mysql_error()); 			
		}
	}

	if(debugging =="0" ) $mode="edit2";
	
}

if ($mode == "remove") { 
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$userInfo=$Panel->GetUser($idd);
	$fname=$userInfo['username'];
	$smarty->assign("idd", $idd);
	$smarty->assign("fname", $fname);

	$nonix=0;
	$connectionStatus=true;
	$clientServersQ = sql_query($safesql->query("SELECT distinct(S.sid) FROM users U, servers S, iptable I, usergames UG WHERE U.id='%i' AND U.id = UG.cid AND UG.ip = I.ip AND I.sid = S.sid", array($idd))) or die(mysql_error());

	$GameCP->loadIncludes("query");
	$Query=new Query();

	while($clientServers = mysql_fetch_array($clientServersQ)){
		if($Query->Status($clientServers['sid']) != true) $connectionStatus=false;
	}

	$smarty->assign("connectionStatus", $connectionStatus);
	$smarty->display("manageusers/remove.tpl");
}

if ($mode == "removeconfirmed" && DEMO != "yes") {
	if(!$idd){ 
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$Panel->ErrorExit("Missing id");	
	}

	if($_SESSION['gamecp']['userinfo']['ulevel'] != "0"){
		$idd=$GameCP->whitelist($idd, "int");
		$GameCP->loadIncludes("user");
		$User=new User();
		$User->Remove($idd);
		$mode="edit";
	} else { 
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$Panel->ErrorExit("Invalid Access");
	}
}

if($mode == "edit"){
	if($_SESSION['gamecp']['userinfo']['ulevel'] == "0"){
		$mode = "viewsubaccount";
	} else { 
		$initialQ ="";
		$sysQuery ="";
		$rsQuery ="";
		$viewQ ="";
		$viewQ2 ="";
		$adminQ ="";
		/* active / inactive */
		if(!isset($_REQUEST['displayType']) || (isset($_REQUEST['displayType']) && !$_REQUEST['displayType'])) { 
			if(!isset($_SESSION['gamecp']['client_display'])) $displayType = "Active";
		}else $_SESSION['gamecp']['client_display']=$GameCP->whitelist($_REQUEST['displayType']);

		if(isset($_SESSION['gamecp']['client_display'])) $displayType=$_SESSION['gamecp']['client_display'];
		$_REQUEST['displayType']=$displayType;
		/* trying to fix it, doesnt do sho hot */
		if(!$displayType || $displayType == "") $displayType = "Active";

		if($displayType == "Active") { $clientActive = "1"; } else { $clientActive="0"; }
		$sysQuery="AND userlevel = '0'";
		

		/* initials */
		if(isset($_REQUEST['initial'])) $initialQ = " AND UPPER(LEFT(name,1)) LIKE '". $GameCP->whitelist($_REQUEST['initial'][0]) . "'";

		/* search */
		if(isset($_REQUEST['do']) && $_REQUEST['do'] == "reset") $_SESSION['searchcontent'] = '';
		if(isset($_POST['searchcontent']) && $_POST['searchcontent'] != "Search Clients") $_SESSION['searchcontent']=$_POST['searchcontent'];

		if(isset($_SESSION['searchcontent']) && $_SESSION['searchcontent']){
			$searchAll ="name LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll .=" OR email LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll .=" OR firstname LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll .=" OR lastname LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";

			$searchAll.=" OR clan LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll.=" OR phone LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll.=" OR address LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll.=" OR address2 LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll.=" OR city LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll.=" OR state LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll.=" OR zip LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll.=" OR website LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll.=" OR payment LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";

			$viewQ = "AND($searchAll)";
		}
		
		$activeQ="active='".$GameCP->whitelist($clientActive)."'";

		if($_SESSION['gamecp']['userinfo']['ulevel'] == "4"){
			$rsQuery= "AND rsid='".$_SESSION['gamecp']['userinfo']['id']."'";
		} else 	$rsQuery='';


		/* remember we wanted to see all, right? */
		if(isset($_REQUEST['view']) && $_REQUEST['view'] == "all"){
			$_SESSION['gamecp']['view']['manageclients']="all";
		}elseif(isset($_REQUEST['do']) && $_REQUEST['do'] == "reset") $_SESSION['gamecp']['view']['manageclients']="";
		if(isset($_SESSION['gamecp']['view']['manageclients']) && $_SESSION['gamecp']['view']['manageclients'] == "all") $_REQUEST['view']="all";



		/* select */
		$rowUserDetailsQ1 = "SELECT SQL_CALC_FOUND_ROWS *
		FROM users
		WHERE 

		$activeQ 
		$sysQuery 
		$rsQuery 
		$viewQ 
		$initialQ 
		
		ORDER BY username";


		$i="0";

		$UserList=array();
		
		/* page control */
		$rowUserDetailsQ=Smarty_PageControl($rowUserDetailsQ1, "userPage", "userPage");

	    while ($rowUserDetails = mysql_fetch_array($rowUserDetailsQ)){
			/* new scan to get os of user to not display shell acces of no linux servers */
			$userosQ = sql_query("SELECT S.os FROM users U, servers S, iptable I, usergames UG WHERE U.id='". $rowUserDetails['id'] ."' AND U.id = UG.cid AND UG.ip = I.ip AND I.sid = S.sid $rsQuery") or die(mysql_error());
			$useros=array();
			while($userosa = mysql_fetch_array($userosQ)) $useros[]=$userosa['os'];
			

			if($rowUserDetails['bash'] == "noftp"){
				$bash="noftp";
			}elseif($rowUserDetails['bash'] == "yes"){
				$bash="Disable";
			} else $bash="Enable";

			
			if($_SESSION['gamecp']['userinfo']['ulevel'] == "5"){

				$addRow=false;
				$usersServersQ = sql_query("SELECT servers FROM users WHERE id='". $_SESSION['gamecp']['userinfo']['id'] ."' LIMIT 1;") or die(mysql_error());
				$usersServers = mysql_fetch_array($usersServersQ);
				$userServer=unserialize($usersServers[0]);

				$clientServersQ = sql_query("SELECT S.sid FROM users U, servers S, iptable I, usergames UG WHERE U.id='". $rowUserDetails['id'] ."' AND U.id = UG.cid AND UG.ip = I.ip AND I.sid = S.sid") or die(mysql_error());
				$clientServers = mysql_fetch_array($clientServersQ);

				foreach($clientServers as $srv){
					if(in_array($srv, $userServer)) $addRow = true;

				}
			} else $addRow = true;

			if($addRow == true){
				$GameCP->loadIncludes("user");
				$User=new User();

				if($rowUserDetails['userlevel'] == "0" || $_SESSION['gamecp']['user']['mainadmin'] == "1"){
					$password=$User->Password($rowUserDetails['id']);
				} else $password='';

				if($rowUserDetails['userlevel'] == "0"){
					$totalUserGamesQ=sql_query("SELECT id FROM usergames WHERE cid='".$rowUserDetails['id']."'");
					$totalUserGames=mysql_num_rows($totalUserGamesQ);

					$totalUserVoiceQ=sql_query("SELECT id FROM uservoice WHERE cid='".$rowUserDetails['id']."'");
					$totalUserVoice=mysql_num_rows($totalUserVoiceQ);
					
					$totalUserModulesQ=sql_query("SELECT id FROM module_services WHERE cid='".$rowUserDetails['id']."'");
					$totalUserModules=mysql_num_rows($totalUserModulesQ);
				} else {
					$totalUserGames="0";
					$totalUserVoice="0";
					$totalUserModules="0";
				}


				/* select the sub users */
				$SubUserList=array();
				$rowSubUserDetailsQ = sql_query("SELECT * FROM usersubaccounts WHERE cid='".$rowUserDetails['id']."'") or die(mysql_error());
				while ($rowSubUserDetails = mysql_fetch_array($rowSubUserDetailsQ)){
					$SubUserList[]=array("cid" => $rowSubUserDetails['cid'], "id" => $rowSubUserDetails['id'], "name" => $rowSubUserDetails['name'], "password" => $User->Password($rowSubUserDetails['id'], "usersubaccounts"));
				}

				if($rowUserDetails['firstname'] || $rowUserDetails['lastname']){
					$rowUserDetails['displayname']=$rowUserDetails['firstname'] .' '.$rowUserDetails['lastname'];
				} else $rowUserDetails['displayname']=$rowUserDetails['name'];


				$UserList[$i]=array(
					"id" => $rowUserDetails['id'],
					"email" => $rowUserDetails['email'],
					"games" => $totalUserGames,
					"userlevel" => $rowUserDetails['userlevel'],
					"username" => $rowUserDetails['name'], 
					"displayname" => $rowUserDetails['displayname'], 
					"name" => $rowUserDetails['name'],
					"address" => $rowUserDetails['address'],
					"address2" => $rowUserDetails['address2'],
					"city" => $rowUserDetails['city'],
					"state" => $rowUserDetails['state'],
					"zip" => $rowUserDetails['zip'],
					"country" => $rowUserDetails['country'],
					"password" => $password,
					"bash" => $bash,
					"os" => $useros,
					"subusers" => $SubUserList,
					"voice" => $totalUserVoice,
					"modules" => $totalUserModules);
				# dont think these are used here.
				$i++;
			}
		}


		/* list of initials */
		$usrinitials=array();
		$initialQ = sql_query($safesql->query("SELECT * FROM users WHERE active='%s' $sysQuery $viewQ", array($clientActive))) or die(mysql_error());
		while ($rowUserDetails = mysql_fetch_array($initialQ)){
			$usrinitials[$i]=array("username" => $rowUserDetails['name'], "name" => $rowUserDetails['name']);
			$i++;
		}


		$GameCP->loadIncludes("display");
		$Display=new Display();

		if($UserList && count($UserList) > 0)$smarty->assign('rowUserDetails', $UserList);
		$smarty->assign("UserInitials", $Display->Initials($usrinitials));
		$smarty->display("manageusers/manageclients-list.tpl");
	}
}

if($mode =="changepw" && DEMO != "yes") { 
	$GameCP->loadIncludes("user");
	$User=new User();
	$User->ChangePassword($idd, $_POST['pass']);
	if(debugging == "0"){
		$mode="edit2";
	} else echo "Saved";
} 

if($mode == "edit2") { 
	$GameCP->loadIncludes("user");
	$User=new User();
	$User->Profile($idd);
} 


require_once(path.'/includes/core/editable/footer.inc.php');

?>