<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');
 
if(!isset($mode) || isset($mode) && !$mode) $mode = "edit";

$GameCP->CheckPermissions('installgames');

$smarty->assign('page_title', $LNG_GAMEMANAGEMENT);

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();

$GameCP->loadIncludes("xml");
$XML=new XML();

function DownloadGame($file, $gid, $filemv, $wgeturl, $sid){
	global $Linux;
		$rate="500000";
		$rate="10000000";

		$Linux->Screen($sid, "mkdir -p \$MAINDIR/installs ;  cd /d \$MAINDIR/installs ; if [ -f $file ] ; then mv $file $filemv; fi ; wget --limit-rate=$rate $wgeturl", "installgame".$gid);
		return $rate;
}


if(!isset($_SERVER["SERVER_ADDR"])) $_SERVER["SERVER_ADDR"]=$_SERVER["SERVER_NAME"];
if(!$_SERVER["SERVER_NAME"] || !$_SERVER["SERVER_ADDR"]){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Unable to determine web-servers ip address");
}

if(isset($_REQUEST['gid'])) $_REQUEST['gid']=$GameCP->whitelist($_REQUEST['gid']);

$myDetails=urlencode(base64_encode(serialize(array($_SERVER['SERVER_ADDR'], $_SERVER["SERVER_NAME"]))));

if ($mode == "install" || $mode == "installyes" || $mode == "checkdlstatus"){
	$mirrors=$XML->MirrorList();
	$gameInfo=$XML->GameInfo($gid, $myDetails);
}

if ($mode == "install"){
	$packname = $gameInfo['name'];
	$serverlist='';
	$doInsertQ = sql_query($safesql->query("SELECT * FROM game WHERE name='%s'", array($GameCP->whitelist($packname, "clean")))) or die(mysql_error());
	$doInsertC = mysql_fetch_row($doInsertQ);
	$doInsert = mysql_num_rows($doInsertQ);

	$result = sql_query("SELECT sid, name, os FROM servers ORDER BY 'name'") or die(mysql_error());
	while ($row = mysql_fetch_array($result)){
		if (($gameInfo['windownload'] && $row['os'] == "1") || ($gameInfo['download'] && $row['os'] != "1")){
			$serverlist.= "<option value=\"". $row['sid'] ."\">". $row['name']." - ". $row['sid'] ."</option>";
		}
	}

	if(isset($serverlist)) $smarty->assign("serverlist", $serverlist);
	$smarty->assign("gameInfo", $gameInfo);
	$smarty->assign("mirrors", $mirrors);
	$smarty->assign("gid", $gid);

	$smarty->display("managegames/install-mirror.tpl");
}



if($mode == "installyes" && DEMO != "yes"){
	/* install the data */
	$packname = $gameInfo['name'];
	$export = $gameInfo['export'];
	$steamid = $gameInfo['steamid'];
	$steammod = $gameInfo['steammod'];
	$dlurl = $gameInfo['url'];

	if(!$export){ 
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$Panel->ErrorExit("Unable to install game, no export.");
	}

	$GameCP->loadIncludes("game");
	$Game=new Game();


	$doInsertQ = sql_query($safesql->query("SELECT * FROM game WHERE name='%s'", array($GameCP->whitelist($packname, "clean")))) or die(mysql_error());
	$doInsertC = mysql_fetch_array($doInsertQ);

	if(mysql_num_rows($doInsertQ) == "0") {
		$newid=$Game->Import($export);

		if(!$newid){ 
			$GameCP->loadIncludes("panel");
			$Panel=new Panel();
			$Panel->ErrorExit("Unable to install game");
		}

		/* grab game info */
		$newInfoQ=sql_query($safesql->query("SELECT * FROM game WHERE id='%i' LIMIT 1;", array($newid)));
		$newInfo=mysql_fetch_assoc($newInfoQ);

		if($steamid || $steammod){
			sql_query($safesql->query("UPDATE game SET steamid='%i', steammod='%s' WHERE id='%i'", array($steamid, $steammod,$newid)));

			sql_query($safesql->query("INSERT INTO gameupdates SET 
				name='%s',
				winrepo='%s', 
				linuxrepo='%s', 
				steamid='%i', 
				steammod='%s',
				gid='%s', 
				type='2'
			", 
				array(
				$newInfo['name'], 
				$newInfo['wininstall'], 
				$newInfo['installfile'], 
				$steamid, 
				$steammod,
				serialize(array($newid)))));

			$gameUpdateID=mysql_insert_id();
			$smarty->assign("gameUpdateID", $gameUpdateID);

		}


		/* these ids are reserved for voice only - do not allow games on them! */
		if($newid == "1000" || $newid == "1001" || $newid == "1002" || $newid == "1003" || $newid == "1004"){
			sql_query($safesql->query("UPDATE game SET id='1010' WHERE id='%i'", array($newid)));
			$newid="1005";
		}

		if($packname == "Mumble"){
			sql_query($safesql->query("UPDATE game SET id='1004' WHERE id='%i'", array($newid)));
			$newid="1004";
		}


		$startmode=$newInfo['startmode'];
		
	} else { 
		/* update */
		$newid=$Game->Import($export, $doInsertC[0]);
		$newInfo=$doInsertC;
		$showsaved=true;
		$smarty->assign("showSaved", true);
		$mode="edit";
	}

	/* download the game */
	if(isset($mirror) && isset($servers) && is_array($servers) && count($servers) > 0){
		foreach($mirrors as $mr) if($mr['id'] == $mirror) $mirrorInfo=$mr;
		
		$mirrorLink = "http://gamecp.com/getgame/from/".$mirrorInfo['id']."/".$myDetails."/";

		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$GameCP->loadIncludes("backend");
		$Backend=new Backend();
		$GameCP->loadIncludes("linux");
		$Linux=new Linux();
		$GameCP->loadIncludes("query");
		$Query=new Query();
		$down=array();

		foreach($servers as $si=>$sid){
			$sid=$GameCP->whitelist($sid);
			$machineInfo=$Panel->GetServer($sid);
			$winport=$machineInfo['winport'];

			if(isset($_SESSION['gamecp']['status'][$sid][$newid])) unset($_SESSION['gamecp']['status'][$sid][$newid]);
			if(isset($_SESSION['gamecp']['download'][$newid]['servers'])) unset($_SESSION['gamecp']['download'][$newid]['servers']);

			if(!$Query->Status($sid)){
				$down[]=$sid;
				unset($servers[$si]);
			} else {
				if($machineInfo['os'] == "1" && $gameInfo['windownload']){
					$wgeturl=$mirrorLink.$gameInfo['windownload'];
					$winfile=$gameInfo['windownload'];
					$script="\$MAINDIR\installs\dlgame_run_$newid.bat";
					$script2="\$MAINDIR\installs\dlgame_exe_$newid.bat";
					$batch="\$MAINDIR\bin\wget.exe $wgeturl -O \$MAINDIR\installs\\$winfile\r\ndel $script\r\ndel $script2\r\nexit\r\n";
					$Backend->QueryResponse($sid, $winport, "writefile:_:$script:_:$batch");
					$Backend->QueryResponse($sid, $winport, "writefile:_:$script2:_:call \"cmd /c start $script\"\r\nexit\r\n");
					$reply=$Backend->Query($sid, $winport, "$script2:_:");
				} elseif($machineInfo['os'] != "1" && $gameInfo['download']) {
					$wgeturl=$mirrorLink.$gameInfo['download'];
					$file=$gameInfo['download'];
					$filemv=time().$gameInfo['download'];
					$_SESSION['gamecp']['dlrate']=DownloadGame($file, $newid, $filemv, $wgeturl, $sid);
				}
			}
		}

		if(count($down) > 0){
			$e="<ul>";
			foreach($down as $d) $e.="<li>Machine $d is offline!</li>";
			$e.="</ul>";
			$Panel->Error($e);
		} 
		
		$smarty->assign("downloadingame", "true");
		$smarty->assign("mirrorInfo", $mirrorInfo);

		sql_query($safesql->query("UPDATE game SET `active` = '2' WHERE id='%i'", array($newid))) or die(mysql_error());

		unset($_SESSION['gamecp']['finished'][$sid][$newid], $_SESSION['gamecp']['status'][$sid][$newid], $_SESSION['gamecp']['baddl'][$sid][$newid], $_SESSION['gamecp']['checkok'][$sid][$newid]);

		if(isset($_SESSION['gamecp']['download'][$newid]['servers'])){
			$_SESSION['gamecp']['download'][$newid]['servers']=array_merge($_SESSION['gamecp']['download'][$newid]['servers'],$servers);
		} else $_SESSION['gamecp']['download'][$newid]['servers']=$servers;
		$_SESSION['gamecp']['download'][$newid]['gameInfo']=$gameInfo;
	}

	$smarty->assign("newid", $newid);

	$GameCP->loadIncludes("game");
	$Game=new Game();

	$smarty->assign("islindl",$Game->IsDownload($newInfo['installfile']));
	$smarty->assign("iswindl",$Game->IsDownload($newInfo['wininstall']));

	$smarty->assign("gid", $gid);
	$smarty->assign("newInfo", $newInfo);
	if(isset($servers)) $smarty->assign("servers", serialize($servers));

	if(mysql_num_rows($doInsertQ) == "0") $smarty->display("managegames/install-finished.tpl");
	
	if(isset($_SESSION['gamecp']['nav_control'])) unset($_SESSION['gamecp']['nav_control']);

	sql_query($safesql->query("UPDATE game SET `updated` = '".time()."' WHERE name = '%s' OR id='$newid'", array($packname))) or die(mysql_error());
	
}


if($mode == "checkdlstatus"){
	if(!isset($_SESSION['gamecp']['download'][$_REQUEST['gid']])){
		sql_query($safesql->query("UPDATE game SET `active` = '0' WHERE id='%i'", array($GameCP->whitelist($_REQUEST['gid'], "int")))) or die(mysql_error());
		die("Download tracking failed. Validate your remote server(s) installs folder for this game.");
	}
	$gameInfo=$_SESSION['gamecp']['download'][$_REQUEST['gid']]['gameInfo'];

	$servers=unserialize($servers);
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$GameCP->loadIncludes("backend");
	$Backend=new Backend();
	$GameCP->loadIncludes("linux");
	$Linux=new Linux();
	if(is_array($servers)){
		foreach($servers as $sid){
			$machineInfo=$Panel->GetServer($sid);
			$winport=$machineInfo['winport'];
			$currentSize="0";
			if($machineInfo['os'] == "1"){
				$checkfile=$gameInfo['windownload'];
				$md5sum=$gameInfo['winmd5'];
				$dlsize=$gameInfo['windlsize'];
			} else {
				$checkfile=$gameInfo['download'];
				$dlsize=$gameInfo['dlsize'];
				$md5sum=$gameInfo['linuxmd5'];
			}

			// this if runs each time if its not completed to get updated info
			if(!isset($_SESSION['gamecp']['status'][$sid][$_REQUEST['gid']])){
				if($machineInfo['os'] == "1"){
					$filelist=$Backend->QueryResponse($sid, $winport, "filelist:_:\$MAINDIR\installs");
					$file=str_replace(":_:", "GC_PC", $filelist);
					$file=explode("::" , $file);
					foreach($file as $fi){
						$fi2=explode("GC_PC" , $fi);
						if($fi2[0] == $checkfile){
							$currentSize=$fi2[1];
							break;
						}
					}
					if(!$currentSize || $currentSize == "0"){
						/* detect if dl didnt happen or left empty for 10 trys */
						if(!isset($_SESSION['gamecp']['baddl'][$sid][$_REQUEST['gid']])) $_SESSION['gamecp']['baddl'][$sid][$_REQUEST['gid']]="0";
						$_SESSION['gamecp']['baddl'][$sid][$_REQUEST['gid']]=$_SESSION['gamecp']['baddl'][$sid][$_REQUEST['gid']]+1;
						if($_SESSION['gamecp']['baddl'][$sid][$_REQUEST['gid']] > 20) echo "<strong>".$sid . "</strong> - Unable to download service file.";
					}
					if($currentSize == $dlsize) $_SESSION['gamecp']['finished'][$sid][$_REQUEST['gid']]=true;
				} else {
					$currentSize=$Backend->QueryResponse($sid, '', "command:_:cd /d \$MAINDIR/installs ; du -b $checkfile");
					$currentSize=explode("\t", $currentSize);
					$currentSize=$currentSize[0];
					$status=$Linux->Watch($sid, "installgame".$_REQUEST['gid'], '','',false);

					if($status[0] == "") $_SESSION['gamecp']['finished'][$sid][$_REQUEST['gid']]=true;
				}
			}


			// if above if triggered fi nished or status was set, run this if
			$md5error=false;
			if(isset($_SESSION['gamecp']['finished'][$sid][$_REQUEST['gid']]) || isset($_SESSION['gamecp']['status'][$sid][$_REQUEST['gid']])){

				if($machineInfo['os'] != "1" && !isset($_SESSION['gamecp']['checkok'][$sid][$_REQUEST['gid']])){
					$_SESSION['gamecp']['checkok'][$sid][$_REQUEST['gid']]=false;
					$checkexists=$Backend->QueryResponse($sid, '', "command:_:cd /d \$MAINDIR/installs ; if [ -f $checkfile ]; then echo 'FILEOK'; fi");
					if(trim($checkexists) == "FILEOK"){
						if($md5sum && !isset($_SESSION['gamecp']['checkmd5'][$sid][$_REQUEST['gid']])){
							if($machineInfo['os'] == "2"){
								$md5=trim($Backend->QueryResponse($sid, '', "command:_:cd /d \$MAINDIR/installs ; md5 -q $checkfile"));
							} else $md5=trim($Backend->QueryResponse($sid, '', "command:_:cd /d \$MAINDIR/installs ; md5sum $checkfile"));
							$md5=explode(" ", $md5);
							$md5=$md5[0];
							if(trim($md5) != trim($md5sum)) $md5error=true;
							$_SESSION['gamecp']['checkmd5'][$sid][$_REQUEST['gid']]=true;
						} 
					}
				} elseif($machineInfo['os'] == "1"){
					if($md5sum && !isset($_SESSION['gamecp']['checkmd5'][$sid][$_REQUEST['gid']])){
						$script="\$MAINDIRmd5sum".$_REQUEST['gid'].".bat";
						$batch="@ECHO off\r\ncd /d \$MAINDIRinstalls\r\n..\bin\md5sum.exe $checkfile\r\ndel $script";
						$Backend->QueryResponse($sid, $winport, "writefile:_:$script:_:$batch");
						$md5=explode(" ", $Backend->QueryResponse($sid, $winport, "$script"));
						if(trim($md5[0]) != trim($md5sum)) $md5error=true;
						$_SESSION['gamecp']['checkmd5'][$sid][$_REQUEST['gid']]=true;
					} 
				}
				$_SESSION['gamecp']['checkok'][$sid][$_REQUEST['gid']]=true;
					
				// next 2 are for the os - if completed - lets extract
				if($machineInfo['os'] != "1" && $_SESSION['gamecp']['status'][$sid][$_REQUEST['gid']] != "complete"){
					$Linux->RemoveScreenLog($sid, "installgame".$_REQUEST['gid']);
					if($_SESSION['gamecp']['checkok'][$sid][$_REQUEST['gid']] != false){

						$GameCP->loadIncludes("game");
						$Game=new Game();

						$extention=$Game->GetExtension($checkfile);
						$determinExtract=$Game->Extract($extention, $machineInfo['os']);

						if($determinExtract != false){
							$EXTRACT=$determinExtract[0];
							$EXTRACTMODE=$determinExtract[1];
							$Backend->Query($sid, '', "command:_:cd /d \$MAINDIR/installs ; screen -mdLS xtract bash -c '$EXTRACT $EXTRACTMODE $checkfile ; rm -f \$MAINDIR/installs/$checkfile ; chown -R root \$MAINDIR/installs/ ; chmod -R 755 \$MAINDIR/installs/'");
						}
					}
				}elseif($machineInfo['os'] == "1" && $_SESSION['gamecp']['status'][$sid][$_REQUEST['gid']] != "complete"){
					$ggid=$_REQUEST['gid'];
					$final_install="\$MAINDIR\installs\\$checkfile";
					$finallocation="\$MAINDIR\installs";
					$script="extract$ggid.bat";
					$script2="extract$ggid-2.bat";
					$batch="\$MAINDIRbin\\unzip.exe -o $final_install -d $finallocation\r\n del $final_install\r\ndel $script\r\ndel $script2\r\nexit\r\n"; 
					$Backend->QueryResponse($sid, $winport, "writefile:_:$script:_:$batch");
					$Backend->QueryResponse($sid, $winport, "writefile:_:$script2:_:call \"cmd /c start $script\"");
					$Backend->Query($sid, $winport, "$script2:_:");
				}


				sql_query($safesql->query("UPDATE game SET `active` = '1' WHERE id='%i';", array($_REQUEST['gid']))) or die(mysql_error());
				$_SESSION['gamecp']['status'][$sid][$_REQUEST['gid']]='complete';
				
				if($_SESSION['gamecp']['checkok'][$sid][$_REQUEST['gid']] != false){
					echo "<strong>".$sid . "</strong> - Download complete<br>";
					if($md5error==true) echo " - <i>download may have been corrupted</i><br>";
				}else echo "<strong>".$sid . "</strong> - Download failed<br>";


			} elseif($currentSize >= 0){
				if(preg_match("/Unable to onnect to the remote/i", $currentSize)  || preg_match("/Remote down/i", $currentSize)){
					echo "<strong>".$sid . "</strong> - Remote server is offline.<br>";
				} else {
					if($dlsize){
						$percent=round($currentSize/$dlsize*100, 0);
					} else $percent="0";
					if(!$dlsize) $dlsize="unknown ";
					if(trim($currentSize) == "" || trim($currentSize) == "0"){
						echo "<strong>".$GameCP->whitelist($_REQUEST['gid']). "</strong> - Checking status...<br>";
					} else {
						echo "<table align='center'><tr><td><strong>".$sid . "</strong></td>";
						$title="Downloading ...";
						$title="Downloading " . $GameCP->ConvertBytes($currentSize) . " out of ". $GameCP->ConvertBytes($dlsize) ."";

						if($percent == "100"){
							echo "<td><div title='$title' class='dlbg'><div title='$title' class='dlfg' style='width: ".$percent."%;'></div></div></td><td>%$percent, please wait...</td>";
						} elseif($percent > 0 && $percent < 101){
							echo "<td><div title='$title' class='dlbg'><div title='$title' class='dlfg' style='width: ".$percent."%;'></div></div></td><td>%$percent</td>";
						} else echo "<td>$title</td>";
						echo "</tr></table>";			//echo " @ ".$_SESSION['gamecp']['dlrate']."K/s";
					}

					if(!$dlsize && !$currentSize) echo "Downloading...";
				}
			} else { 
				echo "<strong>".$sid . "</strong> - Unable to download service file.<br>";
				if($machineInfo['os'] != "1") $Linux->RemoveScreenLog($sid, "installgame".$_REQUEST['gid']);
			}
		}
	}else sql_query($safesql->query("UPDATE game SET `active` = '1' WHERE id='%i'", array($_REQUEST['gid']))) or die(mysql_error());


}

 if($mode == "emailgamecp2"){

	 if(!$comments){ 
		 $mode="edit";
	 } else {
	 
		$message=@$_POST['comments'];
		$GameCP->loadIncludes("email");
		$Email->emailto = "support@gamecp.com";
		$Email->emailsubject = 'GameCP Game Request';
		$Email->emailbody = $message;
		$Email->send();
		
		echo "Thank you for contating GameCP, your request will be reviewed.<br>If you have an export available of your game we recommend sending it in."; 
	 }
	
}



if($mode == "edit") { 

	/* build the list of availble game packages */
	$defaultGames=array();
	$defaultGames=$XML->GameList();
	$smarty->assign("defaultGames", $defaultGames);
	$smarty->assign("totalGames", count($defaultGames));
	$smarty->display("managegames/install-list.tpl");

 } 


require_once(path.'/includes/core/editable/footer.inc.php');

?>