<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/

if(isset($_REQUEST['mode']) && $_REQUEST['mode'] == "update") $noheader=true;

require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');
 
if(!isset($mode) || isset($mode) && !$mode) $mode = "edit"; 

$GameCP->CheckPermissions('settings');

$smarty->assign('page_title', $LNG_SETTINGS);


if($_SESSION['gamecp']['userinfo']['ulevel'] != "1") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();

$settingssaved=false;


if($mode == "logs"){

	if(isset($_REQUEST['searchtxt']) && $_REQUEST['searchtxt'] != "" || (isset($_SESSION['gamecp']['search']['logs']) && !isset($_REQUEST['searchtxt']))){
		if(isset($_SESSION['gamecp']['search']['logs']) && $_REQUEST['searchtxt'] == ""){
			$searchtxt=$GameCP->whitelist($_SESSION['gamecp']['search']['logs'], "clean");
		} else $searchtxt=$GameCP->whitelist($_REQUEST['searchtxt'], "clean");
		$q=" WHERE user LIKE '%$searchtxt%' OR affecteduser LIKE '%$searchtxt%' OR comment LIKE '%$searchtxt%' OR ip LIKE '%$searchtxt%' OR page LIKE '%$searchtxt%' OR post LIKE '%$searchtxt%'";
		$_SESSION['gamecp']['search']['logs']=$searchtxt;
	}else{
		unset($_SESSION['gamecp']['search']['logs']);
		$q="";
	}

	$sql="SELECT SQL_CALC_FOUND_ROWS * FROM eventlogs $q ORDER BY id DESC";
	$a=array();
	$result=Smarty_PageControl($sql, "events", "events", '100');
	while ($row = mysql_fetch_array($result)) $a[]=$row;
	
		
	$smarty->assign("einfo", $a); 
	$smarty->display("settings/logs.tpl");
}


if($mode == "testmail"){
	$GameCP->loadIncludes("email");

	$Email->emailto = emailNotify;
	$Email->emailsubject = "E-mail Test";
	$Email->emailbody = 'This e-mail was sent as a test. <br><br>From the Settings panel of GameCP!<br><br>';
	$Email->ReplaceStuff();
	$Email->send();

	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->Error("Test mail sent.");
}

if ($mode == "disableMaintenance" && DEMO != "yes") {
		sql_query("UPDATE settings SET value='no' WHERE name='MAINTENANCE'") or die(mysql_error()); 
		sql_query("UPDATE settings SET value='no' WHERE name='MAINTENANCEMSG'") or die(mysql_error()); 

		echo "Maintenance mode has been disabled.<br><br>";
		echo "<meta http-equiv=\"Refresh\" content=\"0;url=". $url . "/system\">"; 
}

if ($mode == "update" && DEMO != "yes") {
	foreach($_POST['myvar'] as $key => $val) {
		if($key == "THEME" && $val != $_REQUEST['oldtheme']){
			$GameCP->loadIncludes("panel");
			$Panel=new Panel();
			$Panel->RemoveCache();
			if($val == "x")$updateadmin="x";
		}

		if($key == "USERTHEME" && $val != $_REQUEST['oldusertheme']){
			$GameCP->loadIncludes("panel");
			$Panel=new Panel();
			$Panel->RemoveCache();
			if($val == "x") $updateclient="x";
		}

		$decode=array('tos','INVOICEHEADER');

		if($key == "url") $val = rtrim(str_replace(' ', '', $val), "/");

		if(!in_array($key, $decode)){
			$val=$GameCP->whitelist($val, "clean");
		} else if(in_array($key, $decode)) $val=$GameCP->whitelist($val, "web");

		sql_query($safesql->query("UPDATE settings SET value='%s' WHERE name='%s'", array($val, $GameCP->whitelist($key, "clean")))) or die(mysql_error());

		if($key == "emailAdmin") sql_query($safesql->query("UPDATE settings SET value='%s' WHERE name='EMAILADMIN'", array($GameCP->whitelist($val, "clean")))) or die(mysql_error());
	}

	if(isset($updateadmin)) sql_query($safesql->query("UPDATE settings SET value='%s' WHERE name='styleadmin'", array($updateadmin))) or die(mysql_error()); 
	if(isset($updateclient)) sql_query($safesql->query("UPDATE settings SET value='%s' WHERE name='styleclient'", array($updateclient))) or die(mysql_error()); 

	sql_query($safesql->query("UPDATE settings SET value='%s' WHERE name='userpermissions'", array(serialize($_REQUEST['permissions'])))) or die(mysql_error()); 

	unset($_SESSION['gamecp']['constant_settings']);

	echo "Saved";
}


if($mode == "edit") {  
	/* load out license details */
	$allmachines=($_SESSION['gamecp']['count'][0]+$_SESSION['gamecp']['count'][1]);
	$smarty->assign("machines", $allmachines); 
	$smarty->assign("licenseType", $_SESSION['gamecp']['count'][1] ." Linux, ". $_SESSION['gamecp']['count'][0]." Windows"); 

	$smarty->assign("defaultperms", $GameCP->ClientPermissions());

	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->GetThemes();

	if(preg_match("/.gamecp.com/", url) 
		|| preg_match("/.gamecp.com/", url)
		|| preg_match("/.itsyourserver.com/", url)
		|| preg_match("/.gamepanel.us/", url)
		|| preg_match("/.gamecpx.eu/", url)
		|| preg_match("/.modcp.com/", url)
		|| preg_match("/.mygsp.eu/", url)
	) $smarty->assign('hosted', true);

	$smarty->assign('userperms',unserialize(userpermissions));
	
	if(isset($_SESSION['gamecp']['upgrades']) && is_array($_SESSION['gamecp']['upgrades'])) $smarty->assign("upgrades", $_SESSION['gamecp']['upgrades']); 
	$smarty->display("settings/settings.tpl");
	
} // end edit

require_once(path.'/includes/core/editable/footer.inc.php');

?>