<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/
if(isset($_REQUEST['mode'])){
	$mode=$_REQUEST['mode'];
} else $mode='phpinfo';

$validmodes=array("custom", "phpinfo", "checkport", "portcheck", "cleanup", "autoip", "submitautoip");
if(!in_array($mode, $validmodes)) $noheader=true;
require_once('../includes/core/includes/user/session.inc.php');
require_once('../includes/config.inc.php');

$GameCP->CheckPermissions('tools');

$smarty->assign('page_title', $LNG_TOOLS);

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();

if($mode == "sql") $smarty->display("settings/sql.tpl");
if($mode == "backup") $smarty->display("settings/backup.tpl");
if($mode == "cron") $smarty->display("settings/cron.tpl");
if($mode == "optimize") $smarty->display("settings/optimize.tpl");
if($mode == "phpinfo") $smarty->display("tools/phpinfo.tpl");
if($mode == "phpinfo2") phpinfo();
if($mode == "portcheck") $smarty->display("tools/portcheck.tpl");

if($mode=="custom" && isset($tool)){
	$tool=$GameCP->whitelist($tool, "tool");
	$tools=$GameCP->GetTools();
	if(isset($tools[$tool])) $tool();
}

if($mode == "autoip" || $mode == "submitautoip"){
	$GameCP->loadIncludes("display");
	$Display=new Display();
	$smarty->assign("gameList",$Display->GameIPList(true));
	$GameCP->loadIncludes("ip");
	$IP=new IP();
	$fip=$IP->GetIP(@$_REQUEST['gmid'], @$_REQUEST['fmaxclients'], @$_REQUEST['location']);
	$smarty->assign("result", $fip);

	$locallist='';
	$result = sql_query("SELECT distinct(location) FROM servers ORDER BY 'location'") or die(mysql_error());
	while ($row = mysql_fetch_array($result)){ 
		$lname=$row['location'];
		if(!$lname) $lname="&nbsp;";
		$locallist.= "<option value=\"". $row['location'] ."\">". $lname."</option>"; 
	}

	$smarty->assign("locallist", $locallist);
	$smarty->display("tools/autoip.tpl");
}

if($mode == "submitsql"){
	$smarty->display("settings/sql.tpl");
	$qtype=explode(" ", $_POST['mysql_query']);
	$q=sql_query($safesql->query($_POST['mysql_query'], array()));

	if(strtolower($qtype[0]) == "select" || strtolower($qtype[0]) == "show" ){
		echo "<textarea style='width: 100%; height: 200px;'>";
		while($r = mysql_fetch_assoc($q)) print_r($r);
		echo "</textarea>";
	} else echo "Query executed.";
}

if($mode == "backupv2"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->Backup();
}

if($mode == "cleanup"){
	function totalRecords($table){
		$total=sql_query("SELECT count(*) FROM $table");
		$to=mysql_fetch_row($total);
		return number_format($to[0]);

	}
	if(isset($_REQUEST['action'])){
		switch($_REQUEST['action']){
			case "cache":
				$GameCP->loadIncludes("panel");
				$Panel=new Panel();
				$Panel->RemoveCache();
			break;

			case 'eventlogs':
				sql_query("TRUNCATE eventlogs;");
			break;

			case 'logintrys':
				sql_query("TRUNCATE logintrys;");
			break;
		}
	}
	$smarty->assign("logintrys", totalRecords('logintrys'));
	$smarty->assign("eventlogs", totalRecords('eventlogs'));
	$smarty->display("tools/cleanup.tpl");
}

if($mode == "run_optimize") {
	if(DEMO =="yes"){
		echo "Demo restricted."; 
	} else {
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$Panel->Optimize();

		$cleaned=array();
		$cleanq=sql_query("SELECT * FROM settings");
		while($cl = mysql_fetch_array($cleanq)){
			if(!in_array($cl['name'], $cleaned)){
				$cleaned[$cl['name']]=$cl['name'];
			} else {
				sql_query($safesql->query("DELETE FROM settings WHERE name='%s' AND value='%s' LIMIT 1;", array($cl['name'],$cl['value'] )));
				echo "Removed duplicated variable: ". $cl['name'] ."<br>";
			}
		}

		$smarty->assign("result", "Optimization completed, please wait before you optimize again.");
	}
	$smarty->display("settings/optimize.tpl");
}

if($mode == "checkport"){
	$port=$GameCP->whitelist($_REQUEST['fport'], "int");
	$sql="(port='$port' OR queryport='$port')";
	$portCheck = sql_query("SELECT * FROM usergames WHERE $sql;") or die(mysql_error());
	$rows=array();
	while($row = mysql_fetch_assoc($portCheck)) $rows[]=$row;

	$smarty->assign("rows", $rows);
	$smarty->assign("port", $port);
	$smarty->display("tools/portcheck.tpl");
}

require_once(path.'/includes/core/editable/footer.inc.php');

?>