<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/

if (isset($_REQUEST["mode"]) && ($_REQUEST["mode"] == "download" || $_REQUEST["mode"] == "run")) $noheader=true;

require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');

$GameCP->CheckPermissions('update');

$smarty->assign('page_title', $LNG_UPDATE_GAMECP);

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();

// Perform update actions!
if (@$_REQUEST["do_update"] == "1" && DEMO != "yes") {
	$smarty->display("updater/doupdate.tpl");

}elseif (isset($_REQUEST["mode"]) && $_REQUEST["mode"] == "run" && DEMO != "yes") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$res=$Panel->Upgrade(@$_REQUEST["ignoreerrors"]);
	if($res != "upgraded")echo $res;
	exit;
}elseif (isset($_REQUEST["mode"]) && $_REQUEST["mode"] == "updatecomplete") {
		$smarty->display("updater/updatecomplete.tpl");
}elseif (isset($_REQUEST["mode"]) && $_REQUEST["mode"] == "download") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	if(!$Panel->DownloadBackup()) $Panel->ErrorHeader("Unable to download backup.");
	exit;
} else {


	$GameCP->loadIncludes("panel");
	$Panel=new Panel();


	// Get latest version information
	$bleeding_ver = $Panel->GetLatestGCPDevBuild();

	$gv=str_replace(".", "", $gcpVersion);
	$lv=str_replace(".", "", $bleeding_ver["Version"]);
	$versionDiff=$lv-$gv;
	$update_comments = $Panel->GetLatestGCPDevBuildComments($versionDiff);


	$update_version_date = $bleeding_ver["BuildTimestamp"];
	
	// Version status checks
	if (preg_match("/.dev/i", $gcpVersion)) {
		$update_avail=false;
		
	} else if(version_compare($bleeding_ver["Version"], $gcpVersion, ">") == TRUE) {
		$update_avail=true;
		
	} else {
		$update_avail=false;
	}

	$GameCP->loadIncludes("backend");
	$Backend=new Backend();
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();

	$latest=$Panel->GetLatestGCPRemoteV();
	if($latest) $latest=unserialize($latest);

	$machineList=array();
	$machineLimited=sql_query($safesql->query("SELECT * FROM servers WHERE sid != '' AND active='1' ORDER BY `location` ASC", array()));
	while($row = mysql_fetch_array($machineLimited)){
		if($row['os'] == '1'){
			$latest=$latest['Windows Backend'];
		} else $latest=$latest['Linux Backend'];

		$result=trim($Backend->QueryResponse($row['sid'], '', "version:_:"));
		$res=explode(".", $result);
		if (is_array($res) && count($res) == 4){
			if($result < $latest){
				$row['update']=true;
				$row['version']=$result;
				$machineList[]=$row;
			}
		}
	} 
	$smarty->assign("machineList", $machineList);


	$smarty->assign("gcpVersion", $gcpVersion);
	$smarty->assign("bleeding_ver", $bleeding_ver["Version"]);
	$smarty->assign("update_version_date", $update_version_date);
	$smarty->assign("update_avail", $update_avail);

	
	$smarty->assign("update_comments", nl2br($update_comments));
	$smarty->display("updater/update.tpl");

}


require_once(path.'/includes/core/editable/footer.inc.php');

?>